(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[    192926,       4308]
NotebookOptionsPosition[    189586,       4195]
NotebookOutlinePosition[    190068,       4214]
CellTagsIndexPosition[    190025,       4211]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Workload: DML

Compare Sample Sets Statistical Analysis\
\>", "Title",
 CellChangeTimes->{{3.5303688333633947`*^9, 3.530368837704206*^9}, {
  3.58920804668637*^9, 3.589208062499321*^9}, {3.589208319935629*^9, 
  3.589208337540052*^9}, {3.5892085650982933`*^9, 3.589208565475779*^9}}],

Cell["\<\
version 1a, 26-Sep-2013
author: Craig Shallahamer, craig@orapub.com\
\>", "Text",
 CellChangeTimes->{{3.530374180214813*^9, 3.530374223504505*^9}, {
  3.589208065031522*^9, 3.5892080829739857`*^9}}],

Cell[CellGroupData[{

Cell["Introduction", "Subtitle",
 CellChangeTimes->{{3.530374242866493*^9, 3.530374244484584*^9}}],

Cell["\<\
It\[CloseCurlyQuote]s difficult for us humans to aborb and grasp more than \
just a few values. Statistics provides us with a way to grasp complexity by \
simplifying or abstracting. As Oracle performance specialist, we typically \
have a large number of numeric samples, comprising our sample set.

This notepad analyze two samples and then statisticall compares them.\
\>", "Text",
 CellChangeTimes->{{3.530368849609161*^9, 3.530368851374548*^9}, {
  3.530370187776986*^9, 3.530370232698889*^9}, {3.5303740416976213`*^9, 
  3.530374137913013*^9}, {3.589197070039434*^9, 3.5891970910170927`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sample values", "Subtitle",
 CellChangeTimes->{{3.5303742624633904`*^9, 3.530374264105083*^9}}],

Cell["\<\
Enter your sample values; seperated by commas and the entire set enclosed in \
braces. Usually you can simply copy and paste the values directly into the \
notebook; which usually removes any line feeds or returns.
It is common to not consider all sample vaues. Below you can specify \
threshholds for the minimum and maximum values to run through the analysis.\
\>", "Text",
 CellChangeTimes->{{3.530374267526122*^9, 3.5303743523403177`*^9}, {
  3.530454126353104*^9, 3.5304541854582357`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cutoffMin", "=", 
   RowBox[{"-", "1.0"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cutoffMax", "=", "9999.0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSysstat", "=", 
   RowBox[{"{", 
    RowBox[{
    "41.65", ",", "40.73", ",", "40.57", ",", "39.6", ",", "27.02", ",", 
     "38.99", ",", "40.22", ",", "39.88", ",", "40.25", ",", "39.28", ",", 
     "39.37", ",", "39.37", ",", "39.25", ",", "38.96", ",", "41.04", ",", 
     "36.95", ",", "39.28", ",", "39.7", ",", "38.35", ",", "40.01", ",", 
     "40.04", ",", "39.36", ",", "48.2", ",", "30.89", ",", "38.59", ",", 
     "38.7", ",", "39.63", ",", "39.2", ",", "39.25", ",", "39.13", ",", 
     "39.11"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleTimeModel", "=", 
   RowBox[{"{", 
    RowBox[{
    "46.552924", ",", "40.376861", ",", "41.21473", ",", "39.359013", ",", 
     "38.088207", ",", "41.341715", ",", "39.406006", ",", "41.275724", ",", 
     "38.552138", ",", "42.876479", ",", "40.880783", ",", "41.875634", ",", 
     "41.963621", ",", "41.106746", ",", "39.38401", ",", "40.555835", ",", 
     "42.47654", ",", "39.368012", ",", "44.216276", ",", "42.22758", ",", 
     "45.505079", ",", "42.361557", ",", "41.600671", ",", "42.500536", ",", 
     "38.759109", ",", "40.581829", ",", "40.208887", ",", "42.362558", ",", 
     "39.478001", ",", "42.066601", ",", "40.061909"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetName1", "=", "\"\<Sysstat\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetName2", "=", "\"\<Time Model\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetRaw1", "=", "sampleSysstat"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetRaw2", "=", "sampleTimeModel"}], ";"}]}], "Input",
 CellChangeTimes->{{3.530368865010776*^9, 3.530368867417789*^9}, {
   3.5303689610885572`*^9, 3.530368963522463*^9}, 3.53036900548626*^9, {
   3.530369051420986*^9, 3.530369055243724*^9}, 3.5303714491074944`*^9, 
   3.5303935569531603`*^9, 3.530393588071438*^9, 3.530395180906042*^9, {
   3.530395563209477*^9, 3.530395567665958*^9}, {3.53039594405702*^9, 
   3.530395970436448*^9}, {3.53039607694536*^9, 3.530396146173196*^9}, {
   3.5303962265654697`*^9, 3.530396276110527*^9}, {3.530454018294681*^9, 
   3.5304540216285553`*^9}, {3.5304540980484447`*^9, 
   3.5304541088959084`*^9}, {3.530455451196604*^9, 3.530455451340207*^9}, {
   3.530469015209696*^9, 3.530469015650317*^9}, {3.530469268622115*^9, 
   3.530469268961523*^9}, {3.530469420949239*^9, 3.5304694211293507`*^9}, {
   3.530469546115999*^9, 3.530469546306059*^9}, {3.536336607077544*^9, 
   3.536336646173242*^9}, {3.536337012448007*^9, 3.536337013976362*^9}, {
   3.536337083468281*^9, 3.53633711309508*^9}, {3.536337279867556*^9, 
   3.536337282289822*^9}, {3.536337529501505*^9, 3.53633755196574*^9}, {
   3.5363376242524033`*^9, 3.536337634992538*^9}, {3.536342543724098*^9, 
   3.536342545446476*^9}, {3.536342651050959*^9, 3.53634265379499*^9}, {
   3.536342820072816*^9, 3.536342820372504*^9}, {3.536347444335575*^9, 
   3.536347526036746*^9}, {3.554639963802973*^9, 3.554639974880636*^9}, {
   3.589197097899551*^9, 3.589197108699297*^9}, {3.589204287151061*^9, 
   3.589204342261038*^9}, {3.5892044312058887`*^9, 3.58920446620074*^9}, {
   3.589204521778823*^9, 3.589204564969947*^9}, {3.589204969473914*^9, 
   3.589204970399848*^9}, {3.589205297076652*^9, 3.5892053183576202`*^9}, {
   3.589208281199692*^9, 3.589208306341981*^9}, {3.589208534256229*^9, 
   3.5892085595915813`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic Numeric Statistics", "Subtitle",
 CellChangeTimes->{{3.5303944048152018`*^9, 3.5303944108075037`*^9}}],

Cell[TextData[{
 "The basic numeric statistics shown are:\n\n",
 StyleBox["First five values",
  FontWeight->"Bold"],
 " simply lists the first five values of your sample set. Use this to check \
the data being used is what you think.\n",
 StyleBox["Number of samples ",
  FontWeight->"Bold"],
 "is in fact the number of samples. Use this to check the data has been \
entered correctly.\n",
 StyleBox["Average",
  FontWeight->"Bold"],
 " is the statistical mean.\n",
 StyleBox["Median",
  FontWeight->"Bold"],
 " is the middle value after all the values are sorted. This is also the \
50-percentile value.\n",
 StyleBox["Standard deviation",
  FontWeight->"Bold"],
 " is a measure of dispersion and is particularly valuable when the \
distribution is normal.\n",
 StyleBox["P-Value",
  FontWeight->"Bold"],
 " is a measure of contrast. In this instance, we are constrasting the sample \
set to the normal distribution. Loosely speaking, if the P-Value is greater \
than 0.05 then our sample set is likely to be normally distributed.\n\nSample \
Set #1"
}], "Text",
 CellChangeTimes->{{3.530394428636175*^9, 3.530394432641831*^9}, {
  3.589204580775587*^9, 3.589204586298441*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"sampleSetGood1", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetBad1", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw1", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[LessEqual]", "cutoffMax"}], 
          ")"}], "&&", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw1", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[GreaterEqual]", "cutoffMin"}], 
          ")"}]}], ")"}], ",", "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetGood1", ",", 
         RowBox[{"sampleSetRaw1", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetBad1", ",", 
         RowBox[{"sampleSetRaw1", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}]}], 
      "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "sampleSetRaw1", "]"}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countRaw", "=", 
   RowBox[{"Length", "[", "sampleSetRaw1", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countGood", "=", 
   RowBox[{"Length", "[", "sampleSetGood1", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"countBad", "=", 
    RowBox[{"Length", "[", "sampleSetBad1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveRaw", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetRaw1", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveGood", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetGood1", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstFiveBad", "=", 
    RowBox[{"Take", "[", 
     RowBox[{"sampleSetBad1", ",", "5"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"avg", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Mean", "[", "sampleSetGood1", "]"}], "]"}], ",", "0.00010"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"med", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Median", "[", "sampleSetGood1", "]"}], "]"}], ",", "0.00010"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"std", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"StandardDeviation", "[", "sampleSetGood1", "]"}], "]"}], ",", 
     "0.0010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pValue", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"DistributionFitTest", "[", "sampleSetGood1", "]"}], "]"}], ",",
      "0.0000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct90", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood1", ",", "0.90"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct95", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood1", ",", "0.95"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct99", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood1", ",", "0.99"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"maxV", "=", 
    RowBox[{"Max", "[", "sampleSetGood1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Statistics for Sample Set : \>\"", "<>", " ", "sampleSetName1", 
       "<>", "\"\<\\n\>\""}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of total samples\>\"", ",", "countRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of good samples\>\"", ",", "countGood"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of bad samples\>\"", ",", "countBad"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five raw samples\>\"", ",", "firstFiveRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five good samples\>\"", ",", "firstFiveGood"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five bad samples\>\"", ",", "firstFiveBad"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Good Sample Details\>\"", ",", "\"\<---\>\""}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Average\>\"", ",", "avg"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Median (50%-tile)\>\"", ",", "med"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Maximum\>\"", ",", "maxV"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Percentiles (90,95,99)\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"pct90", ",", "pct95", ",", "pct99"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Standard deviation\>\"", ",", "std"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  P-Value\>\"", ",", "pValue"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Alignment", "\[Rule]", 
      RowBox[{"{", "Left", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "None"}]}], "}"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.530368968593367*^9, 3.530368989268654*^9}, {
   3.5303690965356617`*^9, 3.530369118240787*^9}, {3.530369171410687*^9, 
   3.530369303558567*^9}, {3.5303693351682587`*^9, 3.530369427422378*^9}, {
   3.530369480374955*^9, 3.530369533827389*^9}, {3.5303695650243883`*^9, 
   3.530369579388669*^9}, {3.530369631285817*^9, 3.530369645933391*^9}, {
   3.5303696896422977`*^9, 3.530369697771058*^9}, {3.5303698401340857`*^9, 
   3.5303698459914103`*^9}, 3.530370326490252*^9, {3.530370541055084*^9, 
   3.530370549806651*^9}, {3.5303707096253843`*^9, 3.53037072436871*^9}, {
   3.530370842710359*^9, 3.53037084944149*^9}, {3.530370926582889*^9, 
   3.530370935884305*^9}, {3.530370995403738*^9, 3.530371021568015*^9}, {
   3.5303711315654488`*^9, 3.530371144348104*^9}, {3.530371233252054*^9, 
   3.530371273780658*^9}, {3.5303713101522007`*^9, 3.530371381300761*^9}, {
   3.5303716525945873`*^9, 3.53037169323724*^9}, {3.530371769719269*^9, 
   3.530371781099001*^9}, {3.530371832466179*^9, 3.5303718351591873`*^9}, {
   3.5303936674882107`*^9, 3.53039369987022*^9}, {3.5303937319628277`*^9, 
   3.530393732302782*^9}, {3.530393990173481*^9, 3.5303940515857983`*^9}, {
   3.5303944806938047`*^9, 3.5303944813726587`*^9}, {3.530394513548739*^9, 
   3.530394513933091*^9}, {3.530395584184815*^9, 3.530395665139804*^9}, {
   3.53039573123534*^9, 3.530395770072953*^9}, {3.530395866646319*^9, 
   3.530395866732829*^9}, {3.530395977045204*^9, 3.530395977999033*^9}, 
   3.530396011906796*^9, {3.5303961568553247`*^9, 3.530396185139888*^9}, {
   3.530396295140654*^9, 3.530396297581646*^9}, {3.530396342740769*^9, 
   3.530396401087904*^9}, {3.530396447078868*^9, 3.530396508850835*^9}, {
   3.5303965432221127`*^9, 3.5303967135104313`*^9}, {3.530453988732895*^9, 
   3.530454012634718*^9}, {3.5304540493515*^9, 3.530454071670485*^9}, {
   3.530454118686286*^9, 3.530454120084098*^9}, {3.5304549689805393`*^9, 
   3.530454973039502*^9}, {3.5304551150546083`*^9, 3.530455381038809*^9}, 
   3.5304554947173357`*^9, {3.530469054226564*^9, 3.530469095504678*^9}, {
   3.530469132177784*^9, 3.530469169752913*^9}, {3.589204591684404*^9, 
   3.589204640892511*^9}, {3.589204703982668*^9, 3.58920472726952*^9}, {
   3.5892047706716557`*^9, 3.589204803477298*^9}, {3.589205455713531*^9, 
   3.589205471673032*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Take", "::", "take"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Cannot take positions \[NoBreak]\\!\\(1\\)\[NoBreak] \
through \[NoBreak]\\!\\(5\\)\[NoBreak] in \[NoBreak]\\!\\({}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Take/take\\\", \
ButtonNote -> \\\"Take::take\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.5892047291486473`*^9, {3.589204790418169*^9, 3.5892048045433617`*^9}, 
   3.5892054739477663`*^9, 3.589208119639461*^9, 3.589208394295919*^9, 
   3.58920858801693*^9, 3.590143671774199*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Statistics for Sample Set : Sysstat\\n\"\>", ""},
    {"\<\"Number of total samples\"\>", "31"},
    {"\<\"Number of good samples\"\>", "31"},
    {"\<\"Number of bad samples\"\>", "0"},
    {"\<\"First five raw samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "41.65`", ",", "40.73`", ",", "40.57`", ",", "39.6`", ",", "27.02`"}], 
      "}"}]},
    {"\<\"First five good samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "41.65`", ",", "40.73`", ",", "40.57`", ",", "39.6`", ",", "27.02`"}], 
      "}"}]},
    {"\<\"First five bad samples\"\>", 
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "5"}], "]"}]},
    {"\<\"Good Sample Details\"\>", "\<\"---\"\>"},
    {"\<\"  Average\"\>", "39.1152`"},
    {"\<\"  Median (50%-tile)\"\>", "39.36`"},
    {"\<\"  Maximum\"\>", "48.2`"},
    {"\<\"  Percentiles (90,95,99)\"\>", 
     RowBox[{"{", 
      RowBox[{
      "40.730000000000004`", ",", "41.650000000000006`", ",", "48.2`"}], 
      "}"}]},
    {"\<\"  Standard deviation\"\>", "3.281`"},
    {"\<\"  P-Value\"\>", "0.`"}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> None, "Rows" -> None},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.5303957883159657`*^9, 3.530395873878767*^9, {3.53039598031126*^9, 
   3.530395989224454*^9}, {3.530396163546875*^9, 3.5303961872839327`*^9}, 
   3.530396313304497*^9, {3.53039649481763*^9, 3.530396510875143*^9}, 
   3.5304554272825623`*^9, 3.530455466660076*^9, 3.530455497552189*^9, 
   3.530469028806366*^9, {3.530469060709507*^9, 3.530469096893461*^9}, {
   3.530469153086173*^9, 3.530469171493932*^9}, 3.530469231345664*^9, 
   3.530469273461467*^9, 3.530469426901936*^9, 3.530469552359798*^9, 
   3.530470236790164*^9, 3.536334923158784*^9, 3.5363357149452477`*^9, {
   3.536336624039689*^9, 3.536336650435875*^9}, 3.536337022777419*^9, {
   3.5363370987121067`*^9, 3.536337117024104*^9}, 3.536337287258542*^9, 
   3.536337556724328*^9, 3.536337644127635*^9, 3.5363390853670797`*^9, 
   3.536339943574079*^9, 3.5363411707911367`*^9, 3.5363412270341997`*^9, 
   3.5363414456773653`*^9, 3.5363419606031713`*^9, 3.5363420236911917`*^9, 
   3.536342550277603*^9, 3.536342657424079*^9, 3.53634282443299*^9, 
   3.554639986040378*^9, 3.5546400537141542`*^9, 3.554640183673815*^9, {
   3.5892046928575487`*^9, 3.5892047291750727`*^9}, {3.5892047904579*^9, 
   3.58920480457402*^9}, 3.58920547398158*^9, 3.589208119779434*^9, 
   3.589208394654216*^9, 3.58920858812227*^9, 3.590143672033876*^9}]
}, Open  ]],

Cell["Sample Set #2", "Text",
 CellChangeTimes->{
  3.5303945570998573`*^9, {3.589204860147819*^9, 3.5892048626771383`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"sampleSetGood2", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetBad2", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[LessEqual]", "cutoffMax"}], 
          ")"}], "&&", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[GreaterEqual]", "cutoffMin"}], 
          ")"}]}], ")"}], ",", "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetGood2", ",", 
         RowBox[{"sampleSetRaw2", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetBad2", ",", 
         RowBox[{"sampleSetRaw2", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}]}], 
      "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "sampleSetRaw2", "]"}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countRaw", "=", 
   RowBox[{"Length", "[", "sampleSetRaw2", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countGood", "=", 
   RowBox[{"Length", "[", "sampleSetGood2", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"countBad", "=", 
    RowBox[{"Length", "[", "sampleSetBad2", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveRaw", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetRaw2", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveGood", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetGood2", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstFiveBad", "=", 
    RowBox[{"Take", "[", 
     RowBox[{"sampleSetBad2", ",", "5"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"avg", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Mean", "[", "sampleSetGood2", "]"}], "]"}], ",", "0.00010"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"med", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Median", "[", "sampleSetGood2", "]"}], "]"}], ",", "0.00010"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"std", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"StandardDeviation", "[", "sampleSetGood2", "]"}], "]"}], ",", 
     "0.0010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pValue", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"DistributionFitTest", "[", "sampleSetGood2", "]"}], "]"}], ",",
      "0.0000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct90", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood2", ",", "0.90"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct95", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood2", ",", "0.95"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct99", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood2", ",", "0.99"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"maxV", "=", 
    RowBox[{"Max", "[", "sampleSetGood2", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Statistics for Sample Set : \>\"", "<>", " ", "sampleSetName2", 
       "<>", "\"\<\\n\>\""}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of total samples\>\"", ",", "countRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of good samples\>\"", ",", "countGood"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of bad samples\>\"", ",", "countBad"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five raw samples\>\"", ",", "firstFiveRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five good samples\>\"", ",", "firstFiveGood"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five bad samples\>\"", ",", "firstFiveBad"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Good Sample Details\>\"", ",", "\"\<---\>\""}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Average\>\"", ",", "avg"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Median (50%-tile)\>\"", ",", "med"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Maximum\>\"", ",", "maxV"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Percentiles (90,95,99)\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"pct90", ",", "pct95", ",", "pct99"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Standard deviation\>\"", ",", "std"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  P-Value\>\"", ",", "pValue"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Alignment", "\[Rule]", 
      RowBox[{"{", "Left", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "None"}]}], "}"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.530368968593367*^9, 3.530368989268654*^9}, {
   3.5303690965356617`*^9, 3.530369118240787*^9}, {3.530369171410687*^9, 
   3.530369303558567*^9}, {3.5303693351682587`*^9, 3.530369427422378*^9}, {
   3.530369480374955*^9, 3.530369533827389*^9}, {3.5303695650243883`*^9, 
   3.530369579388669*^9}, {3.530369631285817*^9, 3.530369645933391*^9}, {
   3.5303696896422977`*^9, 3.530369697771058*^9}, {3.5303698401340857`*^9, 
   3.5303698459914103`*^9}, 3.530370326490252*^9, {3.530370541055084*^9, 
   3.530370549806651*^9}, {3.5303707096253843`*^9, 3.53037072436871*^9}, {
   3.530370842710359*^9, 3.53037084944149*^9}, {3.530370926582889*^9, 
   3.530370935884305*^9}, {3.530370995403738*^9, 3.530371021568015*^9}, {
   3.5303711315654488`*^9, 3.530371144348104*^9}, {3.530371233252054*^9, 
   3.530371273780658*^9}, {3.5303713101522007`*^9, 3.530371381300761*^9}, {
   3.5303716525945873`*^9, 3.53037169323724*^9}, {3.530371769719269*^9, 
   3.530371781099001*^9}, {3.530371832466179*^9, 3.5303718351591873`*^9}, {
   3.5303936674882107`*^9, 3.53039369987022*^9}, {3.5303937319628277`*^9, 
   3.530393732302782*^9}, {3.530393990173481*^9, 3.5303940515857983`*^9}, {
   3.5303944806938047`*^9, 3.5303944813726587`*^9}, {3.530394513548739*^9, 
   3.530394513933091*^9}, {3.530395584184815*^9, 3.530395665139804*^9}, {
   3.53039573123534*^9, 3.530395770072953*^9}, {3.530395866646319*^9, 
   3.530395866732829*^9}, {3.530395977045204*^9, 3.530395977999033*^9}, 
   3.530396011906796*^9, {3.5303961568553247`*^9, 3.530396185139888*^9}, {
   3.530396295140654*^9, 3.530396297581646*^9}, {3.530396342740769*^9, 
   3.530396401087904*^9}, {3.530396447078868*^9, 3.530396508850835*^9}, {
   3.5303965432221127`*^9, 3.5303967135104313`*^9}, {3.530453988732895*^9, 
   3.530454012634718*^9}, {3.5304540493515*^9, 3.530454071670485*^9}, {
   3.530454118686286*^9, 3.530454120084098*^9}, {3.5304549689805393`*^9, 
   3.530454973039502*^9}, {3.5304551150546083`*^9, 3.530455381038809*^9}, 
   3.5304554947173357`*^9, {3.530469054226564*^9, 3.530469095504678*^9}, {
   3.530469132177784*^9, 3.530469169752913*^9}, {3.589204591684404*^9, 
   3.589204640892511*^9}, {3.589204703982668*^9, 3.58920472726952*^9}, {
   3.5892047706716557`*^9, 3.589204803477298*^9}, {3.589204870548375*^9, 
   3.589204940006817*^9}, {3.589205330358691*^9, 3.589205384684655*^9}, {
   3.589205417371266*^9, 3.589205440519182*^9}, {3.589205484169776*^9, 
   3.589205484247561*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Take", "::", "take"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Cannot take positions \[NoBreak]\\!\\(1\\)\[NoBreak] \
through \[NoBreak]\\!\\(5\\)\[NoBreak] in \[NoBreak]\\!\\({}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Take/take\\\", \
ButtonNote -> \\\"Take::take\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.5892049419449463`*^9, 3.589204978424362*^9, {3.589205343560355*^9, 
   3.5892053616873007`*^9}, {3.5892054218515043`*^9, 3.589205437780459*^9}, 
   3.589205489145903*^9, 3.5892081198103733`*^9, 3.589208394691865*^9, 
   3.589208588163897*^9, 3.590143672084152*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Statistics for Sample Set : Time Model\\n\"\>", ""},
    {"\<\"Number of total samples\"\>", "31"},
    {"\<\"Number of good samples\"\>", "31"},
    {"\<\"Number of bad samples\"\>", "0"},
    {"\<\"First five raw samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "46.552924`", ",", "40.376861`", ",", "41.21473`", ",", "39.359013`", 
       ",", "38.088207`"}], "}"}]},
    {"\<\"First five good samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "46.552924`", ",", "40.376861`", ",", "41.21473`", ",", "39.359013`", 
       ",", "38.088207`"}], "}"}]},
    {"\<\"First five bad samples\"\>", 
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "5"}], "]"}]},
    {"\<\"Good Sample Details\"\>", "\<\"---\"\>"},
    {"\<\"  Average\"\>", "41.2447`"},
    {"\<\"  Median (50%-tile)\"\>", "41.2147`"},
    {"\<\"  Maximum\"\>", "46.552924`"},
    {"\<\"  Percentiles (90,95,99)\"\>", 
     RowBox[{"{", 
      RowBox[{"42.87648`", ",", "45.50508000000001`", ",", "46.55292`"}], 
      "}"}]},
    {"\<\"  Standard deviation\"\>", "1.922`"},
    {"\<\"  P-Value\"\>", "0.469109`"}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> None, "Rows" -> None},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.589204942302164*^9, 3.589204978468814*^9, {3.589205343595798*^9, 
   3.589205361737233*^9}, {3.589205421895628*^9, 3.589205437785314*^9}, 
   3.5892054891832647`*^9, 3.589208119822625*^9, 3.589208394714353*^9, 
   3.5892085882003107`*^9, 3.590143672085598*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic Visual \
\[OpenCurlyDoubleQuote]Statistics\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.530372627959633*^9, 3.5303726359771557`*^9}}],

Cell["\<\
Histograms are a fantastic way to get a quick grasp of a large number of \
samples. Below are a select number of histogram, each focusing on a specific \
numeric quality.\
\>", "Text",
 CellChangeTimes->{{3.530372643432928*^9, 3.530372683969884*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"hLabel", "=", "\"\<Sample Values\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vLabel", "=", "\"\<Occurrences\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStnd1", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"sampleSetGood1", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1"}]}], 
     ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStndSmooth1", "=", 
   RowBox[{"SmoothHistogram", "[", 
    RowBox[{"sampleSetGood1", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Smoothed Histogram of Sample Values : \>\"", "<>", 
       "sampleSetName1", "<>", 
       "\"\<\\n(Probability Distribution Function)\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<\>\""}], "}"}]}]}], "]"}]}], ";", 
  RowBox[{"histCC1", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood1", ",", "Automatic", ",", "\"\<CumulativeCount\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1", "<>", 
       "\"\<\\nCumulative Count\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histProb1", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood1", ",", "Automatic", ",", "\"\<Probability\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1", "<>", 
       "\"\<\\nProbability\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<% Occurs\>\""}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"histStndSmallBin1", "=", 
    RowBox[{"Histogram", "[", 
     RowBox[{"sampleSetGood1", ",", 
      RowBox[{"{", "0.250", "}"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", 
       RowBox[{
       "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1", "<>", 
        "\"\<\\nbin size 0.250\>\""}]}], ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStnd2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"sampleSetGood2", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2"}]}], 
     ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStndSmooth2", "=", 
   RowBox[{"SmoothHistogram", "[", 
    RowBox[{"sampleSetGood2", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Smoothed Histogram of Sample Values : \>\"", "<>", 
       "sampleSetName1", "<>", 
       "\"\<\\n(Probability Distribution Function)\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<\>\""}], "}"}]}]}], "]"}]}], ";", 
  RowBox[{"histCC2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood2", ",", "Automatic", ",", "\"\<CumulativeCount\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2", "<>", 
       "\"\<\\nCumulative Count\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histProb2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood2", ",", "Automatic", ",", "\"\<Probability\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2", "<>", 
       "\"\<\\nProbability\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<% Occurs\>\""}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStndSmallBin2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"sampleSetGood2", ",", 
     RowBox[{"{", "0.250", "}"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2", "<>", 
       "\"\<\\nnbin size 0.250\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\< \>\"", "]"}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.530394715762684*^9, 3.530394723135069*^9}, 
   3.530394760001342*^9, {3.530455400611494*^9, 3.530455412231533*^9}, {
   3.589205017674301*^9, 3.58920510976562*^9}, {3.5892051473945103`*^9, 
   3.589205191596965*^9}, {3.589205236230096*^9, 3.589205287776355*^9}, {
   3.589205496523555*^9, 3.589205515386764*^9}, {3.589205545391057*^9, 
   3.589205577013954*^9}, {3.589205609269073*^9, 3.5892056985591383`*^9}, {
   3.5892057445963907`*^9, 3.5892057486441298`*^9}, {3.589208146714439*^9, 
   3.589208146802874*^9}}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{
  3.5892055784871073`*^9, 3.589205707787979*^9, 3.589205750492517*^9, {
   3.58920812067819*^9, 3.5892081481298227`*^9}, 3.5892083955250607`*^9, 
   3.5892085890504017`*^9, 3.590143673135977*^9}]
}, Open  ]],

Cell["\<\
Below is a standard histogram, where each sample is shown as a single block \
placed on the vertical axis based on its value. Common sample values (i.e., \
blocks) show as high stacks.\
\>", "Text",
 CellChangeTimes->{3.5303945570998573`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{"histStnd1", "\[IndentingNewLine]", "histStnd2"}], "Input",
 CellChangeTimes->{{3.530369545506777*^9, 3.530369547560232*^9}, {
  3.530369666836165*^9, 3.530369669231763*^9}, {3.5303699085772467`*^9, 
  3.530369930152483*^9}, {3.589205116907014*^9, 3.589205121494775*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{25., 0}, {30., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{16.00888854980468, 99.63426534349094}, {
         124.2468924502039, 136.4}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{30., 0}, {35., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{99.27426534349092, 182.89964213717712`}, {
         124.2468924502039, 136.4}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{35., 0}, {40., 20}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{182.5396421371771, 
         266.1650189308633}, {-99.8221509959221, 136.4}}],
       StatusArea[#, 20]& ,
       TagBoxNote->"20"],
      StyleBox["20", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[20, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40., 0}, {45., 8}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{265.8050189308633, 349.4303957245495}, {
         41.695139601631155`, 136.4}}],
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{45., 0}, {50., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{349.0703957245495, 432.6957725182357}, {
         124.2468924502039, 136.4}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{25., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{675., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\"", TraditionalForm],
  PlotRange->{{25., 50.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.5303695488181334`*^9, 3.53036958415487*^9}, {
   3.530369650023057*^9, 3.530369670205143*^9}, 3.53036970302028*^9, 
   3.530369849607541*^9, {3.530369912051992*^9, 3.5303699314038763`*^9}, 
   3.530370440989561*^9, 3.530370970288966*^9, 3.5303711932451*^9, 
   3.530371282079977*^9, 3.530371366848496*^9, 3.530371464003294*^9, 
   3.530371828554619*^9, 3.530372610876151*^9, 3.530393601714321*^9, 
   3.530394130294532*^9, {3.530394496126593*^9, 3.530394522101289*^9}, 
   3.530394586856161*^9, 3.530395208041752*^9, 3.5303963140372553`*^9, 
   3.530455427899746*^9, 3.530455467257689*^9, {3.530469222935663*^9, 
   3.530469237842341*^9}, 3.53046928026694*^9, 3.530469429880677*^9, 
   3.530469559271694*^9, 3.5304702441973963`*^9, 3.536334926609531*^9, 
   3.5363357185955467`*^9, {3.536336625347118*^9, 3.536336650895856*^9}, 
   3.536337023128414*^9, {3.53633709915998*^9, 3.536337117482912*^9}, 
   3.536337288435781*^9, 3.5363375579023848`*^9, 3.536337644670939*^9, 
   3.536339085895953*^9, 3.536339944228245*^9, 3.53634117179491*^9, 
   3.536341227911189*^9, 3.536341446622402*^9, 3.536341961592246*^9, 
   3.53634202430599*^9, 3.5363425511443777`*^9, 3.536342659031567*^9, 
   3.536342825511848*^9, 3.554640053897842*^9, 3.554640184079294*^9, 
   3.589205122801214*^9, 3.589205196948225*^9, 3.589205244525977*^9, 
   3.5892055246585827`*^9, 3.589205580866781*^9, 3.589205712085713*^9, 
   3.589208120825781*^9, 3.5892081544701767`*^9, 3.5892083956646023`*^9, 
   3.589208589200162*^9, 3.590143673320957*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38., 0}, {40., 8}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{16.00888854980468, 
         99.63426534349077}, {-9.10593907441364, 136.4}}],
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40., 0}, {42., 13}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{99.27426534349075, 
         182.89964213717707`}, {-99.82215099592216, 136.4}}],
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{42., 0}, {44., 7}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{182.53964213717705`, 266.16501893086314`}, {
         9.037303309888074, 136.4}}],
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{44., 0}, {46., 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{265.8050189308631, 349.43039572454944`}, {
         99.7535152313966, 136.4}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{46., 0}, {48., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{349.0703957245494, 432.69577251823574`}, {
         117.8967576156983, 136.4}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{38., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{675., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\"", TraditionalForm],
  PlotRange->{{38., 48.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.5303695488181334`*^9, 3.53036958415487*^9}, {
   3.530369650023057*^9, 3.530369670205143*^9}, 3.53036970302028*^9, 
   3.530369849607541*^9, {3.530369912051992*^9, 3.5303699314038763`*^9}, 
   3.530370440989561*^9, 3.530370970288966*^9, 3.5303711932451*^9, 
   3.530371282079977*^9, 3.530371366848496*^9, 3.530371464003294*^9, 
   3.530371828554619*^9, 3.530372610876151*^9, 3.530393601714321*^9, 
   3.530394130294532*^9, {3.530394496126593*^9, 3.530394522101289*^9}, 
   3.530394586856161*^9, 3.530395208041752*^9, 3.5303963140372553`*^9, 
   3.530455427899746*^9, 3.530455467257689*^9, {3.530469222935663*^9, 
   3.530469237842341*^9}, 3.53046928026694*^9, 3.530469429880677*^9, 
   3.530469559271694*^9, 3.5304702441973963`*^9, 3.536334926609531*^9, 
   3.5363357185955467`*^9, {3.536336625347118*^9, 3.536336650895856*^9}, 
   3.536337023128414*^9, {3.53633709915998*^9, 3.536337117482912*^9}, 
   3.536337288435781*^9, 3.5363375579023848`*^9, 3.536337644670939*^9, 
   3.536339085895953*^9, 3.536339944228245*^9, 3.53634117179491*^9, 
   3.536341227911189*^9, 3.536341446622402*^9, 3.536341961592246*^9, 
   3.53634202430599*^9, 3.5363425511443777`*^9, 3.536342659031567*^9, 
   3.536342825511848*^9, 3.554640053897842*^9, 3.554640184079294*^9, 
   3.589205122801214*^9, 3.589205196948225*^9, 3.589205244525977*^9, 
   3.5892055246585827`*^9, 3.589205580866781*^9, 3.589205712085713*^9, 
   3.589208120825781*^9, 3.5892081544701767`*^9, 3.5892083956646023`*^9, 
   3.589208589200162*^9, 3.590143673384356*^9}]
}, Open  ]],

Cell["\<\
Below is known as a Cummlative Count histogram. Each vertical bar represents \
the total number of samples values that are less than or equal to the bin.\
\>", "Text",
 CellChangeTimes->{{3.530372768356407*^9, 3.530372776770891*^9}, {
  3.530372809849923*^9, 3.530372896754038*^9}, {3.5303730283352537`*^9, 
  3.530373029808041*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histCC1", "\[IndentingNewLine]", "histCC2"}], "Input",
 CellChangeTimes->{{3.530371170718999*^9, 3.530371171449521*^9}, {
  3.589205719276526*^9, 3.5892057223249407`*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{25., 0}, {30., 1.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{16.00888854980468, 99.35214289451136}, {
         133.45732273517248`, 141.4}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{30., 0}, {35., 2.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{98.99214289451135, 182.3353972392179}, {
         125.87464547034499`, 141.4}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{35., 0}, {40., 22.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{181.9753972392179, 
         265.3186515839246}, {-25.778899826205276`, 141.4}}],
       StatusArea[#, 22]& ,
       TagBoxNote->"22"],
      StyleBox["22", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[22, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40., 0}, {45., 30.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{264.95865158392456`, 
         348.30190592863124`}, {-86.44031794482538, 141.4}}],
       StatusArea[#, 30]& ,
       TagBoxNote->"30"],
      StyleBox["30", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[30, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{45., 0}, {50., 31.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{347.94190592863123`, 
         431.2851602733378}, {-94.02299520965289, 141.4}}],
       StatusArea[#, 31]& ,
       TagBoxNote->"31"],
      StyleBox["31", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[31, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{25., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{673., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\\nCumulative Count\"", 
    TraditionalForm],
  PlotRange->{{25., 50.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.5303711933153677`*^9, 3.5303712821883*^9, 3.530371366930995*^9, 
   3.530371464213008*^9, 3.53037182877146*^9, 3.530372611088093*^9, 
   3.53039360178333*^9, 3.530394130363566*^9, {3.5303944961970673`*^9, 
   3.530394522169527*^9}, 3.530394586925064*^9, 3.5303952091265917`*^9, 
   3.5303963140990887`*^9, 3.530455427951482*^9, 3.5304554672995453`*^9, 
   3.5304692383686666`*^9, 3.530469280898362*^9, 3.5304694301425667`*^9, 
   3.5304695599081917`*^9, 3.530470244824375*^9, 3.53633492673665*^9, 
   3.5363357187274313`*^9, {3.536336625403529*^9, 3.5363366509613256`*^9}, 
   3.536337023178193*^9, {3.5363370992069607`*^9, 3.5363371175516*^9}, 
   3.5363372884879627`*^9, 3.536337557953179*^9, 3.536337644729342*^9, 
   3.5363390859477654`*^9, 3.536339944546894*^9, 3.536341172038474*^9, 
   3.536341227959819*^9, 3.536341446836018*^9, 3.536341961681848*^9, 
   3.53634202440347*^9, 3.536342551265297*^9, 3.536342659084442*^9, 
   3.5363428255720654`*^9, 3.554640053932543*^9, 3.554640184099517*^9, {
   3.589205725069447*^9, 3.589205754459869*^9}, 3.5892081208789263`*^9, 
   3.589208395723403*^9, 3.589208589276853*^9, 3.59014367342642*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38., 0}, {40., 8.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{16.00888854980468, 99.35214289451136}, {
         80.3785818813799, 141.4}}],
       StatusArea[#, 8]& ,
       TagBoxNote->"8"],
      StyleBox["8", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[8, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40., 0}, {42., 21.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{98.99214289451135, 
         182.33539723921803`}, {-18.196222561377766`, 141.4}}],
       StatusArea[#, 21]& ,
       TagBoxNote->"21"],
      StyleBox["21", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[21, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{42., 0}, {44., 28.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{181.975397239218, 
         265.31865158392446`}, {-71.27496341517036, 141.4}}],
       StatusArea[#, 28]& ,
       TagBoxNote->"28"],
      StyleBox["28", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[28, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{44., 0}, {46., 30.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{264.95865158392445`, 
         348.30190592863113`}, {-86.44031794482538, 141.4}}],
       StatusArea[#, 30]& ,
       TagBoxNote->"30"],
      StyleBox["30", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[30, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{46., 0}, {48., 31.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{347.9419059286311, 
         431.2851602733378}, {-94.02299520965289, 141.4}}],
       StatusArea[#, 31]& ,
       TagBoxNote->"31"],
      StyleBox["31", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[31, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{38., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{673., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\\nCumulative Count\"", 
    TraditionalForm],
  PlotRange->{{38., 48.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.5303711933153677`*^9, 3.5303712821883*^9, 3.530371366930995*^9, 
   3.530371464213008*^9, 3.53037182877146*^9, 3.530372611088093*^9, 
   3.53039360178333*^9, 3.530394130363566*^9, {3.5303944961970673`*^9, 
   3.530394522169527*^9}, 3.530394586925064*^9, 3.5303952091265917`*^9, 
   3.5303963140990887`*^9, 3.530455427951482*^9, 3.5304554672995453`*^9, 
   3.5304692383686666`*^9, 3.530469280898362*^9, 3.5304694301425667`*^9, 
   3.5304695599081917`*^9, 3.530470244824375*^9, 3.53633492673665*^9, 
   3.5363357187274313`*^9, {3.536336625403529*^9, 3.5363366509613256`*^9}, 
   3.536337023178193*^9, {3.5363370992069607`*^9, 3.5363371175516*^9}, 
   3.5363372884879627`*^9, 3.536337557953179*^9, 3.536337644729342*^9, 
   3.5363390859477654`*^9, 3.536339944546894*^9, 3.536341172038474*^9, 
   3.536341227959819*^9, 3.536341446836018*^9, 3.536341961681848*^9, 
   3.53634202440347*^9, 3.536342551265297*^9, 3.536342659084442*^9, 
   3.5363428255720654`*^9, 3.554640053932543*^9, 3.554640184099517*^9, {
   3.589205725069447*^9, 3.589205754459869*^9}, 3.5892081208789263`*^9, 
   3.589208395723403*^9, 3.589208589276853*^9, 3.5901436734451113`*^9}]
}, Open  ]],

Cell["\<\
Below is a Probability Historgram. It will visually look exactly like the \
standard histogram but the vertical axis is a percentage value. Each vertical \
bar\[CloseCurlyQuote]s height represents the percentage of values that is \
contains. In contrast, the standard histogram hight is the actual number of \
sample occurrences.\
\>", "Text",
 CellChangeTimes->{{3.530372915776453*^9, 3.530373034082033*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histProb1", "\[IndentingNewLine]", "histProb2"}], "Input",
 CellChangeTimes->{{3.530371174905854*^9, 3.5303711849954643`*^9}, {
  3.589205760372879*^9, 3.589205765341523*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{25., 0}, {30., 0.03225806451612903}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{12.397117919921811`, 96.87116814313606}, {
         131.12669246535455`, 143.4}}],
       StatusArea[#, 0.03225806451612903]& ,
       TagBoxNote->"0.03225806451612903"],
      StyleBox["0.03225806451612903`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.03225806451612903, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{30., 0}, {35., 0.03225806451612903}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{96.51116814313605, 180.98521836635035`}, {
         131.12669246535455`, 143.4}}],
       StatusArea[#, 0.03225806451612903]& ,
       TagBoxNote->"0.03225806451612903"],
      StyleBox["0.03225806451612903`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.03225806451612903, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{35., 0}, {40., 0.6451612903225806}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{180.62521836635034`, 
         265.0992685895646}, {-95.22615069290956, 143.4}}],
       StatusArea[#, 0.6451612903225806]& ,
       TagBoxNote->"0.6451612903225806"],
      StyleBox["0.6451612903225806`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.6451612903225806, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40., 0}, {45., 0.25806451612903225`}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{264.7392685895646, 349.21331881277894`}, {
         47.733539722836184`, 143.4}}],
       StatusArea[#, 0.25806451612903225`]& ,
       TagBoxNote->"0.25806451612903225"],
      StyleBox["0.25806451612903225`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.25806451612903225`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{45., 0}, {50., 0.03225806451612903}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{348.8533188127789, 433.3273690359932}, {
         131.12669246535455`, 143.4}}],
       StatusArea[#, 0.03225806451612903]& ,
       TagBoxNote->"0.03225806451612903"],
      StyleBox["0.03225806451612903`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.03225806451612903, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"% Occurs\"", TraditionalForm]},
  AxesOrigin->{25., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{676., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\\nProbability\"", TraditionalForm],
  
  PlotRange->{{25., 50.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.530371193382887*^9, 3.5303712822723207`*^9, 3.5303713670066147`*^9, 
   3.530371464412394*^9, 3.530371828964902*^9, 3.530372611269655*^9, 
   3.530393601844863*^9, 3.530394130424241*^9, {3.530394496259248*^9, 
   3.530394522230245*^9}, 3.5303945869998837`*^9, 3.5303952095236187`*^9, 
   3.5303963141520576`*^9, 3.5304554280200663`*^9, 3.530455467346095*^9, 
   3.5304692386248913`*^9, 3.5304692812452993`*^9, 3.530469430388815*^9, 
   3.5304695602145157`*^9, 3.530470245274753*^9, 3.536334926797206*^9, 
   3.5363357188421097`*^9, {3.536336625456748*^9, 3.536336651006628*^9}, 
   3.536337023227828*^9, {3.536337099256421*^9, 3.536337117594417*^9}, 
   3.5363372885357227`*^9, 3.5363375580025787`*^9, 3.536337644776417*^9, 
   3.536339085995132*^9, 3.536339944639868*^9, 3.536341172119947*^9, 
   3.5363412280149403`*^9, 3.53634144692865*^9, 3.536341961779797*^9, 
   3.536342024503587*^9, 3.536342551316553*^9, 3.536342659142679*^9, 
   3.536342825633093*^9, 3.554640053985256*^9, 3.554640184118108*^9, 
   3.589205766406526*^9, 3.589208120932848*^9, 3.589208395776359*^9, 
   3.5892085893442163`*^9, 3.590143673491888*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38., 0}, {40., 0.25806451612903225`}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{12.397117919921413`, 
         96.87116814313566}, {-3.585323503329022, 143.4}}],
       StatusArea[#, 0.25806451612903225`]& ,
       TagBoxNote->"0.25806451612903225"],
      StyleBox["0.25806451612903225`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.25806451612903225`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40., 0}, {42., 0.41935483870967744`}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{96.51116814313565, 
         180.9852183663499}, {-95.22615069290967, 143.4}}],
       StatusArea[#, 0.41935483870967744`]& ,
       TagBoxNote->"0.41935483870967744"],
      StyleBox["0.41935483870967744`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.41935483870967744`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{42., 0}, {44., 0.22580645161290322`}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{180.62521836634988`, 265.09926858956413`}, {
         14.74284193458712, 143.4}}],
       StatusArea[#, 0.22580645161290322`]& ,
       TagBoxNote->"0.22580645161290322"],
      StyleBox["0.22580645161290322`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.22580645161290322`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{44., 0}, {46., 0.06451612903225806}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{264.7392685895641, 349.21331881277837`}, {
         106.38366912416775`, 143.4}}],
       StatusArea[#, 0.06451612903225806]& ,
       TagBoxNote->"0.06451612903225806"],
      StyleBox["0.06451612903225806`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.06451612903225806, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{46., 0}, {48., 0.03225806451612903}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{348.85331881277835`, 433.32736903599283`}, {
         124.71183456208388`, 143.4}}],
       StatusArea[#, 0.03225806451612903]& ,
       TagBoxNote->"0.03225806451612903"],
      StyleBox["0.03225806451612903`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.03225806451612903, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"% Occurs\"", TraditionalForm]},
  AxesOrigin->{38., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{676., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\\nProbability\"", 
    TraditionalForm],
  PlotRange->{{38., 48.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.530371193382887*^9, 3.5303712822723207`*^9, 3.5303713670066147`*^9, 
   3.530371464412394*^9, 3.530371828964902*^9, 3.530372611269655*^9, 
   3.530393601844863*^9, 3.530394130424241*^9, {3.530394496259248*^9, 
   3.530394522230245*^9}, 3.5303945869998837`*^9, 3.5303952095236187`*^9, 
   3.5303963141520576`*^9, 3.5304554280200663`*^9, 3.530455467346095*^9, 
   3.5304692386248913`*^9, 3.5304692812452993`*^9, 3.530469430388815*^9, 
   3.5304695602145157`*^9, 3.530470245274753*^9, 3.536334926797206*^9, 
   3.5363357188421097`*^9, {3.536336625456748*^9, 3.536336651006628*^9}, 
   3.536337023227828*^9, {3.536337099256421*^9, 3.536337117594417*^9}, 
   3.5363372885357227`*^9, 3.5363375580025787`*^9, 3.536337644776417*^9, 
   3.536339085995132*^9, 3.536339944639868*^9, 3.536341172119947*^9, 
   3.5363412280149403`*^9, 3.53634144692865*^9, 3.536341961779797*^9, 
   3.536342024503587*^9, 3.536342551316553*^9, 3.536342659142679*^9, 
   3.536342825633093*^9, 3.554640053985256*^9, 3.554640184118108*^9, 
   3.589205766406526*^9, 3.589208120932848*^9, 3.589208395776359*^9, 
   3.5892085893442163`*^9, 3.590143673511251*^9}]
}, Open  ]],

Cell["\<\
Below is a Smoothed Histogram. It will have a similar shape to the Standard \
Histogram, but will be mathematically smoothed. Sometimes this is a much more \
pleasent and informative visual, but not always. Remember, it is smoothed so \
it does not consist of the actual values. For example, you may see the line \
go negative, even though there are no negative values. In reality, the plot \
is the probability distribution function (PDF).\
\>", "Text",
 CellChangeTimes->{{3.5303730468070383`*^9, 3.5303731275375233`*^9}, {
  3.530373410538884*^9, 3.530373411173328*^9}, {3.530373965912763*^9, 
  3.5303740112625923`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histStndSmooth1", "\[IndentingNewLine]", "histStndSmooth2"}], \
"Input",
 CellChangeTimes->{{3.530370958778479*^9, 3.5303709615584373`*^9}, {
  3.5892057738165283`*^9, 3.589205778518346*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxdm3c81u/3+Jv2JpVU2sNeWbfXde7lvo1k75W0VEbZ2UmFJCF7j0ohoUj2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      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"\"", TraditionalForm]},
  AxesOrigin->{30., 0},
  ImageSize->{680., Automatic},
  Method->{},
  PlotLabel->FormBox[
   "\"Smoothed Histogram of Sample Values : Sysstat\\n(Probability \
Distribution Function)\"", TraditionalForm],
  PlotRange->{{25.55995364744892, 
   49.66004635255108}, {-5.866202770409336*^-17, 0.5008266645814731}},
  PlotRangeClipping->True,
  PlotRangePadding->Scaled[0.02]]], "Output",
 CellChangeTimes->{
  3.530370970350786*^9, 3.530371193467195*^9, 3.53037128235537*^9, 
   3.5303713670898952`*^9, 3.530371464463482*^9, 3.530371829066883*^9, 
   3.530372611362261*^9, 3.530393601896793*^9, 3.530394130470519*^9, {
   3.5303944963024673`*^9, 3.5303945222734737`*^9}, 3.5303945870415373`*^9, 
   3.5303952095724993`*^9, 3.5303963142156553`*^9, 3.530455428067252*^9, 
   3.530455467394712*^9, 3.530469238698297*^9, 3.530469281286817*^9, 
   3.530469430453369*^9, 3.5304695602937183`*^9, 3.530470245311763*^9, 
   3.536334926838644*^9, 3.536335718919424*^9, {3.536336625505869*^9, 
   3.5363366510603437`*^9}, 3.5363370232800713`*^9, {3.5363370993025703`*^9, 
   3.536337117650896*^9}, 3.536337288587038*^9, 3.536337558052737*^9, 
   3.5363376448261223`*^9, 3.536339086046122*^9, 3.536339944737526*^9, 
   3.536341172213355*^9, 3.536341228061922*^9, 3.536341447016457*^9, 
   3.536341961861414*^9, 3.536342024602624*^9, 3.536342551377861*^9, 
   3.536342659196598*^9, 3.5363428256828203`*^9, 3.5546400540351954`*^9, 
   3.554640184135667*^9, 3.589205779961376*^9, 3.5892081209956627`*^9, 
   3.589208395840897*^9, 3.5892085894009438`*^9, 3.590143673559062*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxde2c4ln/YvyRSRkmiiZBSWkZpnKd7U7KViGyyR1RURikke95k700ke487
SohSUiIh5UeUBv/rfxzP8bx4vHGcx/f6nuMzzsv1gpipo5YFOxsbm/RqNrb/
/zv0+tr8jS3KyPY/P/83tlART1JsU0auhWUJ+4TDcFzkZPilDmUsLJeM5So8
AnyTunf9WMqouzR42//5URitdLyW06WMvx/Vb0tcloMn9wNsXzxXxn1VDVZr
QAGCLqQZLfQo4zPzfIp3qCJclq7V3NanjOtWJyW/mj8Gcr8GKMqvlNExff5R
v40ScHfMKloNKqPqx4p67fkT8D5mnUzwG2WsyeRUo4SdglIriZ1lb5UxkPOn
OIMKcE/x9MY3w8pI8Uws0L+HYMB1gWNlRBmdkphv0zyU4dCg80+JUWWccuLy
XOVGAo6soCnVMWV8+S0lcMGLDG/cM4adPiujffG+41wRFCik1fdEf1HGHcNB
C40VVPAVetNcM6WMPGU6t8q/0OD857mK0a/K+Fz6t0ziXgbIVPDkrv2ujHqr
AntFbqgAm79Uoux/yuiWrzp8bkgV+nUxVGdeGY2ubNq598xZyJG86HdjQRlF
2xmsc91qcHPB1T35pzLW10Q/vmKiDlqtwTZtS0Q8ICQjdEcDpKKyDL/+UUad
Ufvp3Saa8Me8UV1gWRl7Tv3mPsHQgh65t6RjbCSUu/9Hq+q4NqRzLMgbsZNQ
z8dyvZCCDlzv59t7h4OEd59NWT45pQtq6dLbczlJmPZbTrBNQw/E3Uj8PWtJ
2EXn9u1xPA+LZEP2xXUklH+q66zMvADPNrkvbOMl4bf+DRz+ffqQ9CnkizI/
CR/2/KniFTEAt7Kct1YbSWiQ89BF1c4QGH7Nz4M3Eflk1xoXd1+CHdrDjWWb
Sdj/i8lVccoY5sR/Pn6zhYQnHAxFrxhdhra5DdkrIiSUOLMwMiBpAsymfUzJ
7ST0aJURZiyYgGM45eGZnSS8YuwysqHbFCimRj7OoiSs/b7nhmqBGQgfueYW
I07CzeOsXvVoc5hZFW5VK0E8j1HzZvctoOll3sVPUsR5nPQMy88SolNa1bj3
EvW3vX3Red8KbJ1H8KAMCQvavdMzY6wBlJeO6h4g4X3xYvPsYhsQ3Lhpj+dB
En6K85kT6r8CXz7s35pymMBbvZP/BLsd1BbTeNuPkgj/PNMxOmEPYd6X2Wbk
CbyUrKWe3XYAS40b8wLHSJi9ozOv64UjKIlGfj6mRMJ08QaTwSgn4J8teGN0
koQ/DDb/fa/iDGP17V13TpOQz4NWtZvDBSpDPtbnIgktpGM8u1pcINj4T2kP
iYTqiwatHA9cweTg5sxFCgm3LFj5LOq7gcKKbNx2OlHPbXdipexVWPeC8YCk
QsLrN0/Xea1zh5FHpretz5Bw7q9V35UZdyhz8HJ5qEbC4x8Vp3MHPeD+6WiL
x+rEPI0G+y06r8ElvuILQ5oknKAFdzc2XYfD7zvPsOmQ0EFJh3ey+QZwFn46
LaVHwmNbo/eu7vaEoZv/Dp+9QMLb+gt6x957QZHaFkmXi8S8luyVxT9vgt+O
w8KxhgR+LNSJFLkNF2ZU19cZEfPr+dxbI+4N+2vNlz9dJu7z+8WkV3vDquBb
/3GbkbDuyYpvsb4PDBjGjh20IPTXFrcR//pA7v7SQV0rEvKfCf1pleYLt/8+
Y3nakPAUx7D/CXU/0O4ar02xJSFvZNFo94ofSCesFLfbE/jY6M/Lld+Bv7Yi
6TOOJPzZucbF1/EuvDxxNGaTCwlnOVfKmmT9IWO9WuBxNxJ+PdGxj2feH268
tbxp7E7CmHDOAPeae3Auz9vp7jUSsit7XloXdB92e8ab5d0g9Hn8Wu6QUQD8
Un2s99KLhP9k72z/rRgIXVufq/y8RcLxCoy/LRQEKVMTJ3f4kHDgoVaX0+8g
uFq16hDZj4SGnAnFHz49ANXAbbtt7pKw2TlgZqQ3GHZelBcKuUfCz+fo3jfb
H8L8XnXu8gDCb131s+2NIdC+ZP13KIiE02q6mZ8vh0JCp+93tockZB7SCev+
FArOcQmjUqEk3BFbfjrJJgyoNhWvzoaT8Fyx+3eTuTDYerynwyWShKNr3yVu
uxUO39ZOVcdGk3Ct+o4/L3kioPn16qK6WBJG7dxqH/goAmKyd6SOxZNwo48w
j+rRSLC7phi1LpGEN4qDkzc/iwRkaN4/lETCd6/8xeYtomCzsK2nXgoJM4zy
pD6vjoapiTsOXmlEPp1/V7+nR0Pdk0cmqRkkJF2/mSioEgMR9yp1OrJIeEGg
+cmF2RiwOt9L/5ZD5B/R9KuLj4WTe74qCeYT+YOrLjMYcbDh5xpZpUISahh3
avz6FQfjbbvELhcT/FxpnnuRHw9Po48L+peSsLqn1LfHjAkPLbW58h+T0Olc
0+DvHQlgqmD/+2UFCRPts03V3yaAIue9mZ+VJDSrE9//nJkIPAPJH3ZUk1DZ
0KfP3fgRfMio6iPXktCSnxzMkEqC8qv9bTb1JCzWaxIjzSZBAPXb05BGEhop
yvwpNkoGo81rC8qbSbiusbG/vy0ZjoyLJb9tJaFX7f1n9w6lAFf5iYhVHYTf
bS5vZzFT4O0dXf89LBIqrXouGL82FYp1HK+rdZHw4kO+zgX3VLgrEWDn+pyE
7YtRge8+p4L+j1TjuB4S3jq/OU3lQhrIttRo1feS0G6P7qLSszRgjxygjveT
MIU+I1QI6TBoNnts/SAJF15XLiSVp0Pe0XX7D78h4e4YewbvgQzwXi2x6/xb
EtpYL9fOZ2SATt8pgZvDJKRWTy+riWbC3rTza9JGCL8ssPVuSciEZRfnXx0f
SZiq7J2qJpIFvaSg6W+fCH738PybismCLIGM94KfCX64G45Mb8kGz9G6l0pf
SCioStNXicsGjdLXLZenSGiu91uVbXsOSPjOPfH/SsLTrUJZ65JzYEmTJy//
G4GnYO64qWQudItJPeqdJWE4j/4IR34upP4HYb/mSKjZ+3XbxNE8cG/Uv7Nz
gXifvX70m6M2D86EuXpQfpIw88roz/P0fBA1Cb5yZYmEDWNy59/05sOPQ1mX
Qv+QsDApe7evcQF0sjVqVPwjIU3+1qEzMwWQ2DNEfrdC7PczE/IHvArBJfmH
Ajs7Gd/WnN0iwVMENCe+fdIcZDRpdRYWSyyCbSi94xwnGQdsS9pDthTDLD9p
g9taMq6RDUpdb1IMLSMGq+PXkbHj0vmJldxiiCu6uljPQ0ZO3gq69UIx2N8O
mRznI2NiGi0EsQRI6jnv1m8k49ysbcqdoBIQ2tX84vAmMobunjY7OFgC09/e
NZ3fTMa9p/5kn9hdCvV1i+U3t5BR3c96Pt2xFCIfbshJEyFjRVZbomVNKVgb
7Uvo3EZGtY8vajy5y+CULCXk+w4y4oZ8zRG9MhBYvuS7WZSMdMMW1QfpZfC5
2+PqCXEyanIm37k5VwbViWHWJhJk7HJmsQrwMYTY5xnckyLjaoum11tCHoP5
qdZzBdJk3HZj7mLF8GM4xjui3LePjMfKS7/77S8H3uFfckv7ySggqy3t6VkO
H/MFpHcdJGPf44OB0axyqPDav416mIxiOl0hPSIVEHiWxmd7lIymgb9zdttU
gPH2y6vC5Mmoz8elHFhZAXJfr/+oUCTyTX8vX+Z6AmtrIibeHSdj+ZNUM8/z
T2A4qGCI/SQZC7NJyb8zn0CJQXu39Gky9su617kvPgF/mY8N55CM7L3VfFPU
Srj453eZG4mMBkplJ9WjKuHgM8GseAoZpahHfZPHKoGDKRvfQCOj1wYx88Gj
T+H1FUbwZwYZL88FNH3zfQoFSqbePGfI+Djl+K8PL5+Czzov1yNqZHSrP2+Z
LVoFekNRlhfUyfj676er4FgF+3KL9G9pklGCJR+XXFsFK9c7z6Zrk7Fp/pZa
2/pq6FP5BCxdMu58oLE9T78askX+HZk9T8be62KJKlnV4DUpJCV0kYyDv1+5
J/yoBs2nh0ROGpKRYUU3eaRcA1IBqjymRmRUvfZMSvVhDfy+YL5y7zIZj2pV
ZcQP1cAL6VtzBaZk/Bc09zJQqhbSfsWM95mTMcXmYsVml1q41lHyesmSjHye
l9wVamvhbOyzZ7tsyDjUbaH+hasOxKzH66i2ZPQeVo+X0qqDBcWVElt7Mi5e
ed31lVkHLC6RjDBHMsqbr/ZUGK+DR4NHYp84k3EDu+eFlQP14Jp1NmjYlYzf
yZ+Pk93rgeFheWu1O1F/Vl5oubYettO9nfdeI/BInV8dzd4A/wnFm6vfIOOt
+h1ZY5IN0Pq57PxVLzKKPD68Z5LRAPEV3arMW2R8tVGdlWLbAA7+E6cavcno
dDhjiudhA5D1Vh2e8CXO034sShc3gLDUNgneu2S0E+Z2/fGyAb4uyG05eo+M
Tw1lftnPN0Bj67l1+gFknNweJB8p2AhRUdb/bgWR8c2G5FkL+Ua4YuE7mx5M
xhyq75pR3UY4LZ/wiRVCRo9jx6243Bth05qKgdkwQv9eq0RfRTXCRP+LTqFI
Mlbl3NdULW+EmvTJmpPRZCwy2iVv2d8IoW6ri01jyRgi9HGb9HwjWFB2pN2P
JyO18KVDyMYmUBJUjC5MIOPGK7OFzINNwDemEdD/iIwJBnj1rFoTfCq74vU7
mYzHedtcUq40wRO/O46iaQR/Rjec4u81wQPtR6a0DDIq+B5RV0xvgsu7K3Xt
ssi4Sewm17WGJpCff8kIzyGjVoRbjuG7JljXPH2iMo+MUSr+huM/m+B9+JqD
7wvIyGV30FhgUzOUmu4S5ygm+mcVco4daIZ7R45v3ldK4Hkqv+4ioxkM2bXX
ajwmo3D8q7Ueps1wqNfuz9UKMlo7OHsd92qGNan+35iVZJQrnWhNjWqGN87J
HxuryFhdgJllhc1QqFzVP1FDRhu9+Dm79mbw3djfzltP7MMrkREvRprh/MeZ
qqONZNz8qOzOu5/NsL+Eq1C/magvWdMXyd8CbD5iKbdbyWjLxZG8JNUCrzRO
RGa0k3FXQK0Iz+kWyBHVvfesk4yeYko+3TotcGvW4cZ/z8j40VBKCmxbQKvh
vv2W52Ss2VVvaerTAntCUy+f6iGjUTVb0bGYFvhjXKNt1kvGnjM9Hs35LdBz
cIAW0E/Ga6930TiaWiB95fvxogFifz7mzf070ALXX3AfePWajN0JK6cKp1vg
XNJu0T9DZLQUrsrYytYK4o6nNokNk3FPjFswWbAVfp4+z0kfIWPb66nsfdKt
8IzPecnuI7Hvt9uVvjzRCsnvA7+GfyL4Svhio6TeCm6F6SOV42S0ev8vwtK0
FVRu1fW+nyCjuzb70vmrrbDz3OtWjikyxr3YYL7hfivM7Zir3PeVjOv1BFPD
4luhfWZ9vsY3Mp5uCmwezm8FZq1kkvssGX1d288t1rWCUzCEJ8yREd6vHXvX
0wqUS/p3m34Q+3jOyDtitBVEDrhe+7JIxgO8jdPbfrTCzN8HtnxLBL45JlMe
a9qgqSvTSO4PGccaOk/kCLVBdEKD5sV/ZIwU/BVXsqcNbO2GKN4rZNxRc6cy
/Fgb4MkfipmrKNij3Uk+p9IGgjx8Ml2rKfhzJ9+Hcf02mHy7Z+fcGgqutauR
NrjSBrV5yhuF11Iw1S+6qOhGG4R7GnCcXkfBJ+YLf8YC28DyzNWfZjwUdAnk
Cfwb3wYntoVMBfBRcP3cUdbP3Dbgn84eLtpAwdLQY6Kvq9pgrKqp55UABeXN
ykYfsdqgMvBd8x9BCvKdsLqoNtQGwRcXK8S2UFDYMqNxbLINTPdtyKWLUPAw
4ynZcqkNFH7vTbTfRsGPPy/+7V3bDutZ5NCIHRR0n5T+KSPcDiNxl/ye7qLg
2wLpgy572uGxjYf7iBgFbVrPPcxUaIf7x8Ns1khQUMyHd6aT2g6XuPMMZaQo
ODoxtXFYpx2OvGlR15SmIDl0R8kHs3bgzHlP8thHQSmDQ3avXNrh7bVf8on7
Kdi7mP+y2qcdihgCe5tlKWjN120YGdoOd4T3b588RMENnEeuGie1w4UvVH7+
oxQsE01z2FHYDgcqjdnl5SnoMPny/vOadlh1//rCRUUKXqyU+O7yrB0Gzkd8
8T5OQSHpe5Xrhtohd0/B28wTFKxSx4moL+1w+2fb865TFEyJeG4t+LMddNo/
NM4BBa++79jsv6YDpGN+PxYmEfNuai2Z2tQB/ywFs09TKKgTSJ5WFu+Alwqy
THMaBdsskwyCDnVAJifjYSCD6I+5+l7b6Q64MWDiU6xKQTsH83dzZztAPdPT
beAswafazXJ+gw7Y7R5l9fccBWWf9+ptt+mAX9Sii+KaFJwoqfy+xaMDujZ3
qjG0KWhVZxC/6m4HpIyPooMuBR/ovjB4Hd4B7uV/j0aep6BJ2k4JZnIHqN4V
2lOlT8FzKibPGYUdsEv30NYPBhR8adcn+qG6A+YlVHk5jSiYL/hfl3FnB3T8
MGPbf5mCps2Rjm0DHZDQcnNe05SCw8oiYQJjHeAcGfPZw5yC3mG3Mkj/dQDN
vORNoiUFT68K59Fd7oCtcs+6mq0p2GEhIsBY3wnfV4/XT16hoNP1Vd9EhDuh
uW+5lN+egt12IS0dEp0QmyacKe9IwdflUZlahzvBzvVInIEzBWMP5oeVn+oE
ZfLZBz6uFPwv2dbpu0onbN5keTvrKgVprflbl3U7YWr0tku3BwX5F1m6Iyad
UFcaZzF/ndBT7FR/qH0nRPiWXRDxomCDK/n4huudYK3VfQZuUXCjmKOAwZ1O
OCk+cdrCm8DzSfV7h5BO2DjHdiTIl4J7v/uuV4nvhPHGrZIldyj4b/Luwuf0
TqgKkxMe9Kdg04DaJLWoEx6anFv/7z4FWdlhu82edoLZYetl8SAKZm9LeXmi
uRMUV/n+xwgm5jv1amN3VyfwvGSOOYRQ8Eot549NA53wIbl8MDKM8N+RdTd4
Rzqh3OkFqyqC6Gf2/I+KiU4IxMnaD1EUnJKVfcoz2wlGG1aXcMZSMN7Ss279
r044+mF7+v54Ch44nviteKUTuIoVYrQSiPteTN4lTha8u60ReO0RMW/VbP8H
XhYUq1+5+SiZguyDCj/MBVlwd9cdp5ZUCupdebvRdysLLn5PNJtKpyDPt7fP
5ERZIFv/RG9DFgWfzwRUXpdkweqQlyoKOUT/2uet1PaxYNBo+qRhHgWzpnNN
8mVZkC+75pBvAQXvKtbKRBxhgffyzt3ZRRQMiL1JXZZnge7zY0LPSyi4beS2
zNQxFux9pMX9o4yCrSfmzmufYMGyvd1fkQoKjgUxyQqnWNB7yv87VFLwxPxH
y5DTLMjiTR61qKKgRt4bJQNggdfw01dBNYT+Jg2UoolYo6Cvo6SOgutKJT+d
JGLJmzPVgw0E/3bLFWeI+0tnuYr+NRH++DV+sv4kC55vF0vd3Urwx67KHqnE
gtSvSlEq7RTcpUNKaFNkgUeNzn3HTgoaPO3L1pZjwdkHDp5RzyjE3+PHexQP
sUDU8L5DdTcF/UaPtDnKsOCHTKrJxxcEPgkXz/wi8Or8U63D1UtBhsBN2ee7
WPDo2Sv6gX5CH6k/1b4Js8CF+V1Je4CChVMicbobWUC35Za9/pqC+1ICN67i
ZsG2E7vFkoaIfkSKumYIfmfXnRJsfUfB2VbBBeHFTmgZ0uOafk/c3/Tu2e3p
TojLdfq94SPR7/vdubs+dILDjcAZhU/E+6XLjX2xrxNIqukfDMcp6PxMxpSt
vRO2bK3r850g9uvoqMtJQr/Tk4Nt2ZMU1I0Y/JOV2wkNT/97+nya2H9zap+Q
2QmRAesLfsxQ8F7y94NrgjrBRl8yeessBd26JNfNE/46vRcicI7Yb8b2tWut
O0Fg6YK/5Q8KRrumP6UQfv3c4XL9wSIFveQ0IjOUO6E69oFd6S8KCtCHuPcd
6IRQ60zj178pqDrYstyzpRPMjzVoLf8l+LHp945b1QnH1w5RJVYomBMm2+E7
1QG8r+ePqa6iokO+3bEHvR0wmsW732k1FTU6U0zKn3ZAhceeXdFrqBg3prVq
OakDgujKAjVcVIxKv7zaktifl7cYrBnlpuJt1kffGWLfyk24/eLioSKGzrAi
1Tpg7ZOH0wf4qHj/iO55Q2KfD/tnv9feQCX8ceYVRaADSvWaXl4XoGJy/d/d
6vPt4C/1riVJkIqcwKvr1dcOBosLT1qFqMha5CnoLm2Hg238edPCVLR5OMei
hLUDR/TeRxu3UdE4t8z0k0M7vLYghynuoGLW0sM3uWfaoUD+0p1Lu6hY+/hd
cCLxvvVd4+HhJ0ZFd87Qtlr2dtB7FXolZzcV9ZPtl3mH20AmI/fSC0kqvhAc
/xRa0QYrbi0aC3uo+Mei74JKSBv0U96Tt+2j4oYEWRclqzbIFvyloLyfim2U
eA+r021wc2zjPitZKtK6xkb7BNtA67HMjuBDVDQosjf2m2oFqTvUDWVHqNgS
5dZ5vb4Vfmsbr34jR8WjrpoHqiNa4cXu64vLClR88y6q7YxVK6TPh09KHKdi
t9TLsoNKrXCtOf+d6gkqCpdyc9rxtIJaRNsLp1MEPwcnPNa8bwExsw9N0UBF
XkuzHraiFlg88ru8RpmKIcoH9pjdbgEWu2DOKJnAv1Gq5rB6CyT1HkhYSyPw
mpldcN7ZAm6p9BBZBhWXY80v751pBoaLia+OKhUdo3/lXqpuhu0kz6s3zhJ6
OSSUJRjQDP9tjLJOPkfFf1mGNB29Zmj7WGjQpkFFv9j+WPHdzRBf0nHuqxYV
P0oKPrv7vQkcfUaVBXSJfsZ1JO5UNwFZ86/csfNUVLzlxSFBfK8IiwlJG+lT
0ZZdZNRWqwm+zh7cdseA0I+gFsN0RxM0Nqjw5V4i+Jt80c/7pRGiQ81W9RgT
+elx8ldLie+zyzd/LJgQ97MmpZK8GgEOxUxsMyf0FcfmHE4jvs/YSoaULak4
nDs9rruhEb68YHVbWRP6nTljPPumAWqSxhqCr1Ax01y4xjqtAcIcl8vK7Ki4
w9/ofatdA1iCcNYbByr+Xc+ew6fQAEr8R+JXnKio+uj374jleuAbORMs6Urk
T5K2/RdaD58KLbzPXKWiUvR0sOXueqi8ddvV2YOKu4SrKt+X18GDc3GWMdep
WB1TFeTCqAOTnWX6tZ5U/FBAvX7wbS3If+s6++kmoW8x7wFxh1pYV/cZuL2p
aBUoNai/qhbeB7MdPehLxfheu4CPkTVQdmmrlO4dKso/nX/ZJl0D9w/IiXj6
E35xHbASqq0Gw39qPCn3qXjXvrfnnWY1HOq2WmkLJJ7fFXRJaqIK1iT6zH19
QPj/xbTkilcVDNkxxwVCqMi9+a6Ny6YqKDxZ/vpYGBWDgwo7H+Q+BT+eF8+M
IqhIfjDupU96Cufffam7E0XFq/UZ5z4NVcL+fPbS3BgqLuoWc8u7VQKb1/aM
njgqil3cc0CfrxJenVGIXWRSUTRqZlI/5wnkbtMI2v6IioXPD4oqU5/ArWmb
W6RkAj994UvCoxWgXe3nbJ1KRfO6gtdfblfAnqBE84fpVJxSHnat3lkBfy8+
Of84k4q/XpZUxNaVQ8++l6pD2VS88/7J8/vG5ZDxe+oUWx4V+ZwfBkesKocb
LI7DUgVU1GzMsGpIfwzn4ndKnC2i4mEzGVchlccgfuXYFpcSKj7klbBK+FYG
P49rrYsto+KFodL4C1Fl0MVt96+2nOC7OZhD81QZJL+5O/vpCTH/miSloM+l
cDUn6RN3FRXHJnudecJKQeX604GDNYQer2689eZkKexU6evUraNiBJr1Lk6W
wJzwTI1nAxWzK9HHOrYE2r9wFqc0UfH4zLpTRxglkFApmtbeQkW76fwL55eK
wem+UvRMGxWtE8w7hvKKgXJBJ2BTJxW/rZSI1xsXg4i0g9fxZ1R8HWCbwrm5
GL79vOdo3E3FlOyvVMuYImhqTzG9+4KKDQ+Vzz/gKoKYmGrdvJfEvrx/8rnP
jUKws3rFeNlHRa9cig5jtgBQ8fuJn6+omJ989MsH6wIQ5OI+uOM1oddcttEz
Y/kwOSAuTh4i/LCUvHjfNB/qMk9utnlH6L0kfyDyUx6Eu+utDXlPxdEDKruc
rfLAiub05/EHKvoEFvZs+5YLJ4QCvw2NUvFid6ZimEcubPic9pFtnIp6zhwD
L1bnwlh5bb/UBBV3fkbN3vAceHp3sP3sJBUlC0MtIiVy4KHuf1Uu01Qsbpd9
wf80G0wl1xfGzlBRXLISSRrZoLAgkVL3nYoimYtDElNZsL71dOTYf4R+troq
l/hnwYfIC/fW/aCiclr5zAfJLHhs7nLj0CIVFZa1FvLbMyFA7oG93i/iXIzB
z2eXCZc4Mi97/abi1ht6cX8FMuFIf7126l/CL+mXEp1qMoAz/Q2tY5nA17Fo
wMQ6A966zh//xkZDNgWDJ+1CGVBM5j0guJqGT/3t7ePa0+HOpj2iSmtoGG8m
9qX7Rjrof8JNl7lomKHJNmxwKB0OlF3k9OemoV3Bt67jX9KA3c9tKW89Dce6
xbiNUtNgQOvh15e8NExJ/fekzigN8sSzR37y0/DTo8E3mjvSwHuusXeHAA1/
fEpQ432fCjpNb1vJgjTUa9F/9Tk5FaTDFypthGgo+C55a79FKvwz4c8PEabh
JbGeUtb+VOg9vDepfCsNE68e2d2wkAKZq8jhb7fTMNvi71hOQwp4vjS8u2oX
DaVmxG1uBqeAeor7tT1iNOxSXL/9kGEKSDiH2qrtpiGPt4DNk/0p8AtzjVwl
aTihMVO7diUZuje0aMbtIfqNHA4W6UuG1A/DlPq9RD22ep2R7GRwL/6pOC5D
w1VBk3Hq3smg6r1RZr0sDQ92TM4Z6yfDLg2ZnYcP0fDEDn5OTrlk+LGLuvH8
ERp+G3vxQHFDMnR8N+K4KUfDDXEclv1vkyCx/trPVAUa3iwc2yUZnwTOIeFT
HcdoKD/cmqFtkAQ04/zhb0oE/r3puYxdSbD1YFuP4CkaGmkvJc6OP4LvyyPN
SkBDjixHmWNFj6Dl+VLFZWUaFtbdPMXj+QhiH23K9SfT8Gh5wYq+yiOwdziQ
mE+lYW1Z0ge+rY9A+TQ9tJdOQx2PNvctM4kgxGfi90uFhnx+BRUmTYkwNXzD
fedZQi8s8/CRuESoL4i0oZyj4TUY/uflmgiRNwsNr2gQ89eEdEmrJ4K1Wod6
qBYNvTVit/XuT4STO0ZJFTo0PN3GpmXNkwgbZ/7Iv9Oj4Tu2QdG3MwnwuWbz
XnZ9Gm7fI+C39WUCVD04uF3agIYK91RqhSoSIMRQhf/cJRpmNbDo9QkJYLbf
jN3NmIbndl15x3E3AY799VqIM6Gh+88Dpu8cEoCnK/pLvRkNK402JctdTICP
zOK34xY0rLucorxCS4AKW9bz9dY0fHhbSFFWPgECT4w1Hr5Cw6LYg4/LJBLA
aP3y4/N2BD+fB2V9NyfA0bdbsm86EPh8aLn0gCsB1uYdZqY50fBLJZti628m
vLtx5mGnCw3/47P8tus7E0pULXy+u9EwV6bgcfAYE+5uve222YOGn494X1jz
lgkXp2KtTlynIT93tu21XibIVpVeNPEk+HLWHxhhMWF1YJfavZs05NZR8drf
woTX+p+x4DZxnn/7k1YdE/L3ssn1+dBwaYtaC/0pE3yWRPYs+dGQayiTi62c
CbqdR7fu8qfh3sJ7rU4lTNgXp8ZLvU/oef15ckghE5atrdhsA2lo6nphTiOf
CX3HfOZDH9CwRlHCIS+XCdlrmZ8rHtLwnqiMZ2QOE7xeP37zLpTwsyhtDTsR
a2Q/72KPIPikaO+cymaC5LUv9dJRNCwf/vCXRJz/prOXnYuhofW7id/sRL7n
W7ZnusXRMEk0OlI0jwlpE/Jx8UzCz3f2WoUT9T2eqD9oSKThrPHqw+eI/s7e
s7n9OYmG+wu/2aoWM0H0vJ8LTyoNbwVQdvuWMmFBKtHiSDoN21R9n0w+ZgJr
seLChUwaOn/ffOnaEyY8aus5cyubhr72fOaSVUxwiZ46nZ5LwwSp64pfaphA
t+Q4wsqnYUhor2FlPRO2K+yUnC2k4XX+QNfgJibMrjkmLFRC6HsmVs64lQmt
rzTXnyyjYZXqfhfJDibEZdgum5QTfhgw2fKa4Mvh6t3/7j2hYQzPFmnHbiaQ
qEljBU9paFDJahh9wYQtm58O9lXTMHnL2ZPSBN9fx3pZS7U0bA9ip5zqZ0LD
46+1uxqIfeLobiI8wISoO5wl1CYaamm4WZcMMsFGRzTdtoXAa6nnP7Y3TDgt
oRQT1kZD8Q/ZRStELPBDO/BJB4HfZxDMGGLCRLP9zWEWoW8p8eopIq6JuOe0
upuGQq2qkV1EHGqWYrb3BQ235tVbKROx+dFqPfWXNDQLFnkBRL7jq1+pXO2j
4b8yibpWoj5f37eTzFeE3mh3Ap69YsJo6tpDjYM0nCpK7FHpY8ITF/HdE29o
GGmZZ6HYw4Qg0kkh3nc0tDLMcIjoYsJlAT3uo+9paMyv/1uXwE9u1PHvhQ80
PPvygvW1ZiZwlwZ8vzVK7Bujj+M/apnw3idtNH2MhhpOtk2tBJ+lmrWvWJ8J
P3fFOo0TevAXG+yY/ULD7o9S984RejP4b7ZaaJqGctqfG/8kM+FQ47qikzOE
39sq2L/EMIEjTCLV9DsNF2n+WnwPmfDm8umo+//RUDNEe9TGjwmFhy7cL5yn
oUzUEZ5FDyb4srl49i/QcN8jLZ1CWybo9QQ5/P5Jwzdya648NGKCTHKGiehv
GlKNHj4L1WACm1O9Du0vgeflFVKpMhP64Q3dbpmGTbfXTP93mAk5/PNK4Wx0
5Al4PKQixoSbIzyylex0jE1cyq7gZ4JWkZTYew46Po//ukP+XzxI3UZBDi46
9gWyjjZNxsOfcxe59nHT0fHU9BaDV/HQs9Ptt/p6Or7RLJH5Vx8P6d+CZ67y
0jH5l+uazJx4uFaX9YHJT8cN5SbO2uHxoPawsa9xIx1HzAxcVt+IB3Gjt20T
m+iY8byN9PhyPCweWHjKK0TH7QIXdM1p8fDsH1/BUWE6tu58qSsgEw9J3dLJ
+lvpGM+s2FvLFw9uiaSI29vpyLUvaMLsvzhg2Bv6Z+yko+nfX6HsfXGw45T7
9WeidFQ1Iz5ByuJgjifU7j9xOr7iG32jGBEHbe9yjLdI0lHeqDma5RwHzPxm
rVN7iHnNKi5fUI8DR69hqtleOt63XRAekYkDytmfxwJkiHzVW1TNueJAePvG
/UUHiP6OOlRNfIyFmel9u14dpOPWQs9nNtWx0FRNEfhzmI4kd4mV6YhYiA4y
WiMmR8fH0rjZyTYWrhhc+0VToGMWr8zbBeVYAJnwabtjdNTlfjrkuyUWBP/k
vQ9XouMux6DnIl9j4Aur9WXlSToe+nKZs6Y+BmrjR1ren6ajueLkVbvwGAi7
svSEQ5mOkz0H1GTNY8BSaVPePjIdL+HaXxzyMaC07sAjDSoduzf77fjBEQP8
Q7Qwdzodh/ZLJq30RcNYzuU7CSp07AjTdpNJjYbK6zc8ms4Q/CVYTV5zjIYH
KpFXvqjRMW4kV2/+RDSYiBRe4tOg462p4gEmVzQoTLZryGnRMbv2hqlHbxSs
e/qRfFGHjpsaXPYEJUTByP0/Ct56dJzYLOb/ziIKyi5s3pd5gY4uz1gbnGWj
4L70wR1dF+kYXfSf3rnFSDD8xdgwZ0hH/lVRf11rI+Fwh+lqYWM6njq6fmHB
LxI4Y70WT5nQMdOfd2+fSiQMWUVPmpnRcYeb9noB/kgoUix+F2BBzJehcexp
XwT4cbFeFFnRUXKVqsuLmAi4MPip6ZUNHS8U6X65aBAB+7P+lf+xpeMf+QkT
k50RsMpjS46YAx2/iNw9+/VDOAzQDifQnej4n+zGJo60cMgVOhNi70LHznm5
rmLzcLj12dw3wo2O/imj639KhoN2xa2rT93p6LmtXWDkcxhI+8daj1yj44DH
or9TVhj81S01WONJx9UcD0XLrMLgpWTXOZmbBB7v1LIK94RBxsK4suZtOv6j
yMxemQiFG60rch4+hD4X3g19zwyFc1Ei0ol+hJ+jTdWplqGw2+Lotua7dJxL
u3/CVTIUfsmp8U3eo2OCSL/o6s4Q6OKwWsUfSMdCt4+3Z2khkNzv/UPuAR31
avLd6loewtX0+ImLD+lYc19t0Iv0EFTdHg95h9JRfDrA5URDMOykPO/ODKej
9tiXZe7TwTC/6UtDVyQdx6Jf7PhV/QDaP616PBdN6L0uT2ez0gNIKNuWJRxH
R94vB9Y6VwaBk598/GkmHRXGojy2KgYBVVs92DyRjpe1z2zfWREIW3fbeAcm
0bFe8jvbA/lA+Dbn61qcQsdiPn/26+UB0NyUYDmQRsdZtVvD3+QDICa8Qv9v
Bh01d1b0/am4D3amPWfFswm/1qtNFBy7D3hkChi5xL5RKx8QqL4Hm9k5jjrk
01Ga/73wsdP3YOrlDqnIQjpeWQl9s6/JH+pSFEWqiunIp/V14SfNH8KdNXk+
lNJR+Cb3Ul7XXbBStl1ZU07HPdRuYW3tu3By4905mSd0JO/9dGRp6A5s+Pho
XPMpHXutxztzzO7AeHHla49qOn5tKGV3mvGDp969zxJriX0zMpeid80PHmp8
rWuuJ/A2Z3Fbc/iBqShn6WQjHX/J1ysWhvmC4uyuDP4WOqqUdDcdEfUFnobj
sfJtdBSkFL1ZLvKBDyHaQQYddMQnWsrblH3gsbH9LR8WHQet/LVD+7wh4OA9
56wuOn726f9nYeUNRivJ5t3Pif1qKu5DX7oNR15UnZ/vIfaHvLxhitRt4Erq
VxXpo2NSUWT/Z71b8Nbh2yl4RUcd9kM6EoE3ofj02sMWg3TUePja0qLBC+7w
iUsEvaGj7Rt61eMlT9B/f2JLyVs6FnT47dyu4AmyhbrrBoeJ+kZJ/ulXbwD7
Lcd/f0foGMg3wK1XeR0G1QJmxUfpaOa1Mqa4fA3ydqR9YozRseKSvpcG/Rp4
z9QMOHwm8s+mX8qI8ACd2oHOyC9EffMo0olP7rA3eLamaoqOXpcebBJScIdl
w3XFH77S8XxiytSxB1ehd79EGud3OjLK5oQyx90g8++p6P3/0bHZW1HUmOQG
nl3nA7Tm6XhcMZZlnuoKGgnOXtcW6Ghj07j1yRpXkLALcnz0k/Bb9pGLunYu
sHQiw7RliY6j21q2nR5whu719bpTf4h9fcUYHcnOkPr2NWPDMh1/nPvyZ7zM
Cdzz5k4osDHQfrPm0KM9TnDGk+egITsDI4ILA2ROOYLoGSlxXw4G5vp28j04
7AA/tuLmbE4Gqi6K5+vst4eOKf21z9cS55fvZFw/YAeJVa5/5tcxMPxOg+Q3
OVtwCQz+JsLLwJeHzqmmk64A7WLWR+BnoEQ558FgPRvYtq+x32IjA88Osf2O
dbKG2aWh9qBNRH1Vn4mKUCto6fxRVbKZgUYeS7qvKiwhNo6vcHALAyeV+Ho/
jlqAvY10yj8RBqbGJIl3CloA6Tgpcvd2Bu6TfqbjcdYchLgN76nsZCBp3af2
wQAzmH599YajKAOZytrHX3WZQn12iH2UOAPXdDr26G82hchrOZerJRiY3iK5
T93MBKwZzdofpRio5R9o/qjiMpwSHqZx7WXgCz3yvkP8l0Hgy+LxAzIMDDPz
9Xzzxgg+P9lwQPsAA3U+xqy9lnQJqu7tE71+kIHeCiVi6x0NIeQ8ZVPSYQb+
qle7ZMIwAPM9RpytR4n+ZsmDDJmLcOynx9KUPAM3Cq6mhmzRB972sK8bjhH4
5p7jZue9AB+j80YUlIjno+3pDuvPQ4Vla6/hSQayjbQvJAvoQaDCSKvvaQYe
1P723VJcF4w5lyqzkYHyn7jWBivpgNyAQP5zEgOHN6Rs+XBRG9Zm7k/6QWHg
AbMh/gN+WjB8lRa+lc5AM8X5tcplmlBCvXwXVRjIT3HjejalAf6bb1yzPMPA
eNtdI3V7NeDieITtAzUG5vfz6/8ZOQcHywuMStUZWOC+Xtrthhpw3G3XfK3J
wL1XfeLvip+F1zofKcvaDPydcnX980FVyJf4oyihx0CH6ymDX+NUwOeHoIzq
BQb6x0i4+FozQK9FdqfTRQauNHz2OESmw75IxsZoQwZuNyxqjNtLgxUzU44a
I0KP1otuptuo0HfU6+fHywzcNuq66ZAwBbJXR09xmTHwMbdrQM4uMnj1FQ0f
sGBgf+h3JY/DJNBM6+zRtmLgDWE/frKaMki5fmq+bsNAPfZ9NytdEH6T/lUk
2RJ4znfv5iYDPBfYkttqz0CBwrhfeaWnIG30UOK0IwNB6Ztk1dGTcK1UNXSj
CwM7SufKY1qV4KyvuZ+iG9GfRMLWfKvjIKZ1y/2SOwPHryUomIocgwWxWBu/
awwcsHAzlx5SANZ/JYY5Nxj4hbfa0ylHHh41PlN/4cXApk8F/UX+cuAaNk5a
uMXA6dfbVI2djwLDZEV+mw8DXZfrjv+xPgLbD4vsVfZjYKDWFr/V9ofhP7aj
263uMv73/0n+b/z/AGc6MBc=
      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"\"", TraditionalForm]},
  AxesOrigin->{36., 0},
  ImageSize->{680., Automatic},
  Method->{},
  PlotLabel->FormBox[
   "\"Smoothed Histogram of Sample Values : Sysstat\\n(Probability \
Distribution Function)\"", TraditionalForm],
  PlotRange->{{35.53178930677234, 49.04220917215742}, {0, 0.2050655159908476}},
  PlotRangeClipping->True,
  PlotRangePadding->Scaled[0.02]]], "Output",
 CellChangeTimes->{
  3.530370970350786*^9, 3.530371193467195*^9, 3.53037128235537*^9, 
   3.5303713670898952`*^9, 3.530371464463482*^9, 3.530371829066883*^9, 
   3.530372611362261*^9, 3.530393601896793*^9, 3.530394130470519*^9, {
   3.5303944963024673`*^9, 3.5303945222734737`*^9}, 3.5303945870415373`*^9, 
   3.5303952095724993`*^9, 3.5303963142156553`*^9, 3.530455428067252*^9, 
   3.530455467394712*^9, 3.530469238698297*^9, 3.530469281286817*^9, 
   3.530469430453369*^9, 3.5304695602937183`*^9, 3.530470245311763*^9, 
   3.536334926838644*^9, 3.536335718919424*^9, {3.536336625505869*^9, 
   3.5363366510603437`*^9}, 3.5363370232800713`*^9, {3.5363370993025703`*^9, 
   3.536337117650896*^9}, 3.536337288587038*^9, 3.536337558052737*^9, 
   3.5363376448261223`*^9, 3.536339086046122*^9, 3.536339944737526*^9, 
   3.536341172213355*^9, 3.536341228061922*^9, 3.536341447016457*^9, 
   3.536341961861414*^9, 3.536342024602624*^9, 3.536342551377861*^9, 
   3.536342659196598*^9, 3.5363428256828203`*^9, 3.5546400540351954`*^9, 
   3.554640184135667*^9, 3.589205779961376*^9, 3.5892081209956627`*^9, 
   3.589208395840897*^9, 3.5892085894009438`*^9, 3.590143673568356*^9}]
}, Open  ]],

Cell["\<\
Below is a standard histogram but with the bin size set to 0.250. This is \
only  useful when the sample values range below 1.0, such as when sampling \
SQL statements (we all hope). Sample sets with large sample values will \
likely not result in a plot.\
\>", "Text",
 CellChangeTimes->{{3.530394064793583*^9, 3.530394112412057*^9}, {
  3.5303946066852083`*^9, 3.530394653134197*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histStndSmallBin1", "\[IndentingNewLine]", \
"histStndSmallBin2"}], "Input",
 CellChangeTimes->{{3.589205791242793*^9, 3.5892057959677134`*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.588]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.588]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{27., 0}, {27.25, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.499999999999886`, 32.06902761104436}, {
         143.58901662578594`, 189.77937358744006`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{30.75, 0}, {31., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{123.03541416566623`, 130.6044417767106}, {
         143.58901662578594`, 189.77937358744006`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{36.75, 0}, {37., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{280.69207683073216`, 288.26110444177664`}, {
         143.58901662578594`, 189.77937358744006`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38.25, 0}, {38.5, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{320.1062424969987, 327.67527010804315`}, {
         143.58901662578594`, 189.77937358744006`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38.5, 0}, {38.75, 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{326.67527010804315`, 334.2442977190875}, {
         98.39865966413183, 189.77937358744006`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38.75, 0}, {39., 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{333.2442977190875, 340.813325330132}, {
         98.39865966413183, 189.77937358744006`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{39., 0}, {39.25, 3}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{339.813325330132, 347.38235294117646`}, {
         53.20830270247771, 189.77937358744006`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{39.25, 0}, {39.5, 7}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{346.38235294117646`, 
         353.9513805522207}, {-127.55312514413876`, 189.77937358744006`}}],
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{39.5, 0}, {39.75, 3}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{352.9513805522207, 360.5204081632652}, {
         53.20830270247771, 189.77937358744006`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{39.75, 0}, {40., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{359.5204081632652, 367.08943577430966`}, {
         143.58901662578594`, 189.77937358744006`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40., 0}, {40.25, 3}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{366.08943577430966`, 373.6584633853539}, {
         53.20830270247771, 189.77937358744006`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40.25, 0}, {40.5, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{372.6584633853539, 380.2274909963984}, {
         143.58901662578594`, 189.77937358744006`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40.5, 0}, {40.75, 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{379.2274909963984, 386.79651860744286`}, {
         98.39865966413183, 189.77937358744006`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{41., 0}, {41.25, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{392.36554621848734`, 399.9345738295316}, {
         143.58901662578594`, 189.77937358744006`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{41.5, 0}, {41.75, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{405.50360144057606`, 413.07262905162054`}, {
         143.58901662578594`, 189.77937358744006`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{48., 0}, {48.25, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{576.2983193277308, 583.8673469387753}, {
         143.58901662578594`, 189.77937358744006`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{27., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{665., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\\nbin size 0.250\"", 
    TraditionalForm],
  PlotRange->{{27., 48.25}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.530394118277979*^9, 3.530394130657009*^9}, {
   3.5303944964881496`*^9, 3.5303945224641848`*^9}, 3.530394587236465*^9, 
   3.5303952099682217`*^9, 3.530396314270275*^9, 3.530455428139687*^9, 
   3.530455467450446*^9, 3.530469238976469*^9, 3.5304692814840517`*^9, 
   3.5304694306369123`*^9, 3.5304695604920893`*^9, 3.530470245528013*^9, 
   3.536334927030675*^9, 3.536335719117712*^9, {3.536336625672222*^9, 
   3.536336651228236*^9}, 3.536337023459778*^9, {3.536337099443101*^9, 
   3.536337117800517*^9}, 3.536337288758793*^9, 3.536337558225767*^9, 
   3.5363376450286922`*^9, 3.536339086235671*^9, 3.5363399449861813`*^9, 
   3.536341172412774*^9, 3.5363412282310743`*^9, 3.536341447249112*^9, 
   3.5363419620807743`*^9, 3.536342024852913*^9, 3.53634255157006*^9, 
   3.536342659360385*^9, 3.536342825891924*^9, 3.554640054119725*^9, 
   3.554640184196095*^9, 3.589205797030332*^9, 3.589208121045702*^9, 
   3.589208395889303*^9, 3.5892085894618073`*^9, 3.590143673612688*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.567]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.567]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38., 0}, {38.25, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.500000000000455`, 41.45335276967944}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38.5, 0}, {38.75, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{56.40670553935888, 73.36005830903832}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{38.75, 0}, {39., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{72.36005830903832, 89.31341107871731}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{39.25, 0}, {39.5, 5}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{104.26676384839675`, 
         121.22011661807619`}, {-127.55312514413879`, 189.77937358743992`}}],
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40., 0}, {40.25, 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{152.12682215743462`, 169.08017492711406`}, {
         62.246374094808445`, 189.77937358743992`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40.25, 0}, {40.5, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{168.08017492711406`, 185.0335276967935}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40.5, 0}, {40.75, 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{184.0335276967935, 200.98688046647248`}, {
         62.246374094808445`, 189.77937358743992`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40.75, 0}, {41., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{199.98688046647248`, 216.94023323615193`}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{41., 0}, {41.25, 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{215.94023323615193`, 232.89358600583137`}, {
         62.246374094808445`, 189.77937358743992`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{41.25, 0}, {41.5, 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{231.89358600583137`, 248.84693877551035`}, {
         62.246374094808445`, 189.77937358743992`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{41.5, 0}, {41.75, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{247.84693877551035`, 264.8002915451898}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{41.75, 0}, {42., 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{263.8002915451898, 280.75364431486923`}, {
         62.246374094808445`, 189.77937358743992`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{42., 0}, {42.25, 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{279.75364431486923`, 296.7069970845487}, {
         62.246374094808445`, 189.77937358743992`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{42.25, 0}, {42.5, 3}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{295.7069970845487, 
         312.66034985422766`}, {-1.0201256515072998`, 189.77937358743992`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{42.5, 0}, {42.75, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{311.66034985422766`, 328.6137026239071}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{42.75, 0}, {43., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{327.6137026239071, 344.56705539358654`}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{44., 0}, {44.25, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{407.3804664723034, 424.33381924198284`}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{45.5, 0}, {45.75, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{503.1005830903796, 520.0539358600586}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{46.5, 0}, {46.75, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{566.9139941690964, 583.8673469387759}, {
         125.51287384112419`, 189.77937358743992`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{38., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{665., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\\nnbin size 0.250\"", 
    TraditionalForm],
  PlotRange->{{38., 46.75}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.530394118277979*^9, 3.530394130657009*^9}, {
   3.5303944964881496`*^9, 3.5303945224641848`*^9}, 3.530394587236465*^9, 
   3.5303952099682217`*^9, 3.530396314270275*^9, 3.530455428139687*^9, 
   3.530455467450446*^9, 3.530469238976469*^9, 3.5304692814840517`*^9, 
   3.5304694306369123`*^9, 3.5304695604920893`*^9, 3.530470245528013*^9, 
   3.536334927030675*^9, 3.536335719117712*^9, {3.536336625672222*^9, 
   3.536336651228236*^9}, 3.536337023459778*^9, {3.536337099443101*^9, 
   3.536337117800517*^9}, 3.536337288758793*^9, 3.536337558225767*^9, 
   3.5363376450286922`*^9, 3.536339086235671*^9, 3.5363399449861813`*^9, 
   3.536341172412774*^9, 3.5363412282310743`*^9, 3.536341447249112*^9, 
   3.5363419620807743`*^9, 3.536342024852913*^9, 3.53634255157006*^9, 
   3.536342659360385*^9, 3.536342825891924*^9, 3.554640054119725*^9, 
   3.554640184196095*^9, 3.589205797030332*^9, 3.589208121045702*^9, 
   3.589208395889303*^9, 3.5892085894618073`*^9, 
   3.590143673631672*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Compare the two sample sets", "Subtitle",
 CellChangeTimes->{{3.530372627959633*^9, 3.5303726359771557`*^9}, {
  3.5892058898178453`*^9, 3.589205894346086*^9}}],

Cell[TextData[{
 "Below are the statisitcal tests to compare both numerically and visually \
the two sample sets. A simple t-test can be used IF both sample sets are \
normally distributed. (If their respective p-values are > 0.05 then we\
\[CloseCurlyQuote]ll say they are normally distribugted.) If either sample \
set is not normally distributed we must use a location equivilency test. I\
\[CloseCurlyQuote]ll let ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " pick location test to use.\n\nI also included a straight difference \
calculation, in both value and percentage. Why? Just because there is a \
statistical difference does not mean we will feel or notice the difference. \
Knowing the difference can help us determine if a statistical difference \
makes a truly impactful difference."
}], "Text",
 CellChangeTimes->{{3.530394064793583*^9, 3.530394112412057*^9}, {
  3.5303946066852083`*^9, 3.530394653134197*^9}, {3.5892058985878572`*^9, 
  3.589206031021261*^9}, {3.589207928224084*^9, 3.5892080284688168`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SmoothHistogram", "[", 
  RowBox[{"{", 
   RowBox[{"sampleSetGood1", ",", "sampleSetGood2"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.589206283027914*^9, 3.589206290742743*^9}, {
   3.5892070464497757`*^9, 3.589207111663759*^9}, 3.589207230138959*^9, {
   3.589207339346648*^9, 3.589207420942032*^9}, {3.5892074825892687`*^9, 
   3.589207513143084*^9}, {3.589207569068672*^9, 3.5892075978794193`*^9}, {
   3.5892076624448557`*^9, 3.589207664792069*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxdm3c81u/3+Jv2JpVU2sNeWbfXde7lvo1k75W0VEbZ2UmFJCF7j0ohoUj2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      "]]}, 
    {RGBColor[0.6, 0.24, 0.4428931686004542], LineBox[CompressedData["
1:eJxFe3c0l3/YvyRSRkmiiZBSWkZpXJfPpmQrEdlkj6iojFJI9vyQvTeR7D0+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      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{30., 0},
  ImageSize->{567.890625, Automatic},
  Method->{},
  PlotRange->{{25.55995364744892, 
   49.66004635255108}, {-5.866202770409336*^-17, 0.5008266645814731}},
  PlotRangeClipping->True,
  PlotRangePadding->Scaled[0.02]]], "Output",
 CellChangeTimes->{{3.5892070983167477`*^9, 3.589207112714263*^9}, {
   3.589207393627255*^9, 3.589207422348392*^9}, {3.589207507694421*^9, 
   3.5892075139378643`*^9}, 3.589207573266075*^9, 3.589207665970436*^9, 
   3.589208121194585*^9, 3.589208396041711*^9, 3.589208589637158*^9, 
   3.590143673859087*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pValueTT", "=", 
  RowBox[{"TTest", "[", 
   RowBox[{"{", 
    RowBox[{"sampleSetGood1", ",", "sampleSetGood2"}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.58920767306666*^9, 3.589207674119499*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"TTest", "::", "nortst"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"At least one of the p-values in \[NoBreak]\\!\\({0, \
0.4691085242165312`}\\)\[NoBreak], resulting from a test for normality, is \
below \[NoBreak]\\!\\(0.025`\\)\[NoBreak]. The tests in \
\[NoBreak]\\!\\({\\\"T\\\"}\\)\[NoBreak] require that the data is normally \
distributed. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/TTest\\\", ButtonNote -> \\\"TTest::nortst\\\"]\\)\
\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.589208396122691*^9, 3.5892085897147303`*^9, 
  3.590143673935596*^9}],

Cell[BoxData["0.0027953547963985694`"], "Output",
 CellChangeTimes->{3.589207675276827*^9, 3.589208121214479*^9, 
  3.5892083961531897`*^9, 3.58920858973499*^9, 3.590143673944273*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pValueLet", "=", 
  RowBox[{"LocationEquivalenceTest", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sampleSetGood1", ",", "sampleSetGood2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<TestDataTable\>\"", ",", "\"\<AutomaticTest\>\""}], "}"}]}],
    "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   StyleBox[
    TagBox[GridBox[{
       {"\<\"\"\>", "\<\"Statistic\"\>", "\<\"P\[Hyphen]Value\"\>"},
       {"\<\"Kruskal\[Hyphen]Wallis\"\>", "15.264271927002628`", 
        "0.000034728671093537454`"}
      },
      AutoDelete->False,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
      GridBoxDividers->{
       "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
        "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
      GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Grid"], "DialogStyle",
    StripOnInput->False], ",", "\<\"KruskalWallis\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.589207678048285*^9, 3.5892081212448597`*^9, 
  3.58920839623752*^9, 3.58920858977276*^9, 3.590143673976412*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"medDiff", "=", 
  RowBox[{"Abs", "[", 
   RowBox[{
    RowBox[{"Median", "[", "sampleSetGood1", "]"}], "-", 
    RowBox[{"Median", "[", "sampleSetGood2", "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"medDiff", "/", 
  RowBox[{"Median", "[", "sampleSetGood1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"medDiff", "/", 
  RowBox[{"Median", "[", "sampleSetGood2", "]"}]}]}], "Input",
 CellChangeTimes->{{3.589207684922118*^9, 3.589207752846141*^9}, {
  3.589207796653734*^9, 3.589207801233642*^9}, {3.589207882832284*^9, 
  3.589207891400839*^9}}],

Cell[BoxData["1.8547300000000035`"], "Output",
 CellChangeTimes->{3.589207754213632*^9, 3.58920789234379*^9, 
  3.589208121279024*^9, 3.589208396324522*^9, 3.5892085898066597`*^9, 
  3.590143674052651*^9}],

Cell[BoxData["0.04712220528455294`"], "Output",
 CellChangeTimes->{3.589207754213632*^9, 3.58920789234379*^9, 
  3.589208121279024*^9, 3.589208396324522*^9, 3.5892085898066597`*^9, 
  3.5901436740536823`*^9}],

Cell[BoxData["0.045001629271864775`"], "Output",
 CellChangeTimes->{3.589207754213632*^9, 3.58920789234379*^9, 
  3.589208121279024*^9, 3.589208396324522*^9, 3.5892085898066597`*^9, 
  3.590143674054484*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{825, 1046},
WindowMargins->{{Automatic, 38}, {Automatic, 36}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, \
2013)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 293, 7, 131, "Title"],
Cell[718, 24, 208, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[951, 33, 98, 1, 22, "Subtitle"],
Cell[1052, 36, 607, 10, 101, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1696, 51, 101, 1, 22, "Subtitle"],
Cell[1800, 54, 504, 8, 83, "Text"],
Cell[2307, 64, 3622, 65, 260, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5966, 134, 114, 1, 22, "Subtitle"],
Cell[6083, 137, 1179, 29, 227, "Text"],
Cell[CellGroupData[{
Cell[7287, 170, 8709, 212, 804, "Input"],
Cell[15999, 384, 672, 13, 24, "Message"],
Cell[16674, 399, 2652, 55, 279, "Output"]
}, Open  ]],
Cell[19341, 457, 124, 2, 29, "Text"],
Cell[CellGroupData[{
Cell[19490, 463, 8855, 214, 804, "Input"],
Cell[28348, 679, 747, 14, 24, "Message"],
Cell[29098, 695, 1664, 40, 279, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[30811, 741, 160, 2, 22, "Subtitle"],
Cell[30974, 745, 260, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[31259, 754, 5560, 143, 634, "Input"],
Cell[36822, 899, 251, 4, 21, "Print"]
}, Open  ]],
Cell[37088, 906, 252, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[37365, 915, 285, 3, 56, "Input"],
Cell[37653, 920, 5545, 145, 425, "Output"],
Cell[43201, 1067, 5554, 145, 425, "Output"]
}, Open  ]],
Cell[48770, 1215, 343, 6, 47, "Text"],
Cell[CellGroupData[{
Cell[49138, 1225, 186, 2, 56, "Input"],
Cell[49327, 1229, 5225, 141, 440, "Output"],
Cell[54555, 1372, 5233, 141, 440, "Output"]
}, Open  ]],
Cell[59803, 1516, 419, 7, 65, "Text"],
Cell[CellGroupData[{
Cell[60247, 1527, 190, 2, 56, "Input"],
Cell[60440, 1531, 5687, 146, 445, "Output"],
Cell[66130, 1679, 5704, 146, 445, "Output"]
}, Open  ]],
Cell[71849, 1828, 634, 10, 83, "Text"],
Cell[CellGroupData[{
Cell[72508, 1842, 206, 3, 56, "Input"],
Cell[72717, 1847, 20366, 339, 452, "Output"],
Cell[93086, 2188, 18534, 308, 452, "Output"]
}, Open  ]],
Cell[111635, 2499, 396, 7, 65, "Text"],
Cell[CellGroupData[{
Cell[112056, 2510, 159, 2, 56, "Input"],
Cell[112218, 2514, 12140, 358, 435, "Output"],
Cell[124361, 2874, 23733, 578, 435, 13088, 404, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[148143, 3458, 166, 2, 22, "Subtitle"],
Cell[148312, 3462, 1034, 17, 155, "Text"],
Cell[CellGroupData[{
Cell[149371, 3483, 483, 8, 38, "Input"],
Cell[149857, 3493, 36073, 598, 416, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[185967, 4096, 232, 6, 38, "Input"],
Cell[186202, 4104, 692, 14, 42, "Message"],
Cell[186897, 4120, 183, 2, 38, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[187117, 4127, 303, 8, 56, "Input"],
Cell[187423, 4137, 878, 20, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[188338, 4162, 579, 13, 73, "Input"],
Cell[188920, 4177, 205, 3, 38, "Output"],
Cell[189128, 4182, 208, 3, 38, "Output"],
Cell[189339, 4187, 207, 3, 38, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

