(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[    150800,       3216]
NotebookOptionsPosition[    147550,       3105]
NotebookOutlinePosition[    148032,       3124]
CellTagsIndexPosition[    147989,       3121]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Workload: Mixed 

Compare Sample Sets Statistical Analysis\
\>", "Title",
 CellChangeTimes->{{3.5303688333633947`*^9, 3.530368837704206*^9}, {
  3.58920804668637*^9, 3.589208062499321*^9}, {3.5892083459567137`*^9, 
  3.589208363818766*^9}}],

Cell["\<\
version 1a, 26-Sep-2013
author: Craig Shallahamer, craig@orapub.com\
\>", "Text",
 CellChangeTimes->{{3.530374180214813*^9, 3.530374223504505*^9}, {
  3.589208065031522*^9, 3.5892080829739857`*^9}}],

Cell[CellGroupData[{

Cell["Introduction", "Subtitle",
 CellChangeTimes->{{3.530374242866493*^9, 3.530374244484584*^9}}],

Cell["\<\
It\[CloseCurlyQuote]s difficult for us humans to aborb and grasp more than \
just a few values. Statistics provides us with a way to grasp complexity by \
simplifying or abstracting. As Oracle performance specialist, we typically \
have a large number of numeric samples, comprising our sample set.

This notepad analyze two samples and then statisticall compares them.\
\>", "Text",
 CellChangeTimes->{{3.530368849609161*^9, 3.530368851374548*^9}, {
  3.530370187776986*^9, 3.530370232698889*^9}, {3.5303740416976213`*^9, 
  3.530374137913013*^9}, {3.589197070039434*^9, 3.5891970910170927`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sample values", "Subtitle",
 CellChangeTimes->{{3.5303742624633904`*^9, 3.530374264105083*^9}}],

Cell["\<\
Enter your sample values; seperated by commas and the entire set enclosed in \
braces. Usually you can simply copy and paste the values directly into the \
notebook; which usually removes any line feeds or returns.
It is common to not consider all sample vaues. Below you can specify \
threshholds for the minimum and maximum values to run through the analysis.\
\>", "Text",
 CellChangeTimes->{{3.530374267526122*^9, 3.5303743523403177`*^9}, {
  3.530454126353104*^9, 3.5304541854582357`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cutoffMin", "=", 
   RowBox[{"-", "1.0"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cutoffMax", "=", "9999.0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSysstat", "=", 
   RowBox[{"{", 
    RowBox[{
    "481.85", ",", "475.82", ",", "476.88", ",", "475.57", ",", "482.67", ",",
      "475.35", ",", "474.56", ",", "480.53", ",", "479.02", ",", "487.38", 
     ",", "476.27", ",", "474.79", ",", "475.5", ",", "479.35", ",", "476.14",
      ",", "473.4", ",", "474.12", ",", "472.08", ",", "478.1", ",", "474.29",
      ",", "480.26", ",", "481.24", ",", "477.31", ",", "476.68", ",", 
     "482.31", ",", "475.61", ",", "474.73", ",", "483.72", ",", "473.2", ",",
      "473.66", ",", "472.15"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleTimeModel", "=", 
   RowBox[{"{", 
    RowBox[{
    "526.17701", ",", "511.961172", ",", "517.199373", ",", "522.195609", ",",
      "521.490723", ",", "516.601465", ",", "518.036242", ",", "520.724838", 
     ",", "519.662995", ",", "528.518651", ",", "518.117236", ",", 
     "519.045091", ",", "515.726599", ",", "516.331501", ",", "519.010098", 
     ",", "512.955017", ",", "519.340048", ",", "512.06815", ",", 
     "517.938263", ",", "515.495629", ",", "522.695539", ",", "523.968344", 
     ",", "518.9961", ",", "519.867964", ",", "518.858122", ",", "518.570164",
      ",", "516.67345", ",", "525.739073", ",", "513.942872", ",", 
     "513.51393", ",", "512.585072"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetName1", "=", "\"\<Sysstat\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetName2", "=", "\"\<Time Model\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetRaw1", "=", "sampleSysstat"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetRaw2", "=", "sampleTimeModel"}], ";"}]}], "Input",
 CellChangeTimes->{{3.530368865010776*^9, 3.530368867417789*^9}, {
   3.5303689610885572`*^9, 3.530368963522463*^9}, 3.53036900548626*^9, {
   3.530369051420986*^9, 3.530369055243724*^9}, 3.5303714491074944`*^9, 
   3.5303935569531603`*^9, 3.530393588071438*^9, 3.530395180906042*^9, {
   3.530395563209477*^9, 3.530395567665958*^9}, {3.53039594405702*^9, 
   3.530395970436448*^9}, {3.53039607694536*^9, 3.530396146173196*^9}, {
   3.5303962265654697`*^9, 3.530396276110527*^9}, {3.530454018294681*^9, 
   3.5304540216285553`*^9}, {3.5304540980484447`*^9, 
   3.5304541088959084`*^9}, {3.530455451196604*^9, 3.530455451340207*^9}, {
   3.530469015209696*^9, 3.530469015650317*^9}, {3.530469268622115*^9, 
   3.530469268961523*^9}, {3.530469420949239*^9, 3.5304694211293507`*^9}, {
   3.530469546115999*^9, 3.530469546306059*^9}, {3.536336607077544*^9, 
   3.536336646173242*^9}, {3.536337012448007*^9, 3.536337013976362*^9}, {
   3.536337083468281*^9, 3.53633711309508*^9}, {3.536337279867556*^9, 
   3.536337282289822*^9}, {3.536337529501505*^9, 3.53633755196574*^9}, {
   3.5363376242524033`*^9, 3.536337634992538*^9}, {3.536342543724098*^9, 
   3.536342545446476*^9}, {3.536342651050959*^9, 3.53634265379499*^9}, {
   3.536342820072816*^9, 3.536342820372504*^9}, {3.536347444335575*^9, 
   3.536347526036746*^9}, {3.554639963802973*^9, 3.554639974880636*^9}, {
   3.589197097899551*^9, 3.589197108699297*^9}, {3.589204287151061*^9, 
   3.589204342261038*^9}, {3.5892044312058887`*^9, 3.58920446620074*^9}, {
   3.589204521778823*^9, 3.589204564969947*^9}, {3.589204969473914*^9, 
   3.589204970399848*^9}, {3.589205297076652*^9, 3.5892053183576202`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic Numeric Statistics", "Subtitle",
 CellChangeTimes->{{3.5303944048152018`*^9, 3.5303944108075037`*^9}}],

Cell[TextData[{
 "The basic numeric statistics shown are:\n\n",
 StyleBox["First five values",
  FontWeight->"Bold"],
 " simply lists the first five values of your sample set. Use this to check \
the data being used is what you think.\n",
 StyleBox["Number of samples ",
  FontWeight->"Bold"],
 "is in fact the number of samples. Use this to check the data has been \
entered correctly.\n",
 StyleBox["Average",
  FontWeight->"Bold"],
 " is the statistical mean.\n",
 StyleBox["Median",
  FontWeight->"Bold"],
 " is the middle value after all the values are sorted. This is also the \
50-percentile value.\n",
 StyleBox["Standard deviation",
  FontWeight->"Bold"],
 " is a measure of dispersion and is particularly valuable when the \
distribution is normal.\n",
 StyleBox["P-Value",
  FontWeight->"Bold"],
 " is a measure of contrast. In this instance, we are constrasting the sample \
set to the normal distribution. Loosely speaking, if the P-Value is greater \
than 0.05 then our sample set is likely to be normally distributed.\n\nSample \
Set #1"
}], "Text",
 CellChangeTimes->{{3.530394428636175*^9, 3.530394432641831*^9}, {
  3.589204580775587*^9, 3.589204586298441*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"sampleSetGood1", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetBad1", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw1", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[LessEqual]", "cutoffMax"}], 
          ")"}], "&&", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw1", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[GreaterEqual]", "cutoffMin"}], 
          ")"}]}], ")"}], ",", "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetGood1", ",", 
         RowBox[{"sampleSetRaw1", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetBad1", ",", 
         RowBox[{"sampleSetRaw1", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}]}], 
      "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "sampleSetRaw1", "]"}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countRaw", "=", 
   RowBox[{"Length", "[", "sampleSetRaw1", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countGood", "=", 
   RowBox[{"Length", "[", "sampleSetGood1", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"countBad", "=", 
    RowBox[{"Length", "[", "sampleSetBad1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveRaw", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetRaw1", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveGood", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetGood1", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstFiveBad", "=", 
    RowBox[{"Take", "[", 
     RowBox[{"sampleSetBad1", ",", "5"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"avg", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Mean", "[", "sampleSetGood1", "]"}], "]"}], ",", "0.00010"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"med", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Median", "[", "sampleSetGood1", "]"}], "]"}], ",", "0.00010"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"std", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"StandardDeviation", "[", "sampleSetGood1", "]"}], "]"}], ",", 
     "0.0010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pValue", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"DistributionFitTest", "[", "sampleSetGood1", "]"}], "]"}], ",",
      "0.0000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct90", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood1", ",", "0.90"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct95", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood1", ",", "0.95"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct99", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood1", ",", "0.99"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"maxV", "=", 
    RowBox[{"Max", "[", "sampleSetGood1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Statistics for Sample Set : \>\"", "<>", " ", "sampleSetName1", 
       "<>", "\"\<\\n\>\""}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of total samples\>\"", ",", "countRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of good samples\>\"", ",", "countGood"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of bad samples\>\"", ",", "countBad"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five raw samples\>\"", ",", "firstFiveRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five good samples\>\"", ",", "firstFiveGood"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five bad samples\>\"", ",", "firstFiveBad"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Good Sample Details\>\"", ",", "\"\<---\>\""}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Average\>\"", ",", "avg"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Median (50%-tile)\>\"", ",", "med"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Maximum\>\"", ",", "maxV"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Percentiles (90,95,99)\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"pct90", ",", "pct95", ",", "pct99"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Standard deviation\>\"", ",", "std"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  P-Value\>\"", ",", "pValue"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Alignment", "\[Rule]", 
      RowBox[{"{", "Left", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "None"}]}], "}"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.530368968593367*^9, 3.530368989268654*^9}, {
   3.5303690965356617`*^9, 3.530369118240787*^9}, {3.530369171410687*^9, 
   3.530369303558567*^9}, {3.5303693351682587`*^9, 3.530369427422378*^9}, {
   3.530369480374955*^9, 3.530369533827389*^9}, {3.5303695650243883`*^9, 
   3.530369579388669*^9}, {3.530369631285817*^9, 3.530369645933391*^9}, {
   3.5303696896422977`*^9, 3.530369697771058*^9}, {3.5303698401340857`*^9, 
   3.5303698459914103`*^9}, 3.530370326490252*^9, {3.530370541055084*^9, 
   3.530370549806651*^9}, {3.5303707096253843`*^9, 3.53037072436871*^9}, {
   3.530370842710359*^9, 3.53037084944149*^9}, {3.530370926582889*^9, 
   3.530370935884305*^9}, {3.530370995403738*^9, 3.530371021568015*^9}, {
   3.5303711315654488`*^9, 3.530371144348104*^9}, {3.530371233252054*^9, 
   3.530371273780658*^9}, {3.5303713101522007`*^9, 3.530371381300761*^9}, {
   3.5303716525945873`*^9, 3.53037169323724*^9}, {3.530371769719269*^9, 
   3.530371781099001*^9}, {3.530371832466179*^9, 3.5303718351591873`*^9}, {
   3.5303936674882107`*^9, 3.53039369987022*^9}, {3.5303937319628277`*^9, 
   3.530393732302782*^9}, {3.530393990173481*^9, 3.5303940515857983`*^9}, {
   3.5303944806938047`*^9, 3.5303944813726587`*^9}, {3.530394513548739*^9, 
   3.530394513933091*^9}, {3.530395584184815*^9, 3.530395665139804*^9}, {
   3.53039573123534*^9, 3.530395770072953*^9}, {3.530395866646319*^9, 
   3.530395866732829*^9}, {3.530395977045204*^9, 3.530395977999033*^9}, 
   3.530396011906796*^9, {3.5303961568553247`*^9, 3.530396185139888*^9}, {
   3.530396295140654*^9, 3.530396297581646*^9}, {3.530396342740769*^9, 
   3.530396401087904*^9}, {3.530396447078868*^9, 3.530396508850835*^9}, {
   3.5303965432221127`*^9, 3.5303967135104313`*^9}, {3.530453988732895*^9, 
   3.530454012634718*^9}, {3.5304540493515*^9, 3.530454071670485*^9}, {
   3.530454118686286*^9, 3.530454120084098*^9}, {3.5304549689805393`*^9, 
   3.530454973039502*^9}, {3.5304551150546083`*^9, 3.530455381038809*^9}, 
   3.5304554947173357`*^9, {3.530469054226564*^9, 3.530469095504678*^9}, {
   3.530469132177784*^9, 3.530469169752913*^9}, {3.589204591684404*^9, 
   3.589204640892511*^9}, {3.589204703982668*^9, 3.58920472726952*^9}, {
   3.5892047706716557`*^9, 3.589204803477298*^9}, {3.589205455713531*^9, 
   3.589205471673032*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Take", "::", "take"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Cannot take positions \[NoBreak]\\!\\(1\\)\[NoBreak] \
through \[NoBreak]\\!\\(5\\)\[NoBreak] in \[NoBreak]\\!\\({}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Take/take\\\", \
ButtonNote -> \\\"Take::take\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.5892047291486473`*^9, {3.589204790418169*^9, 3.5892048045433617`*^9}, 
   3.5892054739477663`*^9, 3.589208119639461*^9, 3.5892096085255632`*^9, 
   3.59014554537597*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Statistics for Sample Set : Sysstat\\n\"\>", ""},
    {"\<\"Number of total samples\"\>", "31"},
    {"\<\"Number of good samples\"\>", "31"},
    {"\<\"Number of bad samples\"\>", "0"},
    {"\<\"First five raw samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "481.85`", ",", "475.82`", ",", "476.88`", ",", "475.57`", ",", 
       "482.67`"}], "}"}]},
    {"\<\"First five good samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "481.85`", ",", "475.82`", ",", "476.88`", ",", "475.57`", ",", 
       "482.67`"}], "}"}]},
    {"\<\"First five bad samples\"\>", 
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "5"}], "]"}]},
    {"\<\"Good Sample Details\"\>", "\<\"---\"\>"},
    {"\<\"  Average\"\>", "477.2432`"},
    {"\<\"  Median (50%-tile)\"\>", "476.14000000000004`"},
    {"\<\"  Maximum\"\>", "487.38`"},
    {"\<\"  Percentiles (90,95,99)\"\>", 
     RowBox[{"{", 
      RowBox[{
      "482.31000000000006`", ",", "483.72`", ",", "487.38000000000005`"}], 
      "}"}]},
    {"\<\"  Standard deviation\"\>", "3.726`"},
    {"\<\"  P-Value\"\>", "0.026386999999999997`"}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> None, "Rows" -> None},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.5303957883159657`*^9, 3.530395873878767*^9, {3.53039598031126*^9, 
   3.530395989224454*^9}, {3.530396163546875*^9, 3.5303961872839327`*^9}, 
   3.530396313304497*^9, {3.53039649481763*^9, 3.530396510875143*^9}, 
   3.5304554272825623`*^9, 3.530455466660076*^9, 3.530455497552189*^9, 
   3.530469028806366*^9, {3.530469060709507*^9, 3.530469096893461*^9}, {
   3.530469153086173*^9, 3.530469171493932*^9}, 3.530469231345664*^9, 
   3.530469273461467*^9, 3.530469426901936*^9, 3.530469552359798*^9, 
   3.530470236790164*^9, 3.536334923158784*^9, 3.5363357149452477`*^9, {
   3.536336624039689*^9, 3.536336650435875*^9}, 3.536337022777419*^9, {
   3.5363370987121067`*^9, 3.536337117024104*^9}, 3.536337287258542*^9, 
   3.536337556724328*^9, 3.536337644127635*^9, 3.5363390853670797`*^9, 
   3.536339943574079*^9, 3.5363411707911367`*^9, 3.5363412270341997`*^9, 
   3.5363414456773653`*^9, 3.5363419606031713`*^9, 3.5363420236911917`*^9, 
   3.536342550277603*^9, 3.536342657424079*^9, 3.53634282443299*^9, 
   3.554639986040378*^9, 3.5546400537141542`*^9, 3.554640183673815*^9, {
   3.5892046928575487`*^9, 3.5892047291750727`*^9}, {3.5892047904579*^9, 
   3.58920480457402*^9}, 3.58920547398158*^9, 3.589208119779434*^9, 
   3.589209608562257*^9, 3.5901455454613743`*^9}]
}, Open  ]],

Cell["Sample Set #2", "Text",
 CellChangeTimes->{
  3.5303945570998573`*^9, {3.589204860147819*^9, 3.5892048626771383`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"sampleSetGood2", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetBad2", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[LessEqual]", "cutoffMax"}], 
          ")"}], "&&", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[GreaterEqual]", "cutoffMin"}], 
          ")"}]}], ")"}], ",", "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetGood2", ",", 
         RowBox[{"sampleSetRaw2", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetBad2", ",", 
         RowBox[{"sampleSetRaw2", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}]}], 
      "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "sampleSetRaw2", "]"}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countRaw", "=", 
   RowBox[{"Length", "[", "sampleSetRaw2", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countGood", "=", 
   RowBox[{"Length", "[", "sampleSetGood2", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"countBad", "=", 
    RowBox[{"Length", "[", "sampleSetBad2", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveRaw", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetRaw2", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveGood", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetGood2", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstFiveBad", "=", 
    RowBox[{"Take", "[", 
     RowBox[{"sampleSetBad2", ",", "5"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"avg", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Mean", "[", "sampleSetGood2", "]"}], "]"}], ",", "0.00010"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"med", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Median", "[", "sampleSetGood2", "]"}], "]"}], ",", "0.00010"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"std", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"StandardDeviation", "[", "sampleSetGood2", "]"}], "]"}], ",", 
     "0.0010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pValue", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"DistributionFitTest", "[", "sampleSetGood2", "]"}], "]"}], ",",
      "0.0000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct90", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood2", ",", "0.90"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct95", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood2", ",", "0.95"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct99", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood2", ",", "0.99"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"maxV", "=", 
    RowBox[{"Max", "[", "sampleSetGood2", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Statistics for Sample Set : \>\"", "<>", " ", "sampleSetName2", 
       "<>", "\"\<\\n\>\""}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of total samples\>\"", ",", "countRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of good samples\>\"", ",", "countGood"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of bad samples\>\"", ",", "countBad"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five raw samples\>\"", ",", "firstFiveRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five good samples\>\"", ",", "firstFiveGood"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five bad samples\>\"", ",", "firstFiveBad"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Good Sample Details\>\"", ",", "\"\<---\>\""}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Average\>\"", ",", "avg"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Median (50%-tile)\>\"", ",", "med"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Maximum\>\"", ",", "maxV"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Percentiles (90,95,99)\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"pct90", ",", "pct95", ",", "pct99"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Standard deviation\>\"", ",", "std"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  P-Value\>\"", ",", "pValue"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Alignment", "\[Rule]", 
      RowBox[{"{", "Left", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "None"}]}], "}"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.530368968593367*^9, 3.530368989268654*^9}, {
   3.5303690965356617`*^9, 3.530369118240787*^9}, {3.530369171410687*^9, 
   3.530369303558567*^9}, {3.5303693351682587`*^9, 3.530369427422378*^9}, {
   3.530369480374955*^9, 3.530369533827389*^9}, {3.5303695650243883`*^9, 
   3.530369579388669*^9}, {3.530369631285817*^9, 3.530369645933391*^9}, {
   3.5303696896422977`*^9, 3.530369697771058*^9}, {3.5303698401340857`*^9, 
   3.5303698459914103`*^9}, 3.530370326490252*^9, {3.530370541055084*^9, 
   3.530370549806651*^9}, {3.5303707096253843`*^9, 3.53037072436871*^9}, {
   3.530370842710359*^9, 3.53037084944149*^9}, {3.530370926582889*^9, 
   3.530370935884305*^9}, {3.530370995403738*^9, 3.530371021568015*^9}, {
   3.5303711315654488`*^9, 3.530371144348104*^9}, {3.530371233252054*^9, 
   3.530371273780658*^9}, {3.5303713101522007`*^9, 3.530371381300761*^9}, {
   3.5303716525945873`*^9, 3.53037169323724*^9}, {3.530371769719269*^9, 
   3.530371781099001*^9}, {3.530371832466179*^9, 3.5303718351591873`*^9}, {
   3.5303936674882107`*^9, 3.53039369987022*^9}, {3.5303937319628277`*^9, 
   3.530393732302782*^9}, {3.530393990173481*^9, 3.5303940515857983`*^9}, {
   3.5303944806938047`*^9, 3.5303944813726587`*^9}, {3.530394513548739*^9, 
   3.530394513933091*^9}, {3.530395584184815*^9, 3.530395665139804*^9}, {
   3.53039573123534*^9, 3.530395770072953*^9}, {3.530395866646319*^9, 
   3.530395866732829*^9}, {3.530395977045204*^9, 3.530395977999033*^9}, 
   3.530396011906796*^9, {3.5303961568553247`*^9, 3.530396185139888*^9}, {
   3.530396295140654*^9, 3.530396297581646*^9}, {3.530396342740769*^9, 
   3.530396401087904*^9}, {3.530396447078868*^9, 3.530396508850835*^9}, {
   3.5303965432221127`*^9, 3.5303967135104313`*^9}, {3.530453988732895*^9, 
   3.530454012634718*^9}, {3.5304540493515*^9, 3.530454071670485*^9}, {
   3.530454118686286*^9, 3.530454120084098*^9}, {3.5304549689805393`*^9, 
   3.530454973039502*^9}, {3.5304551150546083`*^9, 3.530455381038809*^9}, 
   3.5304554947173357`*^9, {3.530469054226564*^9, 3.530469095504678*^9}, {
   3.530469132177784*^9, 3.530469169752913*^9}, {3.589204591684404*^9, 
   3.589204640892511*^9}, {3.589204703982668*^9, 3.58920472726952*^9}, {
   3.5892047706716557`*^9, 3.589204803477298*^9}, {3.589204870548375*^9, 
   3.589204940006817*^9}, {3.589205330358691*^9, 3.589205384684655*^9}, {
   3.589205417371266*^9, 3.589205440519182*^9}, {3.589205484169776*^9, 
   3.589205484247561*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Take", "::", "take"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Cannot take positions \[NoBreak]\\!\\(1\\)\[NoBreak] \
through \[NoBreak]\\!\\(5\\)\[NoBreak] in \[NoBreak]\\!\\({}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Take/take\\\", \
ButtonNote -> \\\"Take::take\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.5892049419449463`*^9, 3.589204978424362*^9, {3.589205343560355*^9, 
   3.5892053616873007`*^9}, {3.5892054218515043`*^9, 3.589205437780459*^9}, 
   3.589205489145903*^9, 3.5892081198103733`*^9, 3.589209608611649*^9, 
   3.590145545502116*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Statistics for Sample Set : Time Model\\n\"\>", ""},
    {"\<\"Number of total samples\"\>", "31"},
    {"\<\"Number of good samples\"\>", "31"},
    {"\<\"Number of bad samples\"\>", "0"},
    {"\<\"First five raw samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "526.17701`", ",", "511.961172`", ",", "517.199373`", ",", 
       "522.195609`", ",", "521.490723`"}], "}"}]},
    {"\<\"First five good samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "526.17701`", ",", "511.961172`", ",", "517.199373`", ",", 
       "522.195609`", ",", "521.490723`"}], "}"}]},
    {"\<\"First five bad samples\"\>", 
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "5"}], "]"}]},
    {"\<\"Good Sample Details\"\>", "\<\"---\"\>"},
    {"\<\"  Average\"\>", "518.5163`"},
    {"\<\"  Median (50%-tile)\"\>", "518.5702`"},
    {"\<\"  Maximum\"\>", "528.518651`"},
    {"\<\"  Percentiles (90,95,99)\"\>", 
     RowBox[{"{", 
      RowBox[{"523.96834`", ",", "526.17701`", ",", "528.5186500000001`"}], 
      "}"}]},
    {"\<\"  Standard deviation\"\>", "4.155`"},
    {"\<\"  P-Value\"\>", "0.530171`"}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> None, "Rows" -> None},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.589204942302164*^9, 3.589204978468814*^9, {3.589205343595798*^9, 
   3.589205361737233*^9}, {3.589205421895628*^9, 3.589205437785314*^9}, 
   3.5892054891832647`*^9, 3.589208119822625*^9, 3.589209608613071*^9, 
   3.590145545513236*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic Visual \
\[OpenCurlyDoubleQuote]Statistics\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.530372627959633*^9, 3.5303726359771557`*^9}}],

Cell["\<\
Histograms are a fantastic way to get a quick grasp of a large number of \
samples. Below are a select number of histogram, each focusing on a specific \
numeric quality.\
\>", "Text",
 CellChangeTimes->{{3.530372643432928*^9, 3.530372683969884*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"hLabel", "=", "\"\<Sample Values\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vLabel", "=", "\"\<Occurrences\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStnd1", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"sampleSetGood1", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1"}]}], 
     ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStndSmooth1", "=", 
   RowBox[{"SmoothHistogram", "[", 
    RowBox[{"sampleSetGood1", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Smoothed Histogram of Sample Values : \>\"", "<>", 
       "sampleSetName1", "<>", 
       "\"\<\\n(Probability Distribution Function)\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<\>\""}], "}"}]}]}], "]"}]}], ";", 
  RowBox[{"histCC1", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood1", ",", "Automatic", ",", "\"\<CumulativeCount\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1", "<>", 
       "\"\<\\nCumulative Count\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histProb1", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood1", ",", "Automatic", ",", "\"\<Probability\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1", "<>", 
       "\"\<\\nProbability\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<% Occurs\>\""}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"histStndSmallBin1", "=", 
    RowBox[{"Histogram", "[", 
     RowBox[{"sampleSetGood1", ",", 
      RowBox[{"{", "0.250", "}"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", 
       RowBox[{
       "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1", "<>", 
        "\"\<\\nbin size 0.250\>\""}]}], ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStnd2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"sampleSetGood2", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2"}]}], 
     ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStndSmooth2", "=", 
   RowBox[{"SmoothHistogram", "[", 
    RowBox[{"sampleSetGood2", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Smoothed Histogram of Sample Values : \>\"", "<>", 
       "sampleSetName1", "<>", 
       "\"\<\\n(Probability Distribution Function)\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<\>\""}], "}"}]}]}], "]"}]}], ";", 
  RowBox[{"histCC2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood2", ",", "Automatic", ",", "\"\<CumulativeCount\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2", "<>", 
       "\"\<\\nCumulative Count\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histProb2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood2", ",", "Automatic", ",", "\"\<Probability\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2", "<>", 
       "\"\<\\nProbability\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<% Occurs\>\""}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStndSmallBin2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"sampleSetGood2", ",", 
     RowBox[{"{", "0.250", "}"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2", "<>", 
       "\"\<\\nnbin size 0.250\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\< \>\"", "]"}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.530394715762684*^9, 3.530394723135069*^9}, 
   3.530394760001342*^9, {3.530455400611494*^9, 3.530455412231533*^9}, {
   3.589205017674301*^9, 3.58920510976562*^9}, {3.5892051473945103`*^9, 
   3.589205191596965*^9}, {3.589205236230096*^9, 3.589205287776355*^9}, {
   3.589205496523555*^9, 3.589205515386764*^9}, {3.589205545391057*^9, 
   3.589205577013954*^9}, {3.589205609269073*^9, 3.5892056985591383`*^9}, {
   3.5892057445963907`*^9, 3.5892057486441298`*^9}, {3.589208146714439*^9, 
   3.589208146802874*^9}}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{
  3.5892055784871073`*^9, 3.589205707787979*^9, 3.589205750492517*^9, {
   3.58920812067819*^9, 3.5892081481298227`*^9}, 3.589209608897748*^9, 
   3.590145546530599*^9}]
}, Open  ]],

Cell["\<\
Below is a standard histogram, where each sample is shown as a single block \
placed on the vertical axis based on its value. Common sample values (i.e., \
blocks) show as high stacks.\
\>", "Text",
 CellChangeTimes->{3.5303945570998573`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{"histStnd1", "\[IndentingNewLine]", "histStnd2"}], "Input",
 CellChangeTimes->{{3.530369545506777*^9, 3.530369547560232*^9}, {
  3.530369666836165*^9, 3.530369669231763*^9}, {3.5303699085772467`*^9, 
  3.530369930152483*^9}, {3.589205116907014*^9, 3.589205121494775*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6719999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6719999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{470., 0}, {475., 10}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.50000000000182, 
         167.54081632653106`}, {-63.64197244181631, 184.95971347493926`}}],
       StatusArea[#, 10]& ,
       TagBoxNote->"10"],
      StyleBox["10", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[10, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{475., 0}, {480., 13}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{166.54081632653106`, 
         309.5816326530621}, {-137.92247821684302`, 184.95971347493926`}}],
       StatusArea[#, 13]& ,
       TagBoxNote->"13"],
      StyleBox["13", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[13, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{480., 0}, {485., 7}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{308.5816326530621, 451.6224489795932}, {
         10.638533333210347`, 184.95971347493926`}}],
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{485., 0}, {490., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{450.6224489795932, 593.6632653061224}, {
         159.1995448832637, 184.95971347493926`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{470., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{675., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\"", TraditionalForm],
  PlotRange->{{470., 490.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.5303695488181334`*^9, 3.53036958415487*^9}, {
   3.530369650023057*^9, 3.530369670205143*^9}, 3.53036970302028*^9, 
   3.530369849607541*^9, {3.530369912051992*^9, 3.5303699314038763`*^9}, 
   3.530370440989561*^9, 3.530370970288966*^9, 3.5303711932451*^9, 
   3.530371282079977*^9, 3.530371366848496*^9, 3.530371464003294*^9, 
   3.530371828554619*^9, 3.530372610876151*^9, 3.530393601714321*^9, 
   3.530394130294532*^9, {3.530394496126593*^9, 3.530394522101289*^9}, 
   3.530394586856161*^9, 3.530395208041752*^9, 3.5303963140372553`*^9, 
   3.530455427899746*^9, 3.530455467257689*^9, {3.530469222935663*^9, 
   3.530469237842341*^9}, 3.53046928026694*^9, 3.530469429880677*^9, 
   3.530469559271694*^9, 3.5304702441973963`*^9, 3.536334926609531*^9, 
   3.5363357185955467`*^9, {3.536336625347118*^9, 3.536336650895856*^9}, 
   3.536337023128414*^9, {3.53633709915998*^9, 3.536337117482912*^9}, 
   3.536337288435781*^9, 3.5363375579023848`*^9, 3.536337644670939*^9, 
   3.536339085895953*^9, 3.536339944228245*^9, 3.53634117179491*^9, 
   3.536341227911189*^9, 3.536341446622402*^9, 3.536341961592246*^9, 
   3.53634202430599*^9, 3.5363425511443777`*^9, 3.536342659031567*^9, 
   3.536342825511848*^9, 3.554640053897842*^9, 3.554640184079294*^9, 
   3.589205122801214*^9, 3.589205196948225*^9, 3.589205244525977*^9, 
   3.5892055246585827`*^9, 3.589205580866781*^9, 3.589205712085713*^9, 
   3.589208120825781*^9, 3.5892081544701767`*^9, 3.589209608930407*^9, 
   3.590145546677929*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6719999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6719999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{510., 0}, {515., 6}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.49999999999818, 167.54081632652924`}, {
         70.35423405431024, 184.95971347493926`}}],
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{515., 0}, {520., 17}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{166.54081632652924`, 
         309.5816326530603}, {-137.92247821684296`, 184.95971347493926`}}],
       StatusArea[#, 17]& ,
       TagBoxNote->"17"],
      StyleBox["17", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[17, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{520., 0}, {525., 5}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{308.5816326530603, 451.62244897959135`}, {
         89.28848062441509, 184.95971347493926`}}],
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{525., 0}, {530., 3}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{450.62244897959135`, 593.6632653061206}, {
         127.15697376462475`, 184.95971347493926`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{510., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{675., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\"", TraditionalForm],
  PlotRange->{{510., 530.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.5303695488181334`*^9, 3.53036958415487*^9}, {
   3.530369650023057*^9, 3.530369670205143*^9}, 3.53036970302028*^9, 
   3.530369849607541*^9, {3.530369912051992*^9, 3.5303699314038763`*^9}, 
   3.530370440989561*^9, 3.530370970288966*^9, 3.5303711932451*^9, 
   3.530371282079977*^9, 3.530371366848496*^9, 3.530371464003294*^9, 
   3.530371828554619*^9, 3.530372610876151*^9, 3.530393601714321*^9, 
   3.530394130294532*^9, {3.530394496126593*^9, 3.530394522101289*^9}, 
   3.530394586856161*^9, 3.530395208041752*^9, 3.5303963140372553`*^9, 
   3.530455427899746*^9, 3.530455467257689*^9, {3.530469222935663*^9, 
   3.530469237842341*^9}, 3.53046928026694*^9, 3.530469429880677*^9, 
   3.530469559271694*^9, 3.5304702441973963`*^9, 3.536334926609531*^9, 
   3.5363357185955467`*^9, {3.536336625347118*^9, 3.536336650895856*^9}, 
   3.536337023128414*^9, {3.53633709915998*^9, 3.536337117482912*^9}, 
   3.536337288435781*^9, 3.5363375579023848`*^9, 3.536337644670939*^9, 
   3.536339085895953*^9, 3.536339944228245*^9, 3.53634117179491*^9, 
   3.536341227911189*^9, 3.536341446622402*^9, 3.536341961592246*^9, 
   3.53634202430599*^9, 3.5363425511443777`*^9, 3.536342659031567*^9, 
   3.536342825511848*^9, 3.554640053897842*^9, 3.554640184079294*^9, 
   3.589205122801214*^9, 3.589205196948225*^9, 3.589205244525977*^9, 
   3.5892055246585827`*^9, 3.589205580866781*^9, 3.589205712085713*^9, 
   3.589208120825781*^9, 3.5892081544701767`*^9, 3.589209608930407*^9, 
   3.590145546693878*^9}]
}, Open  ]],

Cell["\<\
Below is known as a Cummlative Count histogram. Each vertical bar represents \
the total number of samples values that are less than or equal to the bin.\
\>", "Text",
 CellChangeTimes->{{3.530372768356407*^9, 3.530372776770891*^9}, {
  3.530372809849923*^9, 3.530372896754038*^9}, {3.5303730283352537`*^9, 
  3.530373029808041*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histCC1", "\[IndentingNewLine]", "histCC2"}], "Input",
 CellChangeTimes->{{3.530371170718999*^9, 3.530371171449521*^9}, {
  3.589205719276526*^9, 3.5892057223249407`*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6719999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6719999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{470., 0}, {475., 10.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.5, 90.39795918367327}, {46.83808332666315, 
         95.27900701872227}}],
       StatusArea[#, 10]& ,
       TagBoxNote->"10"],
      StyleBox["10", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[10, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{475., 0}, {480., 23.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{89.39795918367327, 
         155.29591836734653`}, {-14.835117473013696`, 95.27900701872227}}],
       StatusArea[#, 23]& ,
       TagBoxNote->"23"],
      StyleBox["23", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[23, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{480., 0}, {485., 30.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{154.29591836734653`, 
         220.1938775510207}, {-48.043764057455064`, 95.27900701872227}}],
       StatusArea[#, 30]& ,
       TagBoxNote->"30"],
      StyleBox["30", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[30, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{485., 0}, {490., 31.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{219.1938775510207, 
         285.09183673469397`}, {-52.787856426660994`, 95.27900701872227}}],
       StatusArea[#, 31]& ,
       TagBoxNote->"31"],
      StyleBox["31", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[31, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{470., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\\nCumulative Count\"", 
    TraditionalForm],
  PlotRange->{{470., 490.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.5303711933153677`*^9, 3.5303712821883*^9, 3.530371366930995*^9, 
   3.530371464213008*^9, 3.53037182877146*^9, 3.530372611088093*^9, 
   3.53039360178333*^9, 3.530394130363566*^9, {3.5303944961970673`*^9, 
   3.530394522169527*^9}, 3.530394586925064*^9, 3.5303952091265917`*^9, 
   3.5303963140990887`*^9, 3.530455427951482*^9, 3.5304554672995453`*^9, 
   3.5304692383686666`*^9, 3.530469280898362*^9, 3.5304694301425667`*^9, 
   3.5304695599081917`*^9, 3.530470244824375*^9, 3.53633492673665*^9, 
   3.5363357187274313`*^9, {3.536336625403529*^9, 3.5363366509613256`*^9}, 
   3.536337023178193*^9, {3.5363370992069607`*^9, 3.5363371175516*^9}, 
   3.5363372884879627`*^9, 3.536337557953179*^9, 3.536337644729342*^9, 
   3.5363390859477654`*^9, 3.536339944546894*^9, 3.536341172038474*^9, 
   3.536341227959819*^9, 3.536341446836018*^9, 3.536341961681848*^9, 
   3.53634202440347*^9, 3.536342551265297*^9, 3.536342659084442*^9, 
   3.5363428255720654`*^9, 3.554640053932543*^9, 3.554640184099517*^9, {
   3.589205725069447*^9, 3.589205754459869*^9}, 3.5892081208789263`*^9, 
   3.589209608979403*^9, 3.5901455467481537`*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6719999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6719999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{510., 0}, {515., 6.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.5, 90.39795918367417}, {65.81445280348682, 
         95.27900701872228}}],
       StatusArea[#, 6]& ,
       TagBoxNote->"6"],
      StyleBox["6", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{515., 0}, {520., 23.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{89.39795918367417, 
         155.29591836734744`}, {-14.835117473013653`, 95.27900701872228}}],
       StatusArea[#, 23]& ,
       TagBoxNote->"23"],
      StyleBox["23", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[23, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{520., 0}, {525., 28.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{154.29591836734744`, 
         220.19387755102161`}, {-38.55557931904322, 95.27900701872228}}],
       StatusArea[#, 28]& ,
       TagBoxNote->"28"],
      StyleBox["28", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[28, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{525., 0}, {530., 31.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{219.19387755102161`, 
         285.0918367346949}, {-52.78785642666095, 95.27900701872228}}],
       StatusArea[#, 31]& ,
       TagBoxNote->"31"],
      StyleBox["31", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[31, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{510., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\\nCumulative Count\"", 
    TraditionalForm],
  PlotRange->{{510., 530.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.5303711933153677`*^9, 3.5303712821883*^9, 3.530371366930995*^9, 
   3.530371464213008*^9, 3.53037182877146*^9, 3.530372611088093*^9, 
   3.53039360178333*^9, 3.530394130363566*^9, {3.5303944961970673`*^9, 
   3.530394522169527*^9}, 3.530394586925064*^9, 3.5303952091265917`*^9, 
   3.5303963140990887`*^9, 3.530455427951482*^9, 3.5304554672995453`*^9, 
   3.5304692383686666`*^9, 3.530469280898362*^9, 3.5304694301425667`*^9, 
   3.5304695599081917`*^9, 3.530470244824375*^9, 3.53633492673665*^9, 
   3.5363357187274313`*^9, {3.536336625403529*^9, 3.5363366509613256`*^9}, 
   3.536337023178193*^9, {3.5363370992069607`*^9, 3.5363371175516*^9}, 
   3.5363372884879627`*^9, 3.536337557953179*^9, 3.536337644729342*^9, 
   3.5363390859477654`*^9, 3.536339944546894*^9, 3.536341172038474*^9, 
   3.536341227959819*^9, 3.536341446836018*^9, 3.536341961681848*^9, 
   3.53634202440347*^9, 3.536342551265297*^9, 3.536342659084442*^9, 
   3.5363428255720654`*^9, 3.554640053932543*^9, 3.554640184099517*^9, {
   3.589205725069447*^9, 3.589205754459869*^9}, 3.5892081208789263`*^9, 
   3.589209608979403*^9, 3.590145546761009*^9}]
}, Open  ]],

Cell["\<\
Below is a Probability Historgram. It will visually look exactly like the \
standard histogram but the vertical axis is a percentage value. Each vertical \
bar\[CloseCurlyQuote]s height represents the percentage of values that is \
contains. In contrast, the standard histogram hight is the actual number of \
sample occurrences.\
\>", "Text",
 CellChangeTimes->{{3.530372915776453*^9, 3.530373034082033*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histProb1", "\[IndentingNewLine]", "histProb2"}], "Input",
 CellChangeTimes->{{3.530371174905854*^9, 3.5303711849954643`*^9}, {
  3.589205760372879*^9, 3.589205765341523*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6719999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6719999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{470., 0}, {475., 0.3225806451612903}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{19.00000000000182, 
         163.63265306122776`}, {-56.39959799504342, 194.97693440181362`}}],
       StatusArea[#, 0.3225806451612903]& ,
       TagBoxNote->"0.3225806451612903"],
      StyleBox["0.3225806451612903`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.3225806451612903, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{475., 0}, {480., 0.41935483870967744`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{162.63265306122776`, 
         307.2653061224519}, {-131.51255771410055`, 194.97693440181362`}}],
       StatusArea[#, 0.41935483870967744`]& ,
       TagBoxNote->"0.41935483870967744"],
      StyleBox["0.41935483870967744`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.41935483870967744`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{480., 0}, {485., 0.22580645161290322`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{306.2653061224519, 450.897959183676}, {
         18.71336172401368, 194.97693440181362`}}],
       StatusArea[#, 0.22580645161290322`]& ,
       TagBoxNote->"0.22580645161290322"],
      StyleBox["0.22580645161290322`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.22580645161290322`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{485., 0}, {490., 0.03225806451612903}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{449.897959183676, 594.5306122449001}, {
         168.9392811621279, 194.97693440181362`}}],
       StatusArea[#, 0.03225806451612903]& ,
       TagBoxNote->"0.03225806451612903"],
      StyleBox["0.03225806451612903`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.03225806451612903, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"% Occurs\"", TraditionalForm]},
  AxesOrigin->{470., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{676., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\\nProbability\"", TraditionalForm],
  
  PlotRange->{{470., 490.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.530371193382887*^9, 3.5303712822723207`*^9, 3.5303713670066147`*^9, 
   3.530371464412394*^9, 3.530371828964902*^9, 3.530372611269655*^9, 
   3.530393601844863*^9, 3.530394130424241*^9, {3.530394496259248*^9, 
   3.530394522230245*^9}, 3.5303945869998837`*^9, 3.5303952095236187`*^9, 
   3.5303963141520576`*^9, 3.5304554280200663`*^9, 3.530455467346095*^9, 
   3.5304692386248913`*^9, 3.5304692812452993`*^9, 3.530469430388815*^9, 
   3.5304695602145157`*^9, 3.530470245274753*^9, 3.536334926797206*^9, 
   3.5363357188421097`*^9, {3.536336625456748*^9, 3.536336651006628*^9}, 
   3.536337023227828*^9, {3.536337099256421*^9, 3.536337117594417*^9}, 
   3.5363372885357227`*^9, 3.5363375580025787`*^9, 3.536337644776417*^9, 
   3.536339085995132*^9, 3.536339944639868*^9, 3.536341172119947*^9, 
   3.5363412280149403`*^9, 3.53634144692865*^9, 3.536341961779797*^9, 
   3.536342024503587*^9, 3.536342551316553*^9, 3.536342659142679*^9, 
   3.536342825633093*^9, 3.554640053985256*^9, 3.554640184118108*^9, 
   3.589205766406526*^9, 3.589208120932848*^9, 3.5892096090377703`*^9, 
   3.590145546810602*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6719999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6719999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{510., 0}, {515., 0.1935483870967742}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{19.00000000000182, 163.63265306122776`}, {
         79.09829012560859, 194.97693440181362`}}],
       StatusArea[#, 0.1935483870967742]& ,
       TagBoxNote->"0.1935483870967742"],
      StyleBox["0.1935483870967742`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.1935483870967742, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{515., 0}, {520., 0.5483870967741935}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{162.63265306122776`, 
         307.2653061224519}, {-131.51255771410067`, 194.97693440181362`}}],
       StatusArea[#, 0.5483870967741935]& ,
       TagBoxNote->"0.5483870967741935"],
      StyleBox["0.5483870967741935`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.5483870967741935, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{520., 0}, {525., 0.16129032258064516`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{306.2653061224519, 450.8979591836778}, {
         98.24473083830942, 194.97693440181362`}}],
       StatusArea[#, 0.16129032258064516`]& ,
       TagBoxNote->"0.16129032258064516"],
      StyleBox["0.16129032258064516`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.16129032258064516`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{525., 0}, {530., 0.0967741935483871}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{449.8979591836778, 594.5306122449019}, {
         136.5376122637111, 194.97693440181362`}}],
       StatusArea[#, 0.0967741935483871]& ,
       TagBoxNote->"0.0967741935483871"],
      StyleBox["0.0967741935483871`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0967741935483871, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"% Occurs\"", TraditionalForm]},
  AxesOrigin->{510., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{676., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\\nProbability\"", 
    TraditionalForm],
  PlotRange->{{510., 530.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.530371193382887*^9, 3.5303712822723207`*^9, 3.5303713670066147`*^9, 
   3.530371464412394*^9, 3.530371828964902*^9, 3.530372611269655*^9, 
   3.530393601844863*^9, 3.530394130424241*^9, {3.530394496259248*^9, 
   3.530394522230245*^9}, 3.5303945869998837`*^9, 3.5303952095236187`*^9, 
   3.5303963141520576`*^9, 3.5304554280200663`*^9, 3.530455467346095*^9, 
   3.5304692386248913`*^9, 3.5304692812452993`*^9, 3.530469430388815*^9, 
   3.5304695602145157`*^9, 3.530470245274753*^9, 3.536334926797206*^9, 
   3.5363357188421097`*^9, {3.536336625456748*^9, 3.536336651006628*^9}, 
   3.536337023227828*^9, {3.536337099256421*^9, 3.536337117594417*^9}, 
   3.5363372885357227`*^9, 3.5363375580025787`*^9, 3.536337644776417*^9, 
   3.536339085995132*^9, 3.536339944639868*^9, 3.536341172119947*^9, 
   3.5363412280149403`*^9, 3.53634144692865*^9, 3.536341961779797*^9, 
   3.536342024503587*^9, 3.536342551316553*^9, 3.536342659142679*^9, 
   3.536342825633093*^9, 3.554640053985256*^9, 3.554640184118108*^9, 
   3.589205766406526*^9, 3.589208120932848*^9, 3.5892096090377703`*^9, 
   3.590145546827663*^9}]
}, Open  ]],

Cell["\<\
Below is a Smoothed Histogram. It will have a similar shape to the Standard \
Histogram, but will be mathematically smoothed. Sometimes this is a much more \
pleasent and informative visual, but not always. Remember, it is smoothed so \
it does not consist of the actual values. For example, you may see the line \
go negative, even though there are no negative values. In reality, the plot \
is the probability distribution function (PDF).\
\>", "Text",
 CellChangeTimes->{{3.5303730468070383`*^9, 3.5303731275375233`*^9}, {
  3.530373410538884*^9, 3.530373411173328*^9}, {3.530373965912763*^9, 
  3.5303740112625923`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histStndSmooth1", "\[IndentingNewLine]", "histStndSmooth2"}], \
"Input",
 CellChangeTimes->{{3.530370958778479*^9, 3.5303709615584373`*^9}, {
  3.5892057738165283`*^9, 3.589205778518346*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxd23dUj/8bP/CUiKQhRURpS6lol+tuTw0lTRrae8/7bm9lNJU0lPbUHlbx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      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"\"", TraditionalForm]},
  AxesOrigin->{470., 0},
  Method->{},
  PlotLabel->FormBox[
   "\"Smoothed Histogram of Sample Values : Sysstat\\n(Probability \
Distribution Function)\"", TraditionalForm],
  PlotRange->{{466.724717172801, 492.3264105738651}, {
    0, 0.11670109958321687`}},
  PlotRangeClipping->True,
  PlotRangePadding->Scaled[0.02]]], "Output",
 CellChangeTimes->{
  3.530370970350786*^9, 3.530371193467195*^9, 3.53037128235537*^9, 
   3.5303713670898952`*^9, 3.530371464463482*^9, 3.530371829066883*^9, 
   3.530372611362261*^9, 3.530393601896793*^9, 3.530394130470519*^9, {
   3.5303944963024673`*^9, 3.5303945222734737`*^9}, 3.5303945870415373`*^9, 
   3.5303952095724993`*^9, 3.5303963142156553`*^9, 3.530455428067252*^9, 
   3.530455467394712*^9, 3.530469238698297*^9, 3.530469281286817*^9, 
   3.530469430453369*^9, 3.5304695602937183`*^9, 3.530470245311763*^9, 
   3.536334926838644*^9, 3.536335718919424*^9, {3.536336625505869*^9, 
   3.5363366510603437`*^9}, 3.5363370232800713`*^9, {3.5363370993025703`*^9, 
   3.536337117650896*^9}, 3.536337288587038*^9, 3.536337558052737*^9, 
   3.5363376448261223`*^9, 3.536339086046122*^9, 3.536339944737526*^9, 
   3.536341172213355*^9, 3.536341228061922*^9, 3.536341447016457*^9, 
   3.536341961861414*^9, 3.536342024602624*^9, 3.536342551377861*^9, 
   3.536342659196598*^9, 3.5363428256828203`*^9, 3.5546400540351954`*^9, 
   3.554640184135667*^9, 3.589205779961376*^9, 3.5892081209956627`*^9, 
   3.58920960909965*^9, 3.590145546885662*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxd23c01f8fOHBRSChZJauBskLIfr5DisrIqGiQERkJ2bnX3nvvmb2320DS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      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"\"", TraditionalForm]},
  AxesOrigin->{510., 0},
  Method->{},
  PlotLabel->FormBox[
   "\"Smoothed Histogram of Sample Values : Sysstat\\n(Probability \
Distribution Function)\"", TraditionalForm],
  PlotRange->{{506.85029014124666`, 533.1390705379199}, {
    0, 0.10416259590459027`}},
  PlotRangeClipping->True,
  PlotRangePadding->Scaled[0.02]]], "Output",
 CellChangeTimes->{
  3.530370970350786*^9, 3.530371193467195*^9, 3.53037128235537*^9, 
   3.5303713670898952`*^9, 3.530371464463482*^9, 3.530371829066883*^9, 
   3.530372611362261*^9, 3.530393601896793*^9, 3.530394130470519*^9, {
   3.5303944963024673`*^9, 3.5303945222734737`*^9}, 3.5303945870415373`*^9, 
   3.5303952095724993`*^9, 3.5303963142156553`*^9, 3.530455428067252*^9, 
   3.530455467394712*^9, 3.530469238698297*^9, 3.530469281286817*^9, 
   3.530469430453369*^9, 3.5304695602937183`*^9, 3.530470245311763*^9, 
   3.536334926838644*^9, 3.536335718919424*^9, {3.536336625505869*^9, 
   3.5363366510603437`*^9}, 3.5363370232800713`*^9, {3.5363370993025703`*^9, 
   3.536337117650896*^9}, 3.536337288587038*^9, 3.536337558052737*^9, 
   3.5363376448261223`*^9, 3.536339086046122*^9, 3.536339944737526*^9, 
   3.536341172213355*^9, 3.536341228061922*^9, 3.536341447016457*^9, 
   3.536341961861414*^9, 3.536342024602624*^9, 3.536342551377861*^9, 
   3.536342659196598*^9, 3.5363428256828203`*^9, 3.5546400540351954`*^9, 
   3.554640184135667*^9, 3.589205779961376*^9, 3.5892081209956627`*^9, 
   3.58920960909965*^9, 3.59014554689467*^9}]
}, Open  ]],

Cell["\<\
Below is a standard histogram but with the bin size set to 0.250. This is \
only  useful when the sample values range below 1.0, such as when sampling \
SQL statements (we all hope). Sample sets with large sample values will \
likely not result in a plot.\
\>", "Text",
 CellChangeTimes->{{3.530394064793583*^9, 3.530394112412057*^9}, {
  3.5303946066852083`*^9, 3.530394653134197*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histStndSmallBin1", "\[IndentingNewLine]", \
"histStndSmallBin2"}], "Input",
 CellChangeTimes->{{3.589205791242793*^9, 3.5892057959677134`*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.511]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.511]], RectangleBox[{472., 0}, {472.25, 2},
     RoundingRadius->0], RectangleBox[{473., 0}, {473.25, 1},
     RoundingRadius->0], RectangleBox[{473.25, 0}, {473.5, 1},
     RoundingRadius->0], RectangleBox[{473.5, 0}, {473.75, 1},
     RoundingRadius->0], RectangleBox[{474., 0}, {474.25, 1},
     RoundingRadius->0], RectangleBox[{474.25, 0}, {474.5, 1},
     RoundingRadius->0], RectangleBox[{474.5, 0}, {474.75, 2},
     RoundingRadius->0], RectangleBox[{474.75, 0}, {475., 1},
     RoundingRadius->0], RectangleBox[{475.25, 0}, {475.5, 1},
     RoundingRadius->0], RectangleBox[{475.5, 0}, {475.75, 3},
     RoundingRadius->0], RectangleBox[{475.75, 0}, {476., 1},
     RoundingRadius->0], RectangleBox[{476., 0}, {476.25, 1},
     RoundingRadius->0], RectangleBox[{476.25, 0}, {476.5, 1},
     RoundingRadius->0], RectangleBox[{476.5, 0}, {476.75, 1},
     RoundingRadius->0], RectangleBox[{476.75, 0}, {477., 1},
     RoundingRadius->0], RectangleBox[{477.25, 0}, {477.5, 1},
     RoundingRadius->0], RectangleBox[{478., 0}, {478.25, 1},
     RoundingRadius->0], RectangleBox[{479., 0}, {479.25, 1},
     RoundingRadius->0], RectangleBox[{479.25, 0}, {479.5, 1},
     RoundingRadius->0], RectangleBox[{480.25, 0}, {480.5, 1},
     RoundingRadius->0], RectangleBox[{480.5, 0}, {480.75, 1},
     RoundingRadius->0], RectangleBox[{481., 0}, {481.25, 1},
     RoundingRadius->0], RectangleBox[{481.75, 0}, {482., 1},
     RoundingRadius->0], RectangleBox[{482.25, 0}, {482.5, 1},
     RoundingRadius->0], RectangleBox[{482.5, 0}, {482.75, 1},
     RoundingRadius->0], RectangleBox[{483.5, 0}, {483.75, 1},
     RoundingRadius->0], RectangleBox[{487.25, 0}, {487.5, 1},
     RoundingRadius->0]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{472., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{665., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\\nbin size 0.250\"", 
    TraditionalForm],
  PlotRange->{{472., 487.5}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.530394118277979*^9, 3.530394130657009*^9}, {
   3.5303944964881496`*^9, 3.5303945224641848`*^9}, 3.530394587236465*^9, 
   3.5303952099682217`*^9, 3.530396314270275*^9, 3.530455428139687*^9, 
   3.530455467450446*^9, 3.530469238976469*^9, 3.5304692814840517`*^9, 
   3.5304694306369123`*^9, 3.5304695604920893`*^9, 3.530470245528013*^9, 
   3.536334927030675*^9, 3.536335719117712*^9, {3.536336625672222*^9, 
   3.536336651228236*^9}, 3.536337023459778*^9, {3.536337099443101*^9, 
   3.536337117800517*^9}, 3.536337288758793*^9, 3.536337558225767*^9, 
   3.5363376450286922`*^9, 3.536339086235671*^9, 3.5363399449861813`*^9, 
   3.536341172412774*^9, 3.5363412282310743`*^9, 3.536341447249112*^9, 
   3.5363419620807743`*^9, 3.536342024852913*^9, 3.53634255157006*^9, 
   3.536342659360385*^9, 3.536342825891924*^9, 3.554640054119725*^9, 
   3.554640184196095*^9, 3.589205797030332*^9, 3.589208121045702*^9, 
   3.5892096091494837`*^9, 3.5901455469345617`*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.511]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.511]], RectangleBox[{511.75, 0}, {512., 1},
     RoundingRadius->0], RectangleBox[{512., 0}, {512.25, 1},
     RoundingRadius->0], RectangleBox[{512.5, 0}, {512.75, 1},
     RoundingRadius->0], RectangleBox[{512.75, 0}, {513., 1},
     RoundingRadius->0], RectangleBox[{513.5, 0}, {513.75, 1},
     RoundingRadius->0], RectangleBox[{513.75, 0}, {514., 1},
     RoundingRadius->0], RectangleBox[{515.25, 0}, {515.5, 1},
     RoundingRadius->0], RectangleBox[{515.5, 0}, {515.75, 1},
     RoundingRadius->0], RectangleBox[{516.25, 0}, {516.5, 1},
     RoundingRadius->0], RectangleBox[{516.5, 0}, {516.75, 2},
     RoundingRadius->0], RectangleBox[{517., 0}, {517.25, 1},
     RoundingRadius->0], RectangleBox[{517.75, 0}, {518., 1},
     RoundingRadius->0], RectangleBox[{518., 0}, {518.25, 2},
     RoundingRadius->0], RectangleBox[{518.5, 0}, {518.75, 1},
     RoundingRadius->0], RectangleBox[{518.75, 0}, {519., 2},
     RoundingRadius->0], RectangleBox[{519., 0}, {519.25, 2},
     RoundingRadius->0], RectangleBox[{519.25, 0}, {519.5, 1},
     RoundingRadius->0], RectangleBox[{519.5, 0}, {519.75, 1},
     RoundingRadius->0], RectangleBox[{519.75, 0}, {520., 1},
     RoundingRadius->0], RectangleBox[{520.5, 0}, {520.75, 1},
     RoundingRadius->0], RectangleBox[{521.25, 0}, {521.5, 1},
     RoundingRadius->0], RectangleBox[{522., 0}, {522.25, 1},
     RoundingRadius->0], RectangleBox[{522.5, 0}, {522.75, 1},
     RoundingRadius->0], RectangleBox[{523.75, 0}, {524., 1},
     RoundingRadius->0], RectangleBox[{525.5, 0}, {525.75, 1},
     RoundingRadius->0], RectangleBox[{526., 0}, {526.25, 1},
     RoundingRadius->0], RectangleBox[{528.5, 0}, {528.75, 1},
     RoundingRadius->0]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{511.75, 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{665., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\\nnbin size 0.250\"", 
    TraditionalForm],
  PlotRange->{{511.75, 528.75}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.530394118277979*^9, 3.530394130657009*^9}, {
   3.5303944964881496`*^9, 3.5303945224641848`*^9}, 3.530394587236465*^9, 
   3.5303952099682217`*^9, 3.530396314270275*^9, 3.530455428139687*^9, 
   3.530455467450446*^9, 3.530469238976469*^9, 3.5304692814840517`*^9, 
   3.5304694306369123`*^9, 3.5304695604920893`*^9, 3.530470245528013*^9, 
   3.536334927030675*^9, 3.536335719117712*^9, {3.536336625672222*^9, 
   3.536336651228236*^9}, 3.536337023459778*^9, {3.536337099443101*^9, 
   3.536337117800517*^9}, 3.536337288758793*^9, 3.536337558225767*^9, 
   3.5363376450286922`*^9, 3.536339086235671*^9, 3.5363399449861813`*^9, 
   3.536341172412774*^9, 3.5363412282310743`*^9, 3.536341447249112*^9, 
   3.5363419620807743`*^9, 3.536342024852913*^9, 3.53634255157006*^9, 
   3.536342659360385*^9, 3.536342825891924*^9, 3.554640054119725*^9, 
   3.554640184196095*^9, 3.589205797030332*^9, 3.589208121045702*^9, 
   3.5892096091494837`*^9, 3.590145546941061*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Compare the two sample sets", "Subtitle",
 CellChangeTimes->{{3.530372627959633*^9, 3.5303726359771557`*^9}, {
  3.5892058898178453`*^9, 3.589205894346086*^9}}],

Cell[TextData[{
 "Below are the statisitcal tests to compare both numerically and visually \
the two sample sets. A simple t-test can be used IF both sample sets are \
normally distributed. (If their respective p-values are > 0.05 then we\
\[CloseCurlyQuote]ll say they are normally distribugted.) If either sample \
set is not normally distributed we must use a location equivilency test. I\
\[CloseCurlyQuote]ll let ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " pick location test to use.\n\nI also included a straight difference \
calculation, in both value and percentage. Why? Just because there is a \
statistical difference does not mean we will feel or notice the difference. \
Knowing the difference can help us determine if a statistical difference \
makes a truly impactful difference."
}], "Text",
 CellChangeTimes->{{3.530394064793583*^9, 3.530394112412057*^9}, {
  3.5303946066852083`*^9, 3.530394653134197*^9}, {3.5892058985878572`*^9, 
  3.589206031021261*^9}, {3.589207928224084*^9, 3.5892080284688168`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SmoothHistogram", "[", 
  RowBox[{"{", 
   RowBox[{"sampleSetGood1", ",", "sampleSetGood2"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.589206283027914*^9, 3.589206290742743*^9}, {
   3.5892070464497757`*^9, 3.589207111663759*^9}, 3.589207230138959*^9, {
   3.589207339346648*^9, 3.589207420942032*^9}, {3.5892074825892687`*^9, 
   3.589207513143084*^9}, {3.589207569068672*^9, 3.5892075978794193`*^9}, {
   3.5892076624448557`*^9, 3.589207664792069*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxd23c0l/8bP3CRUpKRKFFkJ0LZdN32zIhklpG998h92zsaZiQjsmf2aFGf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      "]]}, 
    {RGBColor[0.6, 0.24, 0.4428931686004542], LineBox[CompressedData["
1:eJxd23c01f8fOHBRSChZJauBskLIfr5DisrIqFCRUTISsnOvvffeM3tvt2Gl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      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{470., 0},
  ImageSize->{517.42578125, Automatic},
  Method->{},
  PlotRange->{{466.724717172801, 533.1390705379199}, {
    0, 0.11670109958321687`}},
  PlotRangeClipping->True,
  PlotRangePadding->Scaled[0.02]]], "Output",
 CellChangeTimes->{{3.5892070983167477`*^9, 3.589207112714263*^9}, {
   3.589207393627255*^9, 3.589207422348392*^9}, {3.589207507694421*^9, 
   3.5892075139378643`*^9}, 3.589207573266075*^9, 3.589207665970436*^9, 
   3.589208121194585*^9, 3.5892096093087378`*^9, 3.590145547094706*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pValueTT", "=", 
  RowBox[{"TTest", "[", 
   RowBox[{"{", 
    RowBox[{"sampleSetGood1", ",", "sampleSetGood2"}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.58920767306666*^9, 3.589207674119499*^9}}],

Cell[BoxData["1.074685926681147`*^-45"], "Output",
 CellChangeTimes->{3.589207675276827*^9, 3.589208121214479*^9, 
  3.589209609328547*^9, 3.59014554712036*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pValueLet", "=", 
  RowBox[{"LocationEquivalenceTest", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sampleSetGood1", ",", "sampleSetGood2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<TestDataTable\>\"", ",", "\"\<AutomaticTest\>\""}], "}"}]}],
    "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   StyleBox[
    TagBox[GridBox[{
       {"\<\"\"\>", "\<\"Statistic\"\>", "\<\"P\[Hyphen]Value\"\>"},
       {"\<\"K\[Hyphen]Sample T\"\>", "1695.4447719064624`", 
        "1.0746859266792348`*^-45"}
      },
      AutoDelete->False,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
      GridBoxDividers->{
       "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
        "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
      GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Grid"], "DialogStyle",
    StripOnInput->False], ",", "\<\"KSampleT\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.589207678048285*^9, 3.5892081212448597`*^9, 
  3.589209609361758*^9, 3.590145547204096*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"medDiff", "=", 
  RowBox[{"Abs", "[", 
   RowBox[{
    RowBox[{"Median", "[", "sampleSetGood1", "]"}], "-", 
    RowBox[{"Median", "[", "sampleSetGood2", "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"medDiff", "/", 
  RowBox[{"Median", "[", "sampleSetGood1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"medDiff", "/", 
  RowBox[{"Median", "[", "sampleSetGood2", "]"}]}]}], "Input",
 CellChangeTimes->{{3.589207684922118*^9, 3.589207752846141*^9}, {
  3.589207796653734*^9, 3.589207801233642*^9}, {3.589207882832284*^9, 
  3.589207891400839*^9}}],

Cell[BoxData["42.43016399999999`"], "Output",
 CellChangeTimes->{3.589207754213632*^9, 3.58920789234379*^9, 
  3.589208121279024*^9, 3.58920960939266*^9, 3.590145547236309*^9}],

Cell[BoxData["0.08911279035577771`"], "Output",
 CellChangeTimes->{3.589207754213632*^9, 3.58920789234379*^9, 
  3.589208121279024*^9, 3.58920960939266*^9, 3.5901455472374153`*^9}],

Cell[BoxData["0.08182145241969607`"], "Output",
 CellChangeTimes->{3.589207754213632*^9, 3.58920789234379*^9, 
  3.589208121279024*^9, 3.58920960939266*^9, 3.590145547238203*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{825, 1061},
WindowMargins->{{Automatic, 226}, {Automatic, 6}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, \
2013)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 250, 7, 131, "Title"],
Cell[675, 24, 208, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[908, 33, 98, 1, 22, "Subtitle"],
Cell[1009, 36, 607, 10, 101, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1653, 51, 101, 1, 22, "Subtitle"],
Cell[1757, 54, 504, 8, 83, "Text"],
Cell[2264, 64, 3587, 64, 294, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5888, 133, 114, 1, 22, "Subtitle"],
Cell[6005, 136, 1179, 29, 227, "Text"],
Cell[CellGroupData[{
Cell[7209, 169, 8709, 212, 804, "Input"],
Cell[15921, 383, 652, 13, 24, "Message"],
Cell[16576, 398, 2683, 55, 279, "Output"]
}, Open  ]],
Cell[19274, 456, 124, 2, 29, "Text"],
Cell[CellGroupData[{
Cell[19423, 462, 8855, 214, 804, "Input"],
Cell[28281, 678, 725, 14, 24, "Message"],
Cell[29009, 694, 1655, 40, 279, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[30713, 740, 160, 2, 22, "Subtitle"],
Cell[30876, 744, 260, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[31161, 753, 5560, 143, 634, "Input"],
Cell[36724, 898, 225, 4, 21, "Print"]
}, Open  ]],
Cell[36964, 905, 252, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[37241, 914, 285, 3, 56, "Input"],
Cell[37529, 919, 4978, 125, 425, "Output"],
Cell[42510, 1046, 4979, 125, 425, "Output"]
}, Open  ]],
Cell[47504, 1174, 343, 6, 47, "Text"],
Cell[CellGroupData[{
Cell[47872, 1184, 186, 2, 56, "Input"],
Cell[48061, 1188, 4603, 120, 247, "Output"],
Cell[52667, 1310, 4597, 120, 247, "Output"]
}, Open  ]],
Cell[57279, 1433, 419, 7, 65, "Text"],
Cell[CellGroupData[{
Cell[57723, 1444, 190, 2, 56, "Input"],
Cell[57916, 1448, 5001, 125, 445, "Output"],
Cell[62920, 1575, 4994, 125, 445, "Output"]
}, Open  ]],
Cell[67929, 1703, 634, 10, 83, "Text"],
Cell[CellGroupData[{
Cell[68588, 1717, 206, 3, 56, "Input"],
Cell[68797, 1722, 17219, 287, 259, "Output"],
Cell[86019, 2011, 17364, 290, 259, "Output"]
}, Open  ]],
Cell[103398, 2304, 396, 7, 65, "Text"],
Cell[CellGroupData[{
Cell[103819, 2315, 159, 2, 56, "Input"],
Cell[103981, 2319, 3566, 65, 435, "Output"],
Cell[107550, 2386, 3571, 65, 435, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[111170, 2457, 166, 2, 22, "Subtitle"],
Cell[111339, 2461, 1034, 17, 155, "Text"],
Cell[CellGroupData[{
Cell[112398, 2482, 483, 8, 38, "Input"],
Cell[112884, 2492, 31843, 528, 352, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144764, 3025, 232, 6, 38, "Input"],
Cell[144999, 3033, 160, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[145196, 3040, 303, 8, 56, "Input"],
Cell[145502, 3050, 849, 20, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146388, 3075, 579, 13, 73, "Input"],
Cell[146970, 3090, 176, 2, 38, "Output"],
Cell[147149, 3094, 180, 2, 38, "Output"],
Cell[147332, 3098, 178, 2, 38, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

