(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[    162765,       3558]
NotebookOptionsPosition[    159469,       3446]
NotebookOutlinePosition[    159952,       3465]
CellTagsIndexPosition[    159909,       3462]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Workload: Cursor: pin S

Compare Sample Sets Statistical Analysis\
\>", "Title",
 CellChangeTimes->{{3.5303688333633947`*^9, 3.530368837704206*^9}, {
  3.58920804668637*^9, 3.589208062499321*^9}, {3.589208319935629*^9, 
  3.589208337540052*^9}}],

Cell["\<\
version 1a, 26-Sep-2013
author: Craig Shallahamer, craig@orapub.com\
\>", "Text",
 CellChangeTimes->{{3.530374180214813*^9, 3.530374223504505*^9}, {
  3.589208065031522*^9, 3.5892080829739857`*^9}}],

Cell[CellGroupData[{

Cell["Introduction", "Subtitle",
 CellChangeTimes->{{3.530374242866493*^9, 3.530374244484584*^9}}],

Cell["\<\
It\[CloseCurlyQuote]s difficult for us humans to aborb and grasp more than \
just a few values. Statistics provides us with a way to grasp complexity by \
simplifying or abstracting. As Oracle performance specialist, we typically \
have a large number of numeric samples, comprising our sample set.

This notepad analyze two samples and then statisticall compares them.\
\>", "Text",
 CellChangeTimes->{{3.530368849609161*^9, 3.530368851374548*^9}, {
  3.530370187776986*^9, 3.530370232698889*^9}, {3.5303740416976213`*^9, 
  3.530374137913013*^9}, {3.589197070039434*^9, 3.5891970910170927`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sample values", "Subtitle",
 CellChangeTimes->{{3.5303742624633904`*^9, 3.530374264105083*^9}}],

Cell["\<\
Enter your sample values; seperated by commas and the entire set enclosed in \
braces. Usually you can simply copy and paste the values directly into the \
notebook; which usually removes any line feeds or returns.
It is common to not consider all sample vaues. Below you can specify \
threshholds for the minimum and maximum values to run through the analysis.\
\>", "Text",
 CellChangeTimes->{{3.530374267526122*^9, 3.5303743523403177`*^9}, {
  3.530454126353104*^9, 3.5304541854582357`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cutoffMin", "=", 
   RowBox[{"-", "1.0"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cutoffMax", "=", "9999.0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSysstat", "=", 
   RowBox[{"{", 
    RowBox[{
    "1072.92", ",", "1072.92", ",", "1072.7", ",", "1073.21", ",", "1072.81", 
     ",", "1073.18", ",", "1073.06", ",", "1073.1", ",", "1065.37", ",", 
     "1073.19", ",", "1073.09", ",", "1073.24", ",", "1073.04", ",", 
     "1073.36", ",", "1073.22", ",", "1073.58", ",", "1073.18", ",", "1073.2",
      ",", "1073.4", ",", "1073.19", ",", "1073.29", ",", "1073.12", ",", 
     "1073.23", ",", "1073.27", ",", "1073.3", ",", "1073.13", ",", "1073.11",
      ",", "1073.01", ",", "1073.31", ",", "1073.02", ",", "1073.27"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleTimeModel", "=", 
   RowBox[{"{", 
    RowBox[{
    "1073.723766", ",", "1073.5118", ",", "1073.252835", ",", "1067.854662", 
     ",", "1073.64078", ",", "1073.895746", ",", "1073.531796", ",", 
     "1073.795754", ",", "1066.515862", ",", "1073.330825", ",", 
     "1074.133706", ",", "1073.985731", ",", "1073.629777", ",", 
     "1073.498809", ",", "1068.105622", ",", "1074.092709", ",", 
     "1073.907739", ",", "1073.997727", ",", "1074.093713", ",", 
     "1074.108706", ",", "1073.5438", ",", "1073.894743", ",", "1073.753762", 
     ",", "1074.016722", ",", "1073.801763", ",", "1073.914735", ",", 
     "1073.637778", ",", "1073.939734", ",", "1073.474803", ",", 
     "1073.831752", ",", "1073.822753"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetName1", "=", "\"\<Sysstat\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetName2", "=", "\"\<Time Model\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetRaw1", "=", "sampleSysstat"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetRaw2", "=", "sampleTimeModel"}], ";"}]}], "Input",
 CellChangeTimes->{{3.530368865010776*^9, 3.530368867417789*^9}, {
   3.5303689610885572`*^9, 3.530368963522463*^9}, 3.53036900548626*^9, {
   3.530369051420986*^9, 3.530369055243724*^9}, 3.5303714491074944`*^9, 
   3.5303935569531603`*^9, 3.530393588071438*^9, 3.530395180906042*^9, {
   3.530395563209477*^9, 3.530395567665958*^9}, {3.53039594405702*^9, 
   3.530395970436448*^9}, {3.53039607694536*^9, 3.530396146173196*^9}, {
   3.5303962265654697`*^9, 3.530396276110527*^9}, {3.530454018294681*^9, 
   3.5304540216285553`*^9}, {3.5304540980484447`*^9, 
   3.5304541088959084`*^9}, {3.530455451196604*^9, 3.530455451340207*^9}, {
   3.530469015209696*^9, 3.530469015650317*^9}, {3.530469268622115*^9, 
   3.530469268961523*^9}, {3.530469420949239*^9, 3.5304694211293507`*^9}, {
   3.530469546115999*^9, 3.530469546306059*^9}, {3.536336607077544*^9, 
   3.536336646173242*^9}, {3.536337012448007*^9, 3.536337013976362*^9}, {
   3.536337083468281*^9, 3.53633711309508*^9}, {3.536337279867556*^9, 
   3.536337282289822*^9}, {3.536337529501505*^9, 3.53633755196574*^9}, {
   3.5363376242524033`*^9, 3.536337634992538*^9}, {3.536342543724098*^9, 
   3.536342545446476*^9}, {3.536342651050959*^9, 3.53634265379499*^9}, {
   3.536342820072816*^9, 3.536342820372504*^9}, {3.536347444335575*^9, 
   3.536347526036746*^9}, {3.554639963802973*^9, 3.554639974880636*^9}, {
   3.589197097899551*^9, 3.589197108699297*^9}, {3.589204287151061*^9, 
   3.589204342261038*^9}, {3.5892044312058887`*^9, 3.58920446620074*^9}, {
   3.589204521778823*^9, 3.589204564969947*^9}, {3.589204969473914*^9, 
   3.589204970399848*^9}, {3.589205297076652*^9, 3.5892053183576202`*^9}, {
   3.589208281199692*^9, 3.589208306341981*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic Numeric Statistics", "Subtitle",
 CellChangeTimes->{{3.5303944048152018`*^9, 3.5303944108075037`*^9}}],

Cell[TextData[{
 "The basic numeric statistics shown are:\n\n",
 StyleBox["First five values",
  FontWeight->"Bold"],
 " simply lists the first five values of your sample set. Use this to check \
the data being used is what you think.\n",
 StyleBox["Number of samples ",
  FontWeight->"Bold"],
 "is in fact the number of samples. Use this to check the data has been \
entered correctly.\n",
 StyleBox["Average",
  FontWeight->"Bold"],
 " is the statistical mean.\n",
 StyleBox["Median",
  FontWeight->"Bold"],
 " is the middle value after all the values are sorted. This is also the \
50-percentile value.\n",
 StyleBox["Standard deviation",
  FontWeight->"Bold"],
 " is a measure of dispersion and is particularly valuable when the \
distribution is normal.\n",
 StyleBox["P-Value",
  FontWeight->"Bold"],
 " is a measure of contrast. In this instance, we are constrasting the sample \
set to the normal distribution. Loosely speaking, if the P-Value is greater \
than 0.05 then our sample set is likely to be normally distributed.\n\nSample \
Set #1"
}], "Text",
 CellChangeTimes->{{3.530394428636175*^9, 3.530394432641831*^9}, {
  3.589204580775587*^9, 3.589204586298441*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"sampleSetGood1", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetBad1", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw1", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[LessEqual]", "cutoffMax"}], 
          ")"}], "&&", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw1", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[GreaterEqual]", "cutoffMin"}], 
          ")"}]}], ")"}], ",", "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetGood1", ",", 
         RowBox[{"sampleSetRaw1", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetBad1", ",", 
         RowBox[{"sampleSetRaw1", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}]}], 
      "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "sampleSetRaw1", "]"}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countRaw", "=", 
   RowBox[{"Length", "[", "sampleSetRaw1", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countGood", "=", 
   RowBox[{"Length", "[", "sampleSetGood1", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"countBad", "=", 
    RowBox[{"Length", "[", "sampleSetBad1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveRaw", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetRaw1", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveGood", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetGood1", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstFiveBad", "=", 
    RowBox[{"Take", "[", 
     RowBox[{"sampleSetBad1", ",", "5"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"avg", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Mean", "[", "sampleSetGood1", "]"}], "]"}], ",", "0.00010"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"med", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Median", "[", "sampleSetGood1", "]"}], "]"}], ",", "0.00010"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"std", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"StandardDeviation", "[", "sampleSetGood1", "]"}], "]"}], ",", 
     "0.0010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pValue", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"DistributionFitTest", "[", "sampleSetGood1", "]"}], "]"}], ",",
      "0.0000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct90", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood1", ",", "0.90"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct95", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood1", ",", "0.95"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct99", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood1", ",", "0.99"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"maxV", "=", 
    RowBox[{"Max", "[", "sampleSetGood1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Statistics for Sample Set : \>\"", "<>", " ", "sampleSetName1", 
       "<>", "\"\<\\n\>\""}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of total samples\>\"", ",", "countRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of good samples\>\"", ",", "countGood"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of bad samples\>\"", ",", "countBad"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five raw samples\>\"", ",", "firstFiveRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five good samples\>\"", ",", "firstFiveGood"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five bad samples\>\"", ",", "firstFiveBad"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Good Sample Details\>\"", ",", "\"\<---\>\""}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Average\>\"", ",", "avg"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Median (50%-tile)\>\"", ",", "med"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Maximum\>\"", ",", "maxV"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Percentiles (90,95,99)\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"pct90", ",", "pct95", ",", "pct99"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Standard deviation\>\"", ",", "std"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  P-Value\>\"", ",", "pValue"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Alignment", "\[Rule]", 
      RowBox[{"{", "Left", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "None"}]}], "}"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.530368968593367*^9, 3.530368989268654*^9}, {
   3.5303690965356617`*^9, 3.530369118240787*^9}, {3.530369171410687*^9, 
   3.530369303558567*^9}, {3.5303693351682587`*^9, 3.530369427422378*^9}, {
   3.530369480374955*^9, 3.530369533827389*^9}, {3.5303695650243883`*^9, 
   3.530369579388669*^9}, {3.530369631285817*^9, 3.530369645933391*^9}, {
   3.5303696896422977`*^9, 3.530369697771058*^9}, {3.5303698401340857`*^9, 
   3.5303698459914103`*^9}, 3.530370326490252*^9, {3.530370541055084*^9, 
   3.530370549806651*^9}, {3.5303707096253843`*^9, 3.53037072436871*^9}, {
   3.530370842710359*^9, 3.53037084944149*^9}, {3.530370926582889*^9, 
   3.530370935884305*^9}, {3.530370995403738*^9, 3.530371021568015*^9}, {
   3.5303711315654488`*^9, 3.530371144348104*^9}, {3.530371233252054*^9, 
   3.530371273780658*^9}, {3.5303713101522007`*^9, 3.530371381300761*^9}, {
   3.5303716525945873`*^9, 3.53037169323724*^9}, {3.530371769719269*^9, 
   3.530371781099001*^9}, {3.530371832466179*^9, 3.5303718351591873`*^9}, {
   3.5303936674882107`*^9, 3.53039369987022*^9}, {3.5303937319628277`*^9, 
   3.530393732302782*^9}, {3.530393990173481*^9, 3.5303940515857983`*^9}, {
   3.5303944806938047`*^9, 3.5303944813726587`*^9}, {3.530394513548739*^9, 
   3.530394513933091*^9}, {3.530395584184815*^9, 3.530395665139804*^9}, {
   3.53039573123534*^9, 3.530395770072953*^9}, {3.530395866646319*^9, 
   3.530395866732829*^9}, {3.530395977045204*^9, 3.530395977999033*^9}, 
   3.530396011906796*^9, {3.5303961568553247`*^9, 3.530396185139888*^9}, {
   3.530396295140654*^9, 3.530396297581646*^9}, {3.530396342740769*^9, 
   3.530396401087904*^9}, {3.530396447078868*^9, 3.530396508850835*^9}, {
   3.5303965432221127`*^9, 3.5303967135104313`*^9}, {3.530453988732895*^9, 
   3.530454012634718*^9}, {3.5304540493515*^9, 3.530454071670485*^9}, {
   3.530454118686286*^9, 3.530454120084098*^9}, {3.5304549689805393`*^9, 
   3.530454973039502*^9}, {3.5304551150546083`*^9, 3.530455381038809*^9}, 
   3.5304554947173357`*^9, {3.530469054226564*^9, 3.530469095504678*^9}, {
   3.530469132177784*^9, 3.530469169752913*^9}, {3.589204591684404*^9, 
   3.589204640892511*^9}, {3.589204703982668*^9, 3.58920472726952*^9}, {
   3.5892047706716557`*^9, 3.589204803477298*^9}, {3.589205455713531*^9, 
   3.589205471673032*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Take", "::", "take"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Cannot take positions \[NoBreak]\\!\\(1\\)\[NoBreak] \
through \[NoBreak]\\!\\(5\\)\[NoBreak] in \[NoBreak]\\!\\({}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Take/take\\\", \
ButtonNote -> \\\"Take::take\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.5892047291486473`*^9, {3.589204790418169*^9, 3.5892048045433617`*^9}, 
   3.5892054739477663`*^9, 3.589208119639461*^9, 3.589208394295919*^9, 
   3.589209456881109*^9, 3.5901451304372253`*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Statistics for Sample Set : Sysstat\\n\"\>", ""},
    {"\<\"Number of total samples\"\>", "31"},
    {"\<\"Number of good samples\"\>", "31"},
    {"\<\"Number of bad samples\"\>", "0"},
    {"\<\"First five raw samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "1072.92`", ",", "1072.92`", ",", "1072.7`", ",", "1073.21`", ",", 
       "1072.81`"}], "}"}]},
    {"\<\"First five good samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "1072.92`", ",", "1072.92`", ",", "1072.7`", ",", "1073.21`", ",", 
       "1072.81`"}], "}"}]},
    {"\<\"First five bad samples\"\>", 
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "5"}], "]"}]},
    {"\<\"Good Sample Details\"\>", "\<\"---\"\>"},
    {"\<\"  Average\"\>", "1072.9039`"},
    {"\<\"  Median (50%-tile)\"\>", "1073.18`"},
    {"\<\"  Maximum\"\>", "1073.58`"},
    {"\<\"  Percentiles (90,95,99)\"\>", 
     RowBox[{"{", 
      RowBox[{
      "1073.3100000000002`", ",", "1073.4`", ",", "1073.5800000000002`"}], 
      "}"}]},
    {"\<\"  Standard deviation\"\>", "1.409`"},
    {"\<\"  P-Value\"\>", "0.`"}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> None, "Rows" -> None},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.5303957883159657`*^9, 3.530395873878767*^9, {3.53039598031126*^9, 
   3.530395989224454*^9}, {3.530396163546875*^9, 3.5303961872839327`*^9}, 
   3.530396313304497*^9, {3.53039649481763*^9, 3.530396510875143*^9}, 
   3.5304554272825623`*^9, 3.530455466660076*^9, 3.530455497552189*^9, 
   3.530469028806366*^9, {3.530469060709507*^9, 3.530469096893461*^9}, {
   3.530469153086173*^9, 3.530469171493932*^9}, 3.530469231345664*^9, 
   3.530469273461467*^9, 3.530469426901936*^9, 3.530469552359798*^9, 
   3.530470236790164*^9, 3.536334923158784*^9, 3.5363357149452477`*^9, {
   3.536336624039689*^9, 3.536336650435875*^9}, 3.536337022777419*^9, {
   3.5363370987121067`*^9, 3.536337117024104*^9}, 3.536337287258542*^9, 
   3.536337556724328*^9, 3.536337644127635*^9, 3.5363390853670797`*^9, 
   3.536339943574079*^9, 3.5363411707911367`*^9, 3.5363412270341997`*^9, 
   3.5363414456773653`*^9, 3.5363419606031713`*^9, 3.5363420236911917`*^9, 
   3.536342550277603*^9, 3.536342657424079*^9, 3.53634282443299*^9, 
   3.554639986040378*^9, 3.5546400537141542`*^9, 3.554640183673815*^9, {
   3.5892046928575487`*^9, 3.5892047291750727`*^9}, {3.5892047904579*^9, 
   3.58920480457402*^9}, 3.58920547398158*^9, 3.589208119779434*^9, 
   3.589208394654216*^9, 3.589209456914464*^9, 3.59014513054576*^9}]
}, Open  ]],

Cell["Sample Set #2", "Text",
 CellChangeTimes->{
  3.5303945570998573`*^9, {3.589204860147819*^9, 3.5892048626771383`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"sampleSetGood2", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sampleSetBad2", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[LessEqual]", "cutoffMax"}], 
          ")"}], "&&", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"sampleSetRaw2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[GreaterEqual]", "cutoffMin"}], 
          ")"}]}], ")"}], ",", "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetGood2", ",", 
         RowBox[{"sampleSetRaw2", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sampleSetBad2", ",", 
         RowBox[{"sampleSetRaw2", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}]}], 
      "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "sampleSetRaw2", "]"}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countRaw", "=", 
   RowBox[{"Length", "[", "sampleSetRaw2", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"countGood", "=", 
   RowBox[{"Length", "[", "sampleSetGood2", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"countBad", "=", 
    RowBox[{"Length", "[", "sampleSetBad2", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveRaw", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetRaw2", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"firstFiveGood", "=", 
   RowBox[{"Take", "[", 
    RowBox[{"sampleSetGood2", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstFiveBad", "=", 
    RowBox[{"Take", "[", 
     RowBox[{"sampleSetBad2", ",", "5"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"avg", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Mean", "[", "sampleSetGood2", "]"}], "]"}], ",", "0.00010"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"med", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Median", "[", "sampleSetGood2", "]"}], "]"}], ",", "0.00010"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"std", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"StandardDeviation", "[", "sampleSetGood2", "]"}], "]"}], ",", 
     "0.0010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pValue", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"DistributionFitTest", "[", "sampleSetGood2", "]"}], "]"}], ",",
      "0.0000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct90", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood2", ",", "0.90"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct95", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood2", ",", "0.95"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pct99", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"Quantile", "[", 
       RowBox[{"sampleSetGood2", ",", "0.99"}], "]"}], "]"}], ",", 
     "0.000010"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"maxV", "=", 
    RowBox[{"Max", "[", "sampleSetGood2", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Statistics for Sample Set : \>\"", "<>", " ", "sampleSetName2", 
       "<>", "\"\<\\n\>\""}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of total samples\>\"", ",", "countRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of good samples\>\"", ",", "countGood"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Number of bad samples\>\"", ",", "countBad"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five raw samples\>\"", ",", "firstFiveRaw"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five good samples\>\"", ",", "firstFiveGood"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<First five bad samples\>\"", ",", "firstFiveBad"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<Good Sample Details\>\"", ",", "\"\<---\>\""}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Average\>\"", ",", "avg"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Median (50%-tile)\>\"", ",", "med"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Maximum\>\"", ",", "maxV"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Percentiles (90,95,99)\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"pct90", ",", "pct95", ",", "pct99"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  Standard deviation\>\"", ",", "std"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<  P-Value\>\"", ",", "pValue"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Alignment", "\[Rule]", 
      RowBox[{"{", "Left", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "None"}]}], "}"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.530368968593367*^9, 3.530368989268654*^9}, {
   3.5303690965356617`*^9, 3.530369118240787*^9}, {3.530369171410687*^9, 
   3.530369303558567*^9}, {3.5303693351682587`*^9, 3.530369427422378*^9}, {
   3.530369480374955*^9, 3.530369533827389*^9}, {3.5303695650243883`*^9, 
   3.530369579388669*^9}, {3.530369631285817*^9, 3.530369645933391*^9}, {
   3.5303696896422977`*^9, 3.530369697771058*^9}, {3.5303698401340857`*^9, 
   3.5303698459914103`*^9}, 3.530370326490252*^9, {3.530370541055084*^9, 
   3.530370549806651*^9}, {3.5303707096253843`*^9, 3.53037072436871*^9}, {
   3.530370842710359*^9, 3.53037084944149*^9}, {3.530370926582889*^9, 
   3.530370935884305*^9}, {3.530370995403738*^9, 3.530371021568015*^9}, {
   3.5303711315654488`*^9, 3.530371144348104*^9}, {3.530371233252054*^9, 
   3.530371273780658*^9}, {3.5303713101522007`*^9, 3.530371381300761*^9}, {
   3.5303716525945873`*^9, 3.53037169323724*^9}, {3.530371769719269*^9, 
   3.530371781099001*^9}, {3.530371832466179*^9, 3.5303718351591873`*^9}, {
   3.5303936674882107`*^9, 3.53039369987022*^9}, {3.5303937319628277`*^9, 
   3.530393732302782*^9}, {3.530393990173481*^9, 3.5303940515857983`*^9}, {
   3.5303944806938047`*^9, 3.5303944813726587`*^9}, {3.530394513548739*^9, 
   3.530394513933091*^9}, {3.530395584184815*^9, 3.530395665139804*^9}, {
   3.53039573123534*^9, 3.530395770072953*^9}, {3.530395866646319*^9, 
   3.530395866732829*^9}, {3.530395977045204*^9, 3.530395977999033*^9}, 
   3.530396011906796*^9, {3.5303961568553247`*^9, 3.530396185139888*^9}, {
   3.530396295140654*^9, 3.530396297581646*^9}, {3.530396342740769*^9, 
   3.530396401087904*^9}, {3.530396447078868*^9, 3.530396508850835*^9}, {
   3.5303965432221127`*^9, 3.5303967135104313`*^9}, {3.530453988732895*^9, 
   3.530454012634718*^9}, {3.5304540493515*^9, 3.530454071670485*^9}, {
   3.530454118686286*^9, 3.530454120084098*^9}, {3.5304549689805393`*^9, 
   3.530454973039502*^9}, {3.5304551150546083`*^9, 3.530455381038809*^9}, 
   3.5304554947173357`*^9, {3.530469054226564*^9, 3.530469095504678*^9}, {
   3.530469132177784*^9, 3.530469169752913*^9}, {3.589204591684404*^9, 
   3.589204640892511*^9}, {3.589204703982668*^9, 3.58920472726952*^9}, {
   3.5892047706716557`*^9, 3.589204803477298*^9}, {3.589204870548375*^9, 
   3.589204940006817*^9}, {3.589205330358691*^9, 3.589205384684655*^9}, {
   3.589205417371266*^9, 3.589205440519182*^9}, {3.589205484169776*^9, 
   3.589205484247561*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Take", "::", "take"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Cannot take positions \[NoBreak]\\!\\(1\\)\[NoBreak] \
through \[NoBreak]\\!\\(5\\)\[NoBreak] in \[NoBreak]\\!\\({}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Take/take\\\", \
ButtonNote -> \\\"Take::take\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.5892049419449463`*^9, 3.589204978424362*^9, {3.589205343560355*^9, 
   3.5892053616873007`*^9}, {3.5892054218515043`*^9, 3.589205437780459*^9}, 
   3.589205489145903*^9, 3.5892081198103733`*^9, 3.589208394691865*^9, 
   3.589209456950676*^9, 3.590145130587963*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Statistics for Sample Set : Time Model\\n\"\>", ""},
    {"\<\"Number of total samples\"\>", "31"},
    {"\<\"Number of good samples\"\>", "31"},
    {"\<\"Number of bad samples\"\>", "0"},
    {"\<\"First five raw samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "1073.723766`", ",", "1073.5118`", ",", "1073.252835`", ",", 
       "1067.854662`", ",", "1073.64078`"}], "}"}]},
    {"\<\"First five good samples\"\>", 
     RowBox[{"{", 
      RowBox[{
      "1073.723766`", ",", "1073.5118`", ",", "1073.252835`", ",", 
       "1067.854662`", ",", "1073.64078`"}], "}"}]},
    {"\<\"First five bad samples\"\>", 
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "5"}], "]"}]},
    {"\<\"Good Sample Details\"\>", "\<\"---\"\>"},
    {"\<\"  Average\"\>", "1073.169`"},
    {"\<\"  Median (50%-tile)\"\>", "1073.7958`"},
    {"\<\"  Maximum\"\>", "1074.133706`"},
    {"\<\"  Percentiles (90,95,99)\"\>", 
     RowBox[{"{", 
      RowBox[{
      "1074.0927100000001`", ",", "1074.1087100000002`", ",", "1074.13371`"}],
       "}"}]},
    {"\<\"  Standard deviation\"\>", "1.9160000000000001`"},
    {"\<\"  P-Value\"\>", "0.`"}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> None, "Rows" -> None},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.589204942302164*^9, 3.589204978468814*^9, {3.589205343595798*^9, 
   3.589205361737233*^9}, {3.589205421895628*^9, 3.589205437785314*^9}, 
   3.5892054891832647`*^9, 3.589208119822625*^9, 3.589208394714353*^9, 
   3.589209456976753*^9, 3.5901451306001062`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic Visual \
\[OpenCurlyDoubleQuote]Statistics\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.530372627959633*^9, 3.5303726359771557`*^9}}],

Cell["\<\
Histograms are a fantastic way to get a quick grasp of a large number of \
samples. Below are a select number of histogram, each focusing on a specific \
numeric quality.\
\>", "Text",
 CellChangeTimes->{{3.530372643432928*^9, 3.530372683969884*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"hLabel", "=", "\"\<Sample Values\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vLabel", "=", "\"\<Occurrences\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStnd1", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"sampleSetGood1", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1"}]}], 
     ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStndSmooth1", "=", 
   RowBox[{"SmoothHistogram", "[", 
    RowBox[{"sampleSetGood1", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Smoothed Histogram of Sample Values : \>\"", "<>", 
       "sampleSetName1", "<>", 
       "\"\<\\n(Probability Distribution Function)\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<\>\""}], "}"}]}]}], "]"}]}], ";", 
  RowBox[{"histCC1", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood1", ",", "Automatic", ",", "\"\<CumulativeCount\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1", "<>", 
       "\"\<\\nCumulative Count\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histProb1", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood1", ",", "Automatic", ",", "\"\<Probability\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1", "<>", 
       "\"\<\\nProbability\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<% Occurs\>\""}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"histStndSmallBin1", "=", 
    RowBox[{"Histogram", "[", 
     RowBox[{"sampleSetGood1", ",", 
      RowBox[{"{", "0.250", "}"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", 
       RowBox[{
       "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName1", "<>", 
        "\"\<\\nbin size 0.250\>\""}]}], ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStnd2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"sampleSetGood2", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2"}]}], 
     ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStndSmooth2", "=", 
   RowBox[{"SmoothHistogram", "[", 
    RowBox[{"sampleSetGood2", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Smoothed Histogram of Sample Values : \>\"", "<>", 
       "sampleSetName1", "<>", 
       "\"\<\\n(Probability Distribution Function)\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<\>\""}], "}"}]}]}], "]"}]}], ";", 
  RowBox[{"histCC2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood2", ",", "Automatic", ",", "\"\<CumulativeCount\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2", "<>", 
       "\"\<\\nCumulative Count\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histProb2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{
    "sampleSetGood2", ",", "Automatic", ",", "\"\<Probability\>\"", ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2", "<>", 
       "\"\<\\nProbability\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "\"\<% Occurs\>\""}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"histStndSmallBin2", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"sampleSetGood2", ",", 
     RowBox[{"{", "0.250", "}"}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", 
      RowBox[{
      "\"\<Histogram of Sample Values : \>\"", "<>", "sampleSetName2", "<>", 
       "\"\<\\nnbin size 0.250\>\""}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"hLabel", ",", "vLabel"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\< \>\"", "]"}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.530394715762684*^9, 3.530394723135069*^9}, 
   3.530394760001342*^9, {3.530455400611494*^9, 3.530455412231533*^9}, {
   3.589205017674301*^9, 3.58920510976562*^9}, {3.5892051473945103`*^9, 
   3.589205191596965*^9}, {3.589205236230096*^9, 3.589205287776355*^9}, {
   3.589205496523555*^9, 3.589205515386764*^9}, {3.589205545391057*^9, 
   3.589205577013954*^9}, {3.589205609269073*^9, 3.5892056985591383`*^9}, {
   3.5892057445963907`*^9, 3.5892057486441298`*^9}, {3.589208146714439*^9, 
   3.589208146802874*^9}}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{
  3.5892055784871073`*^9, 3.589205707787979*^9, 3.589205750492517*^9, {
   3.58920812067819*^9, 3.5892081481298227`*^9}, 3.5892083955250607`*^9, 
   3.589209457200342*^9, 3.590145131661278*^9}]
}, Open  ]],

Cell["\<\
Below is a standard histogram, where each sample is shown as a single block \
placed on the vertical axis based on its value. Common sample values (i.e., \
blocks) show as high stacks.\
\>", "Text",
 CellChangeTimes->{3.5303945570998573`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{"histStnd1", "\[IndentingNewLine]", "histStnd2"}], "Input",
 CellChangeTimes->{{3.530369545506777*^9, 3.530369547560232*^9}, {
  3.530369666836165*^9, 3.530369669231763*^9}, {3.5303699085772467`*^9, 
  3.530369930152483*^9}, {3.589205116907014*^9, 3.589205121494775*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6859999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6859999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1064., 0}, {1066., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.5, 139.13265306122776`}, {173.2303070852104, 
         184.9597134749364}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1072., 0}, {1074., 30}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{479.03061224490375`, 
         593.6632653061315}, {-137.92247821684316`, 184.9597134749364}}],
       StatusArea[#, 30]& ,
       TagBoxNote->"30"],
      StyleBox["30", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[30, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{1064., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{675., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\"", TraditionalForm],
  PlotRange->{{1064., 1074.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.5303695488181334`*^9, 3.53036958415487*^9}, {
   3.530369650023057*^9, 3.530369670205143*^9}, 3.53036970302028*^9, 
   3.530369849607541*^9, {3.530369912051992*^9, 3.5303699314038763`*^9}, 
   3.530370440989561*^9, 3.530370970288966*^9, 3.5303711932451*^9, 
   3.530371282079977*^9, 3.530371366848496*^9, 3.530371464003294*^9, 
   3.530371828554619*^9, 3.530372610876151*^9, 3.530393601714321*^9, 
   3.530394130294532*^9, {3.530394496126593*^9, 3.530394522101289*^9}, 
   3.530394586856161*^9, 3.530395208041752*^9, 3.5303963140372553`*^9, 
   3.530455427899746*^9, 3.530455467257689*^9, {3.530469222935663*^9, 
   3.530469237842341*^9}, 3.53046928026694*^9, 3.530469429880677*^9, 
   3.530469559271694*^9, 3.5304702441973963`*^9, 3.536334926609531*^9, 
   3.5363357185955467`*^9, {3.536336625347118*^9, 3.536336650895856*^9}, 
   3.536337023128414*^9, {3.53633709915998*^9, 3.536337117482912*^9}, 
   3.536337288435781*^9, 3.5363375579023848`*^9, 3.536337644670939*^9, 
   3.536339085895953*^9, 3.536339944228245*^9, 3.53634117179491*^9, 
   3.536341227911189*^9, 3.536341446622402*^9, 3.536341961592246*^9, 
   3.53634202430599*^9, 3.5363425511443777`*^9, 3.536342659031567*^9, 
   3.536342825511848*^9, 3.554640053897842*^9, 3.554640184079294*^9, 
   3.589205122801214*^9, 3.589205196948225*^9, 3.589205244525977*^9, 
   3.5892055246585827`*^9, 3.589205580866781*^9, 3.589205712085713*^9, 
   3.589208120825781*^9, 3.5892081544701767`*^9, 3.5892083956646023`*^9, 
   3.58920945722851*^9, 3.590145131798531*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6719999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6719999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1066., 0}, {1068., 2}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.499999999992724`, 139.13265306122048`}, {
         155.96995767565124`, 184.95971347493642`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1068., 0}, {1070., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{138.13265306122048`, 252.76530612244096`}, {
         169.96483557529382`, 184.95971347493642`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1072., 0}, {1074., 23}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{365.3979591836687, 
         480.0306122448965}, {-137.92247821684313`, 184.95971347493642`}}],
       StatusArea[#, 23]& ,
       TagBoxNote->"23"],
      StyleBox["23", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[23, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1074., 0}, {1076., 5}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{479.0306122448965, 593.663265306117}, {
         113.98532397672346`, 184.95971347493642`}}],
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{1066., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{675., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\"", TraditionalForm],
  PlotRange->{{1066., 1076.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.5303695488181334`*^9, 3.53036958415487*^9}, {
   3.530369650023057*^9, 3.530369670205143*^9}, 3.53036970302028*^9, 
   3.530369849607541*^9, {3.530369912051992*^9, 3.5303699314038763`*^9}, 
   3.530370440989561*^9, 3.530370970288966*^9, 3.5303711932451*^9, 
   3.530371282079977*^9, 3.530371366848496*^9, 3.530371464003294*^9, 
   3.530371828554619*^9, 3.530372610876151*^9, 3.530393601714321*^9, 
   3.530394130294532*^9, {3.530394496126593*^9, 3.530394522101289*^9}, 
   3.530394586856161*^9, 3.530395208041752*^9, 3.5303963140372553`*^9, 
   3.530455427899746*^9, 3.530455467257689*^9, {3.530469222935663*^9, 
   3.530469237842341*^9}, 3.53046928026694*^9, 3.530469429880677*^9, 
   3.530469559271694*^9, 3.5304702441973963`*^9, 3.536334926609531*^9, 
   3.5363357185955467`*^9, {3.536336625347118*^9, 3.536336650895856*^9}, 
   3.536337023128414*^9, {3.53633709915998*^9, 3.536337117482912*^9}, 
   3.536337288435781*^9, 3.5363375579023848`*^9, 3.536337644670939*^9, 
   3.536339085895953*^9, 3.536339944228245*^9, 3.53634117179491*^9, 
   3.536341227911189*^9, 3.536341446622402*^9, 3.536341961592246*^9, 
   3.53634202430599*^9, 3.5363425511443777`*^9, 3.536342659031567*^9, 
   3.536342825511848*^9, 3.554640053897842*^9, 3.554640184079294*^9, 
   3.589205122801214*^9, 3.589205196948225*^9, 3.589205244525977*^9, 
   3.5892055246585827`*^9, 3.589205580866781*^9, 3.589205712085713*^9, 
   3.589208120825781*^9, 3.5892081544701767`*^9, 3.5892083956646023`*^9, 
   3.58920945722851*^9, 3.590145131812546*^9}]
}, Open  ]],

Cell["\<\
Below is known as a Cummlative Count histogram. Each vertical bar represents \
the total number of samples values that are less than or equal to the bin.\
\>", "Text",
 CellChangeTimes->{{3.530372768356407*^9, 3.530372776770891*^9}, {
  3.530372809849923*^9, 3.530372896754038*^9}, {3.5303730283352537`*^9, 
  3.530373029808041*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histCC1", "\[IndentingNewLine]", "histCC2"}], "Input",
 CellChangeTimes->{{3.530371170718999*^9, 3.530371171449521*^9}, {
  3.589205719276526*^9, 3.5892057223249407`*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1064., 0}, {1066., 1.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.5, 138.74081632653542`}, {180.37615346196117`, 
         191.72364549743662`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1066., 0}, {1068., 1.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{137.74081632653542`, 251.98163265306357`}, {
         180.37615346196117`, 191.72364549743662`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1068., 0}, {1070., 1.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{250.98163265306357`, 365.2224489795917}, {
         180.37615346196117`, 191.72364549743662`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1070., 0}, {1072., 1.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{364.2224489795917, 478.46326530612714`}, {
         180.37615346196117`, 191.72364549743662`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1072., 0}, {1074., 31.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{477.46326530612714`, 
         591.7040816326553}, {-130.0486076023024, 191.72364549743662`}}],
       StatusArea[#, 31]& ,
       TagBoxNote->"31"],
      StyleBox["31", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[31, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{1064., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{673., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\\nCumulative Count\"", 
    TraditionalForm],
  PlotRange->{{1064., 1074.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.5303711933153677`*^9, 3.5303712821883*^9, 3.530371366930995*^9, 
   3.530371464213008*^9, 3.53037182877146*^9, 3.530372611088093*^9, 
   3.53039360178333*^9, 3.530394130363566*^9, {3.5303944961970673`*^9, 
   3.530394522169527*^9}, 3.530394586925064*^9, 3.5303952091265917`*^9, 
   3.5303963140990887`*^9, 3.530455427951482*^9, 3.5304554672995453`*^9, 
   3.5304692383686666`*^9, 3.530469280898362*^9, 3.5304694301425667`*^9, 
   3.5304695599081917`*^9, 3.530470244824375*^9, 3.53633492673665*^9, 
   3.5363357187274313`*^9, {3.536336625403529*^9, 3.5363366509613256`*^9}, 
   3.536337023178193*^9, {3.5363370992069607`*^9, 3.5363371175516*^9}, 
   3.5363372884879627`*^9, 3.536337557953179*^9, 3.536337644729342*^9, 
   3.5363390859477654`*^9, 3.536339944546894*^9, 3.536341172038474*^9, 
   3.536341227959819*^9, 3.536341446836018*^9, 3.536341961681848*^9, 
   3.53634202440347*^9, 3.536342551265297*^9, 3.536342659084442*^9, 
   3.5363428255720654`*^9, 3.554640053932543*^9, 3.554640184099517*^9, {
   3.589205725069447*^9, 3.589205754459869*^9}, 3.5892081208789263`*^9, 
   3.589208395723403*^9, 3.5892094572820473`*^9, 3.5901451318590517`*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1066., 0}, {1068., 2.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.499999999992724`, 138.74081632652087`}, {
         170.0286614264857, 191.72364549743662`}}],
       StatusArea[#, 2]& ,
       TagBoxNote->"2"],
      StyleBox["2", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1068., 0}, {1070., 3.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{137.74081632652087`, 251.98163265304902`}, {
         159.68116939101026`, 191.72364549743662`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1070., 0}, {1072., 3.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{250.98163265304902`, 365.22244897958444`}, {
         159.68116939101026`, 191.72364549743662`}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1072., 0}, {1074., 26.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{364.22244897958444`, 
         478.4632653061126}, {-78.31114742492514, 191.72364549743662`}}],
       StatusArea[#, 26]& ,
       TagBoxNote->"26"],
      StyleBox["26", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[26, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1074., 0}, {1076., 31.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{477.4632653061126, 
         591.704081632648}, {-130.0486076023024, 191.72364549743662`}}],
       StatusArea[#, 31]& ,
       TagBoxNote->"31"],
      StyleBox["31", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[31, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{1066., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{673., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\\nCumulative Count\"", 
    TraditionalForm],
  PlotRange->{{1066., 1076.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.5303711933153677`*^9, 3.5303712821883*^9, 3.530371366930995*^9, 
   3.530371464213008*^9, 3.53037182877146*^9, 3.530372611088093*^9, 
   3.53039360178333*^9, 3.530394130363566*^9, {3.5303944961970673`*^9, 
   3.530394522169527*^9}, 3.530394586925064*^9, 3.5303952091265917`*^9, 
   3.5303963140990887`*^9, 3.530455427951482*^9, 3.5304554672995453`*^9, 
   3.5304692383686666`*^9, 3.530469280898362*^9, 3.5304694301425667`*^9, 
   3.5304695599081917`*^9, 3.530470244824375*^9, 3.53633492673665*^9, 
   3.5363357187274313`*^9, {3.536336625403529*^9, 3.5363366509613256`*^9}, 
   3.536337023178193*^9, {3.5363370992069607`*^9, 3.5363371175516*^9}, 
   3.5363372884879627`*^9, 3.536337557953179*^9, 3.536337644729342*^9, 
   3.5363390859477654`*^9, 3.536339944546894*^9, 3.536341172038474*^9, 
   3.536341227959819*^9, 3.536341446836018*^9, 3.536341961681848*^9, 
   3.53634202440347*^9, 3.536342551265297*^9, 3.536342659084442*^9, 
   3.5363428255720654`*^9, 3.554640053932543*^9, 3.554640184099517*^9, {
   3.589205725069447*^9, 3.589205754459869*^9}, 3.5892081208789263`*^9, 
   3.589208395723403*^9, 3.5892094572820473`*^9, 3.590145131873192*^9}]
}, Open  ]],

Cell["\<\
Below is a Probability Historgram. It will visually look exactly like the \
standard histogram but the vertical axis is a percentage value. Each vertical \
bar\[CloseCurlyQuote]s height represents the percentage of values that is \
contains. In contrast, the standard histogram hight is the actual number of \
sample occurrences.\
\>", "Text",
 CellChangeTimes->{{3.530372915776453*^9, 3.530373034082033*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histProb1", "\[IndentingNewLine]", "histProb2"}], "Input",
 CellChangeTimes->{{3.530371174905854*^9, 3.5303711849954643`*^9}, {
  3.589205760372879*^9, 3.589205765341523*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1064., 0}, {1066., 0.03225806451612903}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{19., 134.90612244898512`}, {183.12728466461368`, 
         194.97693440181075`}}],
       StatusArea[#, 0.03225806451612903]& ,
       TagBoxNote->"0.03225806451612903"],
      StyleBox["0.03225806451612903`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.03225806451612903, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1066., 0}, {1068., 0.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{133.90612244898512`, 249.81224489796296`}, {
         193.97693440181075`, 194.97693440181075`}}],
       StatusArea[#, 0]& ,
       TagBoxNote->"0"],
      StyleBox["0", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1068., 0}, {1070., 0.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{248.81224489796296`, 364.7183673469408}, {
         193.97693440181075`, 194.97693440181075`}}],
       StatusArea[#, 0]& ,
       TagBoxNote->"0"],
      StyleBox["0", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1070., 0}, {1072., 0.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{363.7183673469408, 479.6244897959259}, {
         193.97693440181075`, 194.97693440181075`}}],
       StatusArea[#, 0]& ,
       TagBoxNote->"0"],
      StyleBox["0", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1072., 0}, {1074., 0.967741935483871}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{478.6244897959259, 
         594.5306122449038}, {-131.51255771410098`, 194.97693440181075`}}],
       StatusArea[#, 0.967741935483871]& ,
       TagBoxNote->"0.967741935483871"],
      StyleBox["0.967741935483871`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.967741935483871, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"% Occurs\"", TraditionalForm]},
  AxesOrigin->{1064., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{676., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\\nProbability\"", TraditionalForm],
  
  PlotRange->{{1064., 1074.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.530371193382887*^9, 3.5303712822723207`*^9, 3.5303713670066147`*^9, 
   3.530371464412394*^9, 3.530371828964902*^9, 3.530372611269655*^9, 
   3.530393601844863*^9, 3.530394130424241*^9, {3.530394496259248*^9, 
   3.530394522230245*^9}, 3.5303945869998837`*^9, 3.5303952095236187`*^9, 
   3.5303963141520576`*^9, 3.5304554280200663`*^9, 3.530455467346095*^9, 
   3.5304692386248913`*^9, 3.5304692812452993`*^9, 3.530469430388815*^9, 
   3.5304695602145157`*^9, 3.530470245274753*^9, 3.536334926797206*^9, 
   3.5363357188421097`*^9, {3.536336625456748*^9, 3.536336651006628*^9}, 
   3.536337023227828*^9, {3.536337099256421*^9, 3.536337117594417*^9}, 
   3.5363372885357227`*^9, 3.5363375580025787`*^9, 3.536337644776417*^9, 
   3.536339085995132*^9, 3.536339944639868*^9, 3.536341172119947*^9, 
   3.5363412280149403`*^9, 3.53634144692865*^9, 3.536341961779797*^9, 
   3.536342024503587*^9, 3.536342551316553*^9, 3.536342659142679*^9, 
   3.536342825633093*^9, 3.554640053985256*^9, 3.554640184118108*^9, 
   3.589205766406526*^9, 3.589208120932848*^9, 3.589208395776359*^9, 
   3.589209457350844*^9, 3.5901451319121437`*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6649999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6649999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1066., 0}, {1068., 0.06451612903225806}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{19.000000000007276`, 134.90612244898512`}, {
         165.67350030477493`, 194.97693440181072`}}],
       StatusArea[#, 0.06451612903225806]& ,
       TagBoxNote->"0.06451612903225806"],
      StyleBox["0.06451612903225806`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.06451612903225806, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1068., 0}, {1070., 0.03225806451612903}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{133.90612244898512`, 249.81224489796296`}, {
         179.82521735329283`, 194.97693440181072`}}],
       StatusArea[#, 0.03225806451612903]& ,
       TagBoxNote->"0.03225806451612903"],
      StyleBox["0.03225806451612903`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.03225806451612903, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1070., 0}, {1072., 0.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{248.81224489796296`, 364.71836734694807`}, {
         193.97693440181072`, 194.97693440181072`}}],
       StatusArea[#, 0]& ,
       TagBoxNote->"0"],
      StyleBox["0", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1072., 0}, {1074., 0.7419354838709677}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{363.71836734694807`, 
         479.6244897959259}, {-131.51255771410095`, 194.97693440181072`}}],
       StatusArea[#, 0.7419354838709677]& ,
       TagBoxNote->"0.7419354838709677"],
      StyleBox["0.7419354838709677`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.7419354838709677, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1074., 0}, {1076., 0.16129032258064516`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{478.6244897959259, 594.5306122449038}, {
         123.21834915922123`, 194.97693440181072`}}],
       StatusArea[#, 0.16129032258064516`]& ,
       TagBoxNote->"0.16129032258064516"],
      StyleBox["0.16129032258064516`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.16129032258064516`, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"% Occurs\"", TraditionalForm]},
  AxesOrigin->{1066., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{676., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\\nProbability\"", 
    TraditionalForm],
  PlotRange->{{1066., 1076.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.530371193382887*^9, 3.5303712822723207`*^9, 3.5303713670066147`*^9, 
   3.530371464412394*^9, 3.530371828964902*^9, 3.530372611269655*^9, 
   3.530393601844863*^9, 3.530394130424241*^9, {3.530394496259248*^9, 
   3.530394522230245*^9}, 3.5303945869998837`*^9, 3.5303952095236187`*^9, 
   3.5303963141520576`*^9, 3.5304554280200663`*^9, 3.530455467346095*^9, 
   3.5304692386248913`*^9, 3.5304692812452993`*^9, 3.530469430388815*^9, 
   3.5304695602145157`*^9, 3.530470245274753*^9, 3.536334926797206*^9, 
   3.5363357188421097`*^9, {3.536336625456748*^9, 3.536336651006628*^9}, 
   3.536337023227828*^9, {3.536337099256421*^9, 3.536337117594417*^9}, 
   3.5363372885357227`*^9, 3.5363375580025787`*^9, 3.536337644776417*^9, 
   3.536339085995132*^9, 3.536339944639868*^9, 3.536341172119947*^9, 
   3.5363412280149403`*^9, 3.53634144692865*^9, 3.536341961779797*^9, 
   3.536342024503587*^9, 3.536342551316553*^9, 3.536342659142679*^9, 
   3.536342825633093*^9, 3.554640053985256*^9, 3.554640184118108*^9, 
   3.589205766406526*^9, 3.589208120932848*^9, 3.589208395776359*^9, 
   3.589209457350844*^9, 3.5901451319295797`*^9}]
}, Open  ]],

Cell["\<\
Below is a Smoothed Histogram. It will have a similar shape to the Standard \
Histogram, but will be mathematically smoothed. Sometimes this is a much more \
pleasent and informative visual, but not always. Remember, it is smoothed so \
it does not consist of the actual values. For example, you may see the line \
go negative, even though there are no negative values. In reality, the plot \
is the probability distribution function (PDF).\
\>", "Text",
 CellChangeTimes->{{3.5303730468070383`*^9, 3.5303731275375233`*^9}, {
  3.530373410538884*^9, 3.530373411173328*^9}, {3.530373965912763*^9, 
  3.5303740112625923`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histStndSmooth1", "\[IndentingNewLine]", "histStndSmooth2"}], \
"Input",
 CellChangeTimes->{{3.530370958778479*^9, 3.5303709615584373`*^9}, {
  3.5892057738165283`*^9, 3.589205778518346*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJx123dcTf8fOPBkk5GRHdnZQtbRiRASMiJlhqwShWSUlpJSaSjR3tq73u2U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      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"\"", TraditionalForm]},
  AxesOrigin->{1066., 0},
  ImageSize->{680., Automatic},
  Method->{},
  PlotLabel->FormBox[
   "\"Smoothed Histogram of Sample Values : Sysstat\\n(Probability \
Distribution Function)\"", TraditionalForm],
  PlotRange->{{1064.9813459365794`, 
   1073.9686540634204`}, {-4.201954079558138*^-16, 2.3992440847192738`}},
  PlotRangeClipping->True,
  PlotRangePadding->Scaled[0.02]]], "Output",
 CellChangeTimes->{
  3.530370970350786*^9, 3.530371193467195*^9, 3.53037128235537*^9, 
   3.5303713670898952`*^9, 3.530371464463482*^9, 3.530371829066883*^9, 
   3.530372611362261*^9, 3.530393601896793*^9, 3.530394130470519*^9, {
   3.5303944963024673`*^9, 3.5303945222734737`*^9}, 3.5303945870415373`*^9, 
   3.5303952095724993`*^9, 3.5303963142156553`*^9, 3.530455428067252*^9, 
   3.530455467394712*^9, 3.530469238698297*^9, 3.530469281286817*^9, 
   3.530469430453369*^9, 3.5304695602937183`*^9, 3.530470245311763*^9, 
   3.536334926838644*^9, 3.536335718919424*^9, {3.536336625505869*^9, 
   3.5363366510603437`*^9}, 3.5363370232800713`*^9, {3.5363370993025703`*^9, 
   3.536337117650896*^9}, 3.536337288587038*^9, 3.536337558052737*^9, 
   3.5363376448261223`*^9, 3.536339086046122*^9, 3.536339944737526*^9, 
   3.536341172213355*^9, 3.536341228061922*^9, 3.536341447016457*^9, 
   3.536341961861414*^9, 3.536342024602624*^9, 3.536342551377861*^9, 
   3.536342659196598*^9, 3.5363428256828203`*^9, 3.5546400540351954`*^9, 
   3.554640184135667*^9, 3.589205779961376*^9, 3.5892081209956627`*^9, 
   3.589208395840897*^9, 3.589209457418434*^9, 3.590145131977593*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxd23VQVV20AHAkbUBJEVRQlFIQENDj3SghIUp3WVggKd1KSCgdIkg3SOel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      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"\"", TraditionalForm]},
  AxesOrigin->{1066., 0},
  ImageSize->{680., Automatic},
  Method->{},
  PlotLabel->FormBox[
   "\"Smoothed Histogram of Sample Values : Sysstat\\n(Probability \
Distribution Function)\"", TraditionalForm],
  PlotRange->{{1065.8015993118138`, 
   1074.8479686881863`}, {-2.398934242751287*^-16, 1.2381240788578707`}},
  PlotRangeClipping->True,
  PlotRangePadding->Scaled[0.02]]], "Output",
 CellChangeTimes->{
  3.530370970350786*^9, 3.530371193467195*^9, 3.53037128235537*^9, 
   3.5303713670898952`*^9, 3.530371464463482*^9, 3.530371829066883*^9, 
   3.530372611362261*^9, 3.530393601896793*^9, 3.530394130470519*^9, {
   3.5303944963024673`*^9, 3.5303945222734737`*^9}, 3.5303945870415373`*^9, 
   3.5303952095724993`*^9, 3.5303963142156553`*^9, 3.530455428067252*^9, 
   3.530455467394712*^9, 3.530469238698297*^9, 3.530469281286817*^9, 
   3.530469430453369*^9, 3.5304695602937183`*^9, 3.530470245311763*^9, 
   3.536334926838644*^9, 3.536335718919424*^9, {3.536336625505869*^9, 
   3.5363366510603437`*^9}, 3.5363370232800713`*^9, {3.5363370993025703`*^9, 
   3.536337117650896*^9}, 3.536337288587038*^9, 3.536337558052737*^9, 
   3.5363376448261223`*^9, 3.536339086046122*^9, 3.536339944737526*^9, 
   3.536341172213355*^9, 3.536341228061922*^9, 3.536341447016457*^9, 
   3.536341961861414*^9, 3.536342024602624*^9, 3.536342551377861*^9, 
   3.536342659196598*^9, 3.5363428256828203`*^9, 3.5546400540351954`*^9, 
   3.554640184135667*^9, 3.589205779961376*^9, 3.5892081209956627`*^9, 
   3.589208395840897*^9, 3.589209457418434*^9, 3.59014513198536*^9}]
}, Open  ]],

Cell["\<\
Below is a standard histogram but with the bin size set to 0.250. This is \
only  useful when the sample values range below 1.0, such as when sampling \
SQL statements (we all hope). Sample sets with large sample values will \
likely not result in a plot.\
\>", "Text",
 CellChangeTimes->{{3.530394064793583*^9, 3.530394112412057*^9}, {
  3.5303946066852083`*^9, 3.530394653134197*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"histStndSmallBin1", "\[IndentingNewLine]", \
"histStndSmallBin2"}], "Input",
 CellChangeTimes->{{3.589205791242793*^9, 3.5892057959677134`*^9}}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.6579999999999999]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.6579999999999999]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1065.25, 0}, {1065.5, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.500000000014552`, 41.9225690276362}, {
         171.2053458801272, 189.779373587437}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1072.5, 0}, {1072.75, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{500.7545018007513, 518.1770708283584}, {
         171.2053458801272, 189.779373587437}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1072.75, 0}, {1073., 3}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{517.1770708283584, 534.5996398559655}, {
         136.05729046550766`, 189.779373587437}}],
       StatusArea[#, 3]& ,
       TagBoxNote->"3"],
      StyleBox["3", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1073., 0}, {1073.25, 18}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{533.5996398559655, 
         551.0222088835726}, {-127.55312514413905`, 189.779373587437}}],
       StatusArea[#, 18]& ,
       TagBoxNote->"18"],
      StyleBox["18", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[18, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1073.25, 0}, {1073.5, 7}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{550.0222088835726, 567.4447779111943}, {
         65.76117963626852, 189.779373587437}}],
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1073.5, 0}, {1073.75, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{566.4447779111943, 583.8673469388013}, {
         171.2053458801272, 189.779373587437}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{1065.25, 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{665., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Sysstat\\nbin size 0.250\"", 
    TraditionalForm],
  PlotRange->{{1065.25, 1073.75}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.530394118277979*^9, 3.530394130657009*^9}, {
   3.5303944964881496`*^9, 3.5303945224641848`*^9}, 3.530394587236465*^9, 
   3.5303952099682217`*^9, 3.530396314270275*^9, 3.530455428139687*^9, 
   3.530455467450446*^9, 3.530469238976469*^9, 3.5304692814840517`*^9, 
   3.5304694306369123`*^9, 3.5304695604920893`*^9, 3.530470245528013*^9, 
   3.536334927030675*^9, 3.536335719117712*^9, {3.536336625672222*^9, 
   3.536336651228236*^9}, 3.536337023459778*^9, {3.536337099443101*^9, 
   3.536337117800517*^9}, 3.536337288758793*^9, 3.536337558225767*^9, 
   3.5363376450286922`*^9, 3.536339086235671*^9, 3.5363399449861813`*^9, 
   3.536341172412774*^9, 3.5363412282310743`*^9, 3.536341447249112*^9, 
   3.5363419620807743`*^9, 3.536342024852913*^9, 3.53634255157006*^9, 
   3.536342659360385*^9, 3.536342825891924*^9, 3.554640054119725*^9, 
   3.554640184196095*^9, 3.589205797030332*^9, 3.589208121045702*^9, 
   3.589208395889303*^9, 3.5892094574720592`*^9, 3.590145132029216*^9}],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.651]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.651]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1066.5, 0}, {1066.75, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{24.500000000014552`, 43.511849901260575`}, {
         162.41833202647211`, 189.77937358743677`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1067.75, 0}, {1068., 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{114.55924950627377`, 133.5710994075198}, {
         162.41833202647211`, 189.77937358743677`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1068., 0}, {1068.25, 1}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{132.5710994075198, 151.58294930878037`}, {
         162.41833202647211`, 189.77937358743677`}}],
       StatusArea[#, 1]& ,
       TagBoxNote->"1"],
      StyleBox["1", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1073.25, 0}, {1073.5, 4}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{510.81994733378815`, 529.8317972350487}, {
         83.33520734357815, 189.77937358743677`}}],
       StatusArea[#, 4]& ,
       TagBoxNote->"4"],
      StyleBox["4", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1073.5, 0}, {1073.75, 7}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{528.8317972350487, 547.8436471362947}, {
         4.252082660684181, 189.77937358743677`}}],
       StatusArea[#, 7]& ,
       TagBoxNote->"7"],
      StyleBox["7", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[7, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1073.75, 0}, {1074., 12}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{546.8436471362947, 
         565.8554970375408}, {-127.5531251441391, 189.77937358743677`}}],
       StatusArea[#, 12]& ,
       TagBoxNote->"12"],
      StyleBox["12", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[12, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1074., 0}, {1074.25, 5}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{564.8554970375408, 583.8673469388013}, {
         56.97416578261348, 189.77937358743677`}}],
       StatusArea[#, 5]& ,
       TagBoxNote->"5"],
      StyleBox["5", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[5, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"Sample Values\"", TraditionalForm], 
    FormBox["\"Occurrences\"", TraditionalForm]},
  AxesOrigin->{1066.5, 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{665., Automatic},
  PlotLabel->FormBox[
   "\"Histogram of Sample Values : Time Model\\nnbin size 0.250\"", 
    TraditionalForm],
  PlotRange->{{1066.5, 1074.25}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.530394118277979*^9, 3.530394130657009*^9}, {
   3.5303944964881496`*^9, 3.5303945224641848`*^9}, 3.530394587236465*^9, 
   3.5303952099682217`*^9, 3.530396314270275*^9, 3.530455428139687*^9, 
   3.530455467450446*^9, 3.530469238976469*^9, 3.5304692814840517`*^9, 
   3.5304694306369123`*^9, 3.5304695604920893`*^9, 3.530470245528013*^9, 
   3.536334927030675*^9, 3.536335719117712*^9, {3.536336625672222*^9, 
   3.536336651228236*^9}, 3.536337023459778*^9, {3.536337099443101*^9, 
   3.536337117800517*^9}, 3.536337288758793*^9, 3.536337558225767*^9, 
   3.5363376450286922`*^9, 3.536339086235671*^9, 3.5363399449861813`*^9, 
   3.536341172412774*^9, 3.5363412282310743`*^9, 3.536341447249112*^9, 
   3.5363419620807743`*^9, 3.536342024852913*^9, 3.53634255157006*^9, 
   3.536342659360385*^9, 3.536342825891924*^9, 3.554640054119725*^9, 
   3.554640184196095*^9, 3.589205797030332*^9, 3.589208121045702*^9, 
   3.589208395889303*^9, 3.5892094574720592`*^9, 3.590145132045596*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Compare the two sample sets", "Subtitle",
 CellChangeTimes->{{3.530372627959633*^9, 3.5303726359771557`*^9}, {
  3.5892058898178453`*^9, 3.589205894346086*^9}}],

Cell[TextData[{
 "Below are the statisitcal tests to compare both numerically and visually \
the two sample sets. A simple t-test can be used IF both sample sets are \
normally distributed. (If their respective p-values are > 0.05 then we\
\[CloseCurlyQuote]ll say they are normally distribugted.) If either sample \
set is not normally distributed we must use a location equivilency test. I\
\[CloseCurlyQuote]ll let ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " pick location test to use.\n\nI also included a straight difference \
calculation, in both value and percentage. Why? Just because there is a \
statistical difference does not mean we will feel or notice the difference. \
Knowing the difference can help us determine if a statistical difference \
makes a truly impactful difference."
}], "Text",
 CellChangeTimes->{{3.530394064793583*^9, 3.530394112412057*^9}, {
  3.5303946066852083`*^9, 3.530394653134197*^9}, {3.5892058985878572`*^9, 
  3.589206031021261*^9}, {3.589207928224084*^9, 3.5892080284688168`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SmoothHistogram", "[", 
  RowBox[{"{", 
   RowBox[{"sampleSetGood1", ",", "sampleSetGood2"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.589206283027914*^9, 3.589206290742743*^9}, {
   3.5892070464497757`*^9, 3.589207111663759*^9}, 3.589207230138959*^9, {
   3.589207339346648*^9, 3.589207420942032*^9}, {3.5892074825892687`*^9, 
   3.589207513143084*^9}, {3.589207569068672*^9, 3.5892075978794193`*^9}, {
   3.5892076624448557`*^9, 3.589207664792069*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJx123dcje//OPBkk5GRHdnZQtatO0JIyIiUGbJKFJJRWkpKpaFEe2vvutop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      "]]}, 
    {RGBColor[0.6, 0.24, 0.4428931686004542], LineBox[CompressedData["
1:eJxd23VQVV20AHAkbUBJEVRQlFIQENDj3SghIUp3WVggKd1KSCgdIkg3SOel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      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{1066., 0},
  ImageSize->{543.328125, Automatic},
  Method->{},
  PlotRange->{{1064.9813459365794`, 
   1074.8479686881863`}, {-4.201954079558138*^-16, 2.3992440847192738`}},
  PlotRangeClipping->True,
  PlotRangePadding->Scaled[0.02]]], "Output",
 CellChangeTimes->{{3.5892070983167477`*^9, 3.589207112714263*^9}, {
   3.589207393627255*^9, 3.589207422348392*^9}, {3.589207507694421*^9, 
   3.5892075139378643`*^9}, 3.589207573266075*^9, 3.589207665970436*^9, 
   3.589208121194585*^9, 3.589208396041711*^9, 3.589209457626957*^9, 
   3.59014513217216*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pValueTT", "=", 
  RowBox[{"TTest", "[", 
   RowBox[{"{", 
    RowBox[{"sampleSetGood1", ",", "sampleSetGood2"}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.58920767306666*^9, 3.589207674119499*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"TTest", "::", "nortst"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"At least one of the p-values in \[NoBreak]\\!\\({0, 0}\\)\
\[NoBreak], resulting from a test for normality, is below \
\[NoBreak]\\!\\(0.025`\\)\[NoBreak]. The tests in \[NoBreak]\\!\\({\\\"T\\\"}\
\\)\[NoBreak] require that the data is normally distributed. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/TTest\\\", ButtonNote -> \
\\\"TTest::nortst\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.589208396122691*^9, 3.58920945770277*^9, 
  3.5901451322498493`*^9}],

Cell[BoxData["0.5372334813007426`"], "Output",
 CellChangeTimes->{3.589207675276827*^9, 3.589208121214479*^9, 
  3.5892083961531897`*^9, 3.589209457724022*^9, 3.590145132273649*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pValueLet", "=", 
  RowBox[{"LocationEquivalenceTest", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sampleSetGood1", ",", "sampleSetGood2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<TestDataTable\>\"", ",", "\"\<AutomaticTest\>\""}], "}"}]}],
    "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   StyleBox[
    TagBox[GridBox[{
       {"\<\"\"\>", "\<\"Statistic\"\>", "\<\"P\[Hyphen]Value\"\>"},
       {"\<\"Kruskal\[Hyphen]Wallis\"\>", "27.801274172019696`", 
        "1.767776207074138`*^-9"}
      },
      AutoDelete->False,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
      GridBoxDividers->{
       "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
        "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
      GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Grid"], "DialogStyle",
    StripOnInput->False], ",", "\<\"KruskalWallis\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.589207678048285*^9, 3.5892081212448597`*^9, 
  3.58920839623752*^9, 3.5892094577537727`*^9, 3.590145132306178*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"medDiff", "=", 
  RowBox[{"Abs", "[", 
   RowBox[{
    RowBox[{"Median", "[", "sampleSetGood1", "]"}], "-", 
    RowBox[{"Median", "[", "sampleSetGood2", "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"medDiff", "/", 
  RowBox[{"Median", "[", "sampleSetGood1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"medDiff", "/", 
  RowBox[{"Median", "[", "sampleSetGood2", "]"}]}]}], "Input",
 CellChangeTimes->{{3.589207684922118*^9, 3.589207752846141*^9}, {
  3.589207796653734*^9, 3.589207801233642*^9}, {3.589207882832284*^9, 
  3.589207891400839*^9}}],

Cell[BoxData["0.6157539999999244`"], "Output",
 CellChangeTimes->{3.589207754213632*^9, 3.58920789234379*^9, 
  3.589208121279024*^9, 3.589208396324522*^9, 3.58920945778125*^9, 
  3.59014513234004*^9}],

Cell[BoxData["0.0005737658174769604`"], "Output",
 CellChangeTimes->{3.589207754213632*^9, 3.58920789234379*^9, 
  3.589208121279024*^9, 3.589208396324522*^9, 3.58920945778125*^9, 
  3.590145132341094*^9}],

Cell[BoxData["0.0005734367990431861`"], "Output",
 CellChangeTimes->{3.589207754213632*^9, 3.58920789234379*^9, 
  3.589208121279024*^9, 3.589208396324522*^9, 3.58920945778125*^9, 
  3.5901451323419323`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{825, 1046},
WindowMargins->{{Automatic, 226}, {Automatic, 15}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, \
2013)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 255, 7, 131, "Title"],
Cell[680, 24, 208, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[913, 33, 98, 1, 22, "Subtitle"],
Cell[1014, 36, 607, 10, 101, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1658, 51, 101, 1, 22, "Subtitle"],
Cell[1762, 54, 504, 8, 83, "Text"],
Cell[2269, 64, 3710, 67, 294, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6016, 136, 114, 1, 22, "Subtitle"],
Cell[6133, 139, 1179, 29, 227, "Text"],
Cell[CellGroupData[{
Cell[7337, 172, 8709, 212, 804, "Input"],
Cell[16049, 386, 675, 13, 24, "Message"],
Cell[16727, 401, 2683, 55, 279, "Output"]
}, Open  ]],
Cell[19425, 459, 124, 2, 29, "Text"],
Cell[CellGroupData[{
Cell[19574, 465, 8855, 214, 804, "Input"],
Cell[28432, 681, 747, 14, 24, "Message"],
Cell[29182, 697, 1712, 41, 279, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[30943, 744, 160, 2, 22, "Subtitle"],
Cell[31106, 748, 260, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[31391, 757, 5560, 143, 634, "Input"],
Cell[36954, 902, 249, 4, 21, "Print"]
}, Open  ]],
Cell[37218, 909, 252, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[37495, 918, 285, 3, 56, "Input"],
Cell[37783, 923, 3709, 85, 425, "Output"],
Cell[41495, 1010, 5016, 125, 425, "Output"]
}, Open  ]],
Cell[46526, 1138, 343, 6, 47, "Text"],
Cell[CellGroupData[{
Cell[46894, 1148, 186, 2, 56, "Input"],
Cell[47083, 1152, 5309, 141, 440, "Output"],
Cell[52395, 1295, 5326, 141, 440, "Output"]
}, Open  ]],
Cell[57736, 1439, 419, 7, 65, "Text"],
Cell[CellGroupData[{
Cell[58180, 1450, 190, 2, 56, "Input"],
Cell[58373, 1454, 5460, 143, 445, "Output"],
Cell[63836, 1599, 5695, 145, 445, "Output"]
}, Open  ]],
Cell[69546, 1747, 634, 10, 83, "Text"],
Cell[CellGroupData[{
Cell[70205, 1761, 206, 3, 56, "Input"],
Cell[70414, 1766, 17894, 298, 452, "Output"],
Cell[88311, 2066, 18971, 316, 452, "Output"]
}, Open  ]],
Cell[107297, 2385, 396, 7, 65, "Text"],
Cell[CellGroupData[{
Cell[107718, 2396, 159, 2, 56, "Input"],
Cell[107880, 2400, 5773, 158, 435, "Output"],
Cell[113656, 2560, 6418, 178, 435, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[120123, 2744, 166, 2, 22, "Subtitle"],
Cell[120292, 2748, 1034, 17, 155, "Text"],
Cell[CellGroupData[{
Cell[121351, 2769, 483, 8, 38, "Input"],
Cell[121837, 2779, 34005, 564, 401, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[155879, 3348, 232, 6, 38, "Input"],
Cell[156114, 3356, 671, 13, 42, "Message"],
Cell[156788, 3371, 181, 2, 38, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[157006, 3378, 303, 8, 56, "Input"],
Cell[157312, 3388, 879, 20, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[158228, 3413, 579, 13, 73, "Input"],
Cell[158810, 3428, 201, 3, 38, "Output"],
Cell[159014, 3433, 205, 3, 38, "Output"],
Cell[159222, 3438, 207, 3, 38, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

